package pps.core.system.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import pps.cloud.framedata.service.CommonDataService;
import pps.cloud.framedata.service.data.common_data.SelectCommonInput;
import pps.cloud.framedata.service.data.common_data.SelectCommonOutput;
import pps.core.common.session.PpsUserSession;
import pps.core.common.utils.NamedServiceProvider;
import pps.core.common.utils.TraceHelper;
import pps.core.system.mapper.*;
import pps.core.system.entity.*;
//import pps.core.system.service.data.message_proc_cnf.*;

import pps.core.system.service.data.message_proc_cnf.*;
import pps.core.system.service.data.message_template_cnf.QueryMessageTemplateCnfViewInput;
import pps.core.system.service.data.message_template_cnf.QueryMessageTemplateCnfViewOutput;
import xstartup.annotation.XService;
import xstartup.data.XSingleResult;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;

import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.*;
import java.util.stream.Collectors;

@XService
public class MessageProcCnfService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult insertProcCnf(XContext context, UpdateMessageProcCnfInput input){

        context.getLogger().info("testmmm1",input);

        MessageProcCnfMapper mapper1 = context.getBean(MessageProcCnfMapper.class);
        MessageProcParamMapper paramMapper = context.getBean(MessageProcParamMapper.class);

        MessageProcCnfEnt entity = new MessageProcCnfEnt();
        XCopyUtils.copyObject(input, entity);

        //组合参数内容
        entity.setInParam( fillParam(input.getAbc().get("in")) );
        entity.setOutParam( fillParam(input.getAbc().get("out")) );

        //主记录的主键
        String id= UUID.randomUUID().toString();

        //数据插入参数表
        insertParam(input.getAbc().get("in"),paramMapper,"in",id);
        insertParam(input.getAbc().get("out"),paramMapper,"out",id);

        //更新主记录
        entity.setId(id);
        Date date = new Date();
        entity.setCreateTime(date);
        mapper1.insert(entity);

        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateProcCnf(XContext context, UpdateMessageProcCnfInput input){

        MessageProcCnfMapper mapper1 = context.getBean(MessageProcCnfMapper.class);
        MessageProcParamMapper paramMapper = context.getBean(MessageProcParamMapper.class);

        MessageProcCnfEnt entity = new MessageProcCnfEnt();
        XCopyUtils.copyObject(input, entity);

        //组合参数内容
        entity.setInParam( fillParam(input.getAbc().get("in")) );
        entity.setOutParam( fillParam(input.getAbc().get("out")) );

        //删除参数表
        Map<String,Object> m = new HashMap<>();
        m.put("proc_id",input.getId());
        paramMapper.deleteByMap(m);

        //数据插入参数表
        insertParam(input.getAbc().get("in"),paramMapper,"in",input.getId());
        insertParam(input.getAbc().get("out"),paramMapper,"out",input.getId());

        //更新主记录
        Date date = new Date();
        entity.setCreateTime(date);
        mapper1.updateById(entity);

        return XServiceResult.OK;
    }

    //插入参数
    private void insertParam(Object paramArray, MessageProcParamMapper mapper,String inout,String procId) {

        List<Map<String,Object>> list = (List<Map<String,Object>>)paramArray;
        for(Integer i=0;i<list.size();i++){

            MessageProcParamEnt ent = new MessageProcParamEnt();
            ent.setParamName( list.get(i).get("paramCode").toString());
            ent.setParamDes( list.get(i).get("paramDes").toString());
            ent.setInOut(inout);
            ent.setProcId(procId);
            ent.setSort(i);
            ent.setId(UUID.randomUUID().toString());
            mapper.insert(ent);
        }
    }

    //参数组合成字符串
    private String fillParam(Object paramArray) {
        String r="";
        List<Map<String,Object>> list = (List<Map<String,Object>>)paramArray;
        for(Integer i=0;i<list.size();i++){
            String code = list.get(i).get("paramCode").toString();
            String des = list.get(i).get("paramDes").toString();

            r = r+"<"+code+">"+des+";";
        }

        return  r;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteProcCnf(XContext context, DeleteMessageProcCnfInput input){
        MessageProcCnfMapper mapper = context.getBean(MessageProcCnfMapper.class);

        MessageProcCnfEnt entity = new MessageProcCnfEnt();
        entity.setId(input.getId());
        mapper.deleteById(entity);


        //删除参数表
        Map<String,Object> m = new HashMap<>();
        m.put("proc_id",input.getId());
        MessageProcParamMapper paramMapper = context.getBean(MessageProcParamMapper.class);
        paramMapper.deleteByMap(m);

        return XServiceResult.OK;
    }
    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteTemplateCnf(XContext context, DeleteMessageProcCnfInput input){
        MessageTemplateCnfMapper mapper = context.getBean(MessageTemplateCnfMapper.class);

        MessageTemplateCnfEnt entity = new MessageTemplateCnfEnt();
        entity.setId(input.getId());
        mapper.deleteById(entity);


        //删除参数表
        Map<String,Object> m = new HashMap<>();
        m.put("template_id",input.getId());
        MessageTemplateProcParamMapper paramMapper = context.getBean(MessageTemplateProcParamMapper.class);
        paramMapper.deleteByMap(m);
        MessageTemplateProcMapper procMapper = context.getBean(MessageTemplateProcMapper.class);
        procMapper.deleteByMap(m);

        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    @XText("新模板加存储过程查参数")
    public XSingleResult<UpdateMessageProcCnfInput> getProcParam(XContext context, UpdateMessageProcCnfInput input){
        MessageProcParamMapper mapper = context.getBean(MessageProcParamMapper.class);
        Map<String,Object> m = new HashMap<>();
        m.put("proc_id",input.getId());
        List<MessageProcParamEnt> list =  mapper.selectByMap(m).stream().sorted(Comparator.comparing(MessageProcParamEnt::getSort)).collect(Collectors.toList());

        input.setResult(list);
        return XSingleResult.success(input);
    }
    @XApiAnonymous
    @XApiPost
    @XText("修改模板中的存储过程的参数和值")
    public XSingleResult<UpdateMessageProcCnfInput> getParamsValue(XContext context, UpdateMessageProcCnfInput input){
        MessageTemplateProcParamMapper mapper = context.getBean(MessageTemplateProcParamMapper.class);

        List<Map<String,Object>> obj = mapper.getParamValue(input.getAbc().get("id").toString());

        input.setResult(obj);
        return XSingleResult.success(input);
    }

    @XApiAnonymous
    @XApiPost
    public XSingleResult<UpdateMessageProcCnfInput> runProc(XContext context, UpdateMessageProcCnfInput input){

        String procId = input.getAbc().get("procId").toString();
        List<Map<String,Object>> inParam = (List<Map<String,Object>> )input.getAbc().get("in");
        String sDate = input.getAbc().get("date").toString();

        List<LinkedHashMap<String,Object>> a = runProcByProcId(context,procId,inParam,sDate);

        UpdateMessageProcCnfInput re = new UpdateMessageProcCnfInput();
        re.setResult(a);

        return XSingleResult.success(re);
    }

    List<LinkedHashMap<String,Object>> runProcByProcId(XContext context,String procId, List<Map<String,Object>> inParam,String sDate){
        MessageProcCnfMapper mapper = context.getBean(MessageProcCnfMapper.class);

        MessageProcCnfEnt ent = mapper.selectById(procId);
        String dataSource = ent.getDataSource();
        String procName = ent.getProcName();
        String params = "";

        for (int i = 0; i < inParam.size(); i++) {
            Map<String,Object> m = inParam.get(i);
            params = params + "'"+(m.get("value")==null?"":m.get("value").toString())+"',";
        }

        params = params.substring(0,params.length()-1);

        params = params.replaceAll("\\$\\{input_date}",sDate);

        List<LinkedHashMap<String,Object>> a = selectCommon(context,dataSource,"select * from "+procName+"("+params+")");

        return a;
    }



    private static List<LinkedHashMap<String, Object>> selectCommon(XContext context, String serviceName, String sql) {
        TraceHelper.appendTraceLog(context, "BeginOfSelectCommon", sql + ", [SERVICENAME]:" + serviceName);
        CommonDataService mapper = NamedServiceProvider.getServiceByName(context, serviceName, CommonDataService.class);
        SelectCommonInput selectCommonInput = new SelectCommonInput();
        selectCommonInput.setCmd(sql);
        //selectCommonInput.setTraceId(dbName);
        SelectCommonOutput result = mapper.selectCommon(context, selectCommonInput).getResult();
        if( result != null ){
//            TraceHelper.appendTraceLogWithSpan(context, "EndOfSelectCommon");
            TraceHelper.appendTraceLogTotalTime(context);
        }else{
            TraceHelper.appendTraceLogWithSpan(context, "EndOfSelectCommon","ERROR,服务调用失败，请检查微服务是否运行正常。"+ ", [SERVICENAME]:" + serviceName);
            TraceHelper.appendTraceLogTotalTime(context);
            throw new RuntimeException("执行SQL错误："+sql);
        }

        return result.getResultList();
    }

    @XApiAnonymous
    @XApiPost
    public XSingleResult<UpdateMessageProcCnfInput> getAllProc(XContext context){
        MessageProcCnfMapper mapper = context.getBean(MessageProcCnfMapper.class);
        QueryWrapper<MessageProcCnfEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().orderByDesc(MessageProcCnfEnt::getCreateTime);
        List<MessageProcCnfEnt> list =  mapper.selectList(queryWrapper);

        List<Map<String,Object>> l=new ArrayList<>();
        for (int i = 0; i < list.size(); i++) {
            MessageProcCnfEnt item = list.get(i);
            Map<String,Object> m = new HashMap<>();
            m.put("Text",item.getProcName()+"("+item.getProcDes()+")");
            m.put("Value",item.getId());
            m.put("ent",item);

            l.add(m);
        }

        UpdateMessageProcCnfInput obj= new UpdateMessageProcCnfInput();
        obj.setResult(l);
        return XSingleResult.success(obj);
    }

    //query-message-template-cnf-view
    @XApiAnonymous
    @XApiPost
    @XText("模板列表")
    public XPageResult<QueryMessageTemplateCnfViewOutput> queryMessageTemplateCnfView(XContext context, QueryMessageTemplateCnfViewInput input){

        PpsUserSession session = context.getSession(PpsUserSession.class);

        MessageTemplateCnfMapper mapper = context.getBean(MessageTemplateCnfMapper.class);
        QueryWrapper<MessageTemplateCnfEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().orderByDesc(MessageTemplateCnfEnt::getCreateTime);
        if   (input.getName()!=null && input.getName()!="")
            queryWrapper.lambda().like(MessageTemplateCnfEnt::getName,input.getName());


        return XMapperHelper.query(mapper, input, queryWrapper, QueryMessageTemplateCnfViewOutput.class);
    }
    @XApiAnonymous
    @XApiPost
    @XText("模板列表")
    public XPageResult<QueryMessageTemplateCnfViewOutput> queryMessageTemplateCnfView2(XContext context, QueryMessageTemplateCnfViewInput input){

        PpsUserSession session = context.getSession(PpsUserSession.class);

        MessageTemplateCnfMapper mapper = context.getBean(MessageTemplateCnfMapper.class);
        QueryWrapper<MessageTemplateCnfEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().orderByDesc(MessageTemplateCnfEnt::getCreateTime);
        if   (input.getName()!=null && input.getName()!="")
            queryWrapper.lambda().like(MessageTemplateCnfEnt::getName,input.getName());

        queryWrapper.lambda().eq(MessageTemplateCnfEnt::getOrgId, session.getOuId());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryMessageTemplateCnfViewOutput.class);
    }

    @XApiAnonymous
    @XApiPost
    @XText("存储过程列表")
    public XPageResult<QueryMessageProcCnfViewOutput> queryMessageProcCnfView(XContext context, QueryMessageProcCnfViewInput input){
        MessageProcCnfMapper mapper = context.getBean(MessageProcCnfMapper.class);
        QueryWrapper<MessageProcCnfEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().orderByDesc(MessageProcCnfEnt::getCreateTime);
        if   (input.getKey()!=null && input.getKey()!="")
            queryWrapper.lambda().like(MessageProcCnfEnt::getProcName,input.getKey()).or().like(MessageProcCnfEnt::getProcDes,input.getKey());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryMessageProcCnfViewOutput.class);
    }




    @XApiAnonymous
    @XApiPost
    @XText("某个模板编辑里用到的 存储过程")
    public XSingleResult<UpdateMessageProcCnfInput> getTemplateProcList(XContext context, UpdateMessageProcCnfInput input){
        String templateId = input.getAbc().get("id").toString();
        Map<String,Object> m = getProcByTemplateID(context, templateId);
        input.setResult(m);
        return XSingleResult.success(input);
    }
    Map<String,Object> getProcByTemplateID(XContext context,String templateId){
        MessageTemplateProcMapper mapper = context.getBean(MessageTemplateProcMapper.class);
        QueryWrapper<MessageTemplateProcEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().orderByAsc(MessageTemplateProcEnt::getSort);
        queryWrapper.lambda().eq(MessageTemplateProcEnt::getTemplateId,templateId);
        List<MessageTemplateProcEnt> ent = mapper.selectList(queryWrapper);
        List<Map<String,Object>> allParam =  mapper.getTemplateUsedProc(templateId);

        Map<String,Object> m = new HashMap<>();
        m.put("proc",ent);
        m.put("allParam",allParam);

        return  m;
    }


    @XApiAnonymous
    @XApiPost
    @XText("保存模板")
    public XSingleResult<UpdateMessageProcCnfInput> insertTemplate(XContext context, UpdateMessageProcCnfInput input){
        savetemplate(context,input,true);

        return XSingleResult.success(input);
    }
    @XApiAnonymous
    @XApiPost
    @XText("更新模板")
    public XSingleResult<UpdateMessageProcCnfInput> updateTemplate(XContext context, UpdateMessageProcCnfInput input){

        savetemplate(context,input,false);
        return XSingleResult.success(input);
    }

    void savetemplate(XContext context,UpdateMessageProcCnfInput input, Boolean isnew){
        Map<String,Object> template= (Map<String,Object>) input.getAbc().get("template");
        MessageTemplateCnfMapper tm=context.getBean(MessageTemplateCnfMapper.class);
        MessageTemplateCnfEnt a = new MessageTemplateCnfEnt();
        if (isnew==false)
           a.setId(template.get("id").toString());
        else {
            String id = UUID.randomUUID().toString();
            input.setResult(id);
            a.setId(id);
        }

        a.setOrgId(template.get("orgId").toString());
        a.setOrgName(template.get("orgName").toString());
        a.setName(template.get("name").toString());
        a.setContent(template.get("content").toString());
        //XCopyUtils.copyObject(template,a);

        if (isnew) {
            tm.insert(a);
            newProc(input, context, a.getId());
        }
        else {
            tm.updateById(a);
            newProc(input,context,a.getId());
            updateProc(input, context, a.getId());
            deleteProc(input, context);
        }
    }

    private void deleteProc(UpdateMessageProcCnfInput input, XContext context) {
        List<Map<String,Object>> np= (List<Map<String,Object>>) input.getAbc().get("deleteProc");
        MessageTemplateProcMapper mp= context.getBean(MessageTemplateProcMapper.class);

        for (int i = 0; i < np.size(); i++) {
            Map<String,Object> a = np.get(i);
            mp.deletesql(a.get("id").toString());
        }
    }

    private void updateProc(UpdateMessageProcCnfInput input, XContext context,String templateId) {
        List<Map<String,Object>> np= (List<Map<String,Object>>) input.getAbc().get("updateProc");
        MessageTemplateProcMapper mp= context.getBean(MessageTemplateProcMapper.class);

        for (int i = 0; i < np.size(); i++) {
            Map<String,Object> a= np.get(i);

            mp.deletesql(a.get("id").toString());

            MessageTemplateProcEnt m = new MessageTemplateProcEnt();
            m.setId(a.get("id").toString());
            m.setParamsDes(a.get("paramsDes").toString());
            m.setProcId(a.get("procId").toString());
            m.setProcName(a.get("procName").toString());
            m.setTemplateId(templateId);
            //m.setSort();
            mp.insert(m);
            isertTPP(a,context,templateId,m.getId());
        }
    }

    private void newProc(UpdateMessageProcCnfInput input, XContext context,String templateId){
        List<Map<String,Object>> np= (List<Map<String,Object>>) input.getAbc().get("newProc");
MessageTemplateProcMapper mp= context.getBean(MessageTemplateProcMapper.class);
        for (int i = 0; i < np.size(); i++) {
            Map<String,Object> a= np.get(i);
            MessageTemplateProcEnt m = new MessageTemplateProcEnt();
            m.setId(a.get("newid").toString());
            m.setParamsDes(a.get("paramsDes").toString());
            m.setProcId(a.get("procId").toString());
            m.setProcName(a.get("procName").toString());
            m.setTemplateId(templateId);
            //m.setSort();
            mp.insert(m);
            isertTPP(a,context,templateId,m.getId());
        }
    }

    private void isertTPP(Map<String, Object> tp, XContext context, String tid, String tpid) {
        MessageTemplateProcParamMapper mp = context.getBean(MessageTemplateProcParamMapper.class);

        List<Map<String,Object>> p= (List<Map<String,Object>>)tp.get("params");
        for (int i = 0; i < p.size(); i++) {
            Map<String,Object> pitem = p.get(i);
            MessageTemplateProcParamEnt ent= new MessageTemplateProcParamEnt();
            ent.setId(UUID.randomUUID().toString());
            ent.setNo(pitem.get("no")==null?null:pitem.get("no").toString());
            ent.setParamValue(pitem.get("param_value")==null?null:pitem.get("param_value").toString());
            ent.setSort(i);
            ent.setTemplateId(tid);
            ent.setTemplateProcId(tpid);
            ent.setParamName(pitem.get("param_name").toString());

            mp.insert(ent);
        }
    }

    @XApiAnonymous
    @XApiPost
    @XText("运行模板")
    public XSingleResult<UpdateMessageProcCnfInput> getMessageContent(XContext context, UpdateMessageProcCnfInput input){

        Map<String,Object> tmp =(Map<String, Object>) input.getAbc().get("template");
        String templateId = tmp.get("id").toString();
        String mtext = tmp.get("content").toString();
        String sDate = input.getAbc().get("date").toString();

        //找proc
        Map<String,Object> p = getProcByTemplateID(context,templateId);
//        m.put("proc",ent);
//        m.put("allParam",allParam);

        List<Map<String,Object>> procs = (List<Map<String, Object>>) p.get("proc");
        List<Map<String,Object>> params = (List<Map<String, Object>>) p.get("allParam");

        Map<String,String> result = new HashMap<>();
        //运行proc
        for (int i = 0; i < procs.size(); i++) {
            MessageTemplateProcEnt proc = (MessageTemplateProcEnt)procs.get(i);
            String procId = proc.getProcId();
            String tpId= proc.getId();
            List<Map<String,Object>> inParam= params.stream()
                    .filter(a->a.get("in_out").toString().equals("in") &&  a.get("tp_id").toString().equals(tpId) )
                    .collect(Collectors.toList());
            inParam.forEach(a->a.put("value",a.get("param_value")));

            List<LinkedHashMap<String,Object>> procResult = runProcByProcId(context,procId,inParam,sDate);

            List<Map<String, Object>> outParam=new ArrayList<>();
            if (procResult.size()==1) {
                outParam = params.stream().
                        filter(a -> a.get("in_out").toString().equals("out")
                                && a.get("tp_id").toString().equals(tpId)).collect(Collectors.toList());
            }

            outParam.stream().forEach(a->{
                String v = procResult.get(0).get(a.get("param_name").toString()).toString();
                result.put(a.get("no").toString(),v);
            });
        }
        //替换

        for(Map.Entry<String,String> item:result.entrySet()){
            mtext=mtext.replaceAll("\\{"+item.getKey()+"}",item.getValue());
        }

        input.setResult(mtext);
        return XSingleResult.success(input);
    }





}
