package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import pps.cloud.base.service.BaseBaseEquipmentPropertyService;
import pps.cloud.base.service.data.BaseEquipmentPropertyView;
import pps.core.base.entity.BaseEquipmentPropertyEnt;
import pps.core.base.mapper.BaseEquipmentPropertyMapper;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XSingleResult;
import xstartup.feature.api.annotation.XApiPost;

@XService
public class BaseBaseEquipmentPropertyServiceImpl implements BaseBaseEquipmentPropertyService {

    @XText("根据设备id和属性英文名称查询设备属性值")
    @XApiPost
    @Override
    public XSingleResult<BaseEquipmentPropertyView> queryBaseEquipmentPropertyView(XContext context, BaseEquipmentPropertyView input){
        BaseEquipmentPropertyMapper mapper = context.getBean(BaseEquipmentPropertyMapper.class);
        QueryWrapper<BaseEquipmentPropertyEnt> queryWrapper = new QueryWrapper();
        queryWrapper.lambda().eq(BaseEquipmentPropertyEnt::getEquipmentId,input.getEquipmentId()).
                eq(BaseEquipmentPropertyEnt::getPropertyNameEn,input.getPropertyNameEn());
        queryWrapper.lambda().last("limit 1");
        BaseEquipmentPropertyEnt Ent = mapper.selectOne(queryWrapper);
        BaseEquipmentPropertyView view = XCopyUtils.copyNewObject(Ent, BaseEquipmentPropertyView.class);
        return XSingleResult.success(view);
    }
}
