package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import pps.cloud.base.service.BaseBaseSegmentService;
import pps.cloud.base.service.data.base_segment.GetBaseSegmentInput;
import pps.cloud.base.service.data.base_segment.GetBaseSegmentOutput;
import pps.cloud.base.service.data.base_segment.BaseSegmentBatchInput;
import pps.core.base.entity.BaseSegmentEnt;
import pps.core.base.entity.BaseSegmentView;
import pps.core.base.mapper.BaseSegmentMapper;
import pps.core.base.mapper.BaseSegmentViewMapper;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XListResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;

import java.util.List;

/**
 * 王甜创建的查询管段方法
 * @author wang1
 */
@XText("管段接口")
@XService
public class BaseBaseSegmentServiceImpl implements BaseBaseSegmentService {
    @Override
    @XText("根据id查询管段")
    public XSingleResult<GetBaseSegmentOutput> getBaseSegmentById(XContext context, GetBaseSegmentInput input) {
        BaseSegmentMapper mapper = context.getBean(BaseSegmentMapper.class);
        QueryWrapper<BaseSegmentEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseSegmentEnt::getId, input.getId());
        BaseSegmentEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBaseSegmentOutput output = new GetBaseSegmentOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    public XListResult<GetBaseSegmentOutput> getBaseSeamentId(XContext context, BaseSegmentBatchInput input) {
        BaseSegmentViewMapper bean = context.getBean(BaseSegmentViewMapper.class);
        List<BaseSegmentView> list = bean.queryBaseSegmentByPipelineId(input);
        List<GetBaseSegmentOutput> outputs = XCopyUtils.copyNewList(list, GetBaseSegmentOutput.class);
        return XListResult.success(outputs);
    }

}
