package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import pps.cloud.base.service.BaseBaseSmallMeteringFixCoefficientService;
import pps.cloud.base.service.data.QueryBaseSmallMeteringFixCoefficientInput;
import pps.cloud.base.service.data.QueryBaseSmallMeteringFixCoefficientOutput;
import pps.core.base.entity.BaseSmallMeteringFixCoefficientEnt;
import pps.core.base.mapper.BaseSmallMeteringFixCoefficientMapper;
import pps.core.common.utils.BigDecimalUtil;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.data.XSingleResult;

import java.math.BigDecimal;
import java.util.List;

@XService
public class BaseBaseSmallMeteringFixCoefficientServiceImpl implements BaseBaseSmallMeteringFixCoefficientService {

    @Override
    public XSingleResult<QueryBaseSmallMeteringFixCoefficientOutput> getBaseSmallMeteringFixValue(XContext context, QueryBaseSmallMeteringFixCoefficientInput input) {
        String meterId = input.getMeterId();
        BigDecimal val = input.getMeasureValue();
        BaseSmallMeteringFixCoefficientMapper mapper = context.getBean(BaseSmallMeteringFixCoefficientMapper.class);
        QueryWrapper<BaseSmallMeteringFixCoefficientEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseSmallMeteringFixCoefficientEnt::getMeterId,meterId)
                .eq(BaseSmallMeteringFixCoefficientEnt::getMeasureValue,val);
        List<BaseSmallMeteringFixCoefficientEnt> list = mapper.selectList(queryWrapper);
        BigDecimal vc = new BigDecimal("0");
        if(ObjectUtils.isNotEmpty(list)){
            BigDecimal fixValue = list.get(0).getFixValue();
            if(fixValue != null){
                vc = fixValue;
            }
        }else{
            //查询小于输入值
            QueryWrapper<BaseSmallMeteringFixCoefficientEnt> querylt = new QueryWrapper<>();
            querylt.lambda().eq(BaseSmallMeteringFixCoefficientEnt::getMeterId,meterId)
                    .lt(BaseSmallMeteringFixCoefficientEnt::getMeasureValue,val).orderByDesc(BaseSmallMeteringFixCoefficientEnt::getMeasureValue);
            List<BaseSmallMeteringFixCoefficientEnt> listlt = mapper.selectList(querylt);
            //查询大于输入值
            QueryWrapper<BaseSmallMeteringFixCoefficientEnt> querygt = new QueryWrapper<>();
            querygt.lambda().eq(BaseSmallMeteringFixCoefficientEnt::getMeterId,meterId)
                    .gt(BaseSmallMeteringFixCoefficientEnt::getMeasureValue,val).orderByAsc(BaseSmallMeteringFixCoefficientEnt::getMeasureValue);
            List<BaseSmallMeteringFixCoefficientEnt> listgt = mapper.selectList(querygt);
            //（2）如油高匹配则直接取值对应容积
            //（3）如油高不匹配，则根据x1、x2查表获得对应的容积y1、y2，并利用内插法计算容积膨胀值，计算公式为：△Vc=y1+(x-x1)*(y2-y1)/(x2-x1)
            BaseSmallMeteringFixCoefficientEnt leView = null;
            BaseSmallMeteringFixCoefficientEnt gtView = null;
            if(ObjectUtils.isNotEmpty(listlt)){
                leView = listlt.get(0);
            }
            if(ObjectUtils.isNotEmpty(listgt)){
                gtView = listgt.get(0);
            }
            if(ObjectUtils.isNotEmpty(leView) && ObjectUtils.isNotEmpty(gtView) && ObjectUtils.isNotEmpty(leView.getFixValue())
                    && ObjectUtils.isNotEmpty(gtView.getFixValue())&& ObjectUtils.isNotEmpty(leView.getMeasureValue())&& ObjectUtils.isNotEmpty(gtView.getMeasureValue())
                    && ObjectUtils.isNotEmpty(val)){
                //(x-x1)
                BigDecimal height = val.subtract(BigDecimalUtil.parseNull2Zero(leView.getMeasureValue()));
                //(x2-x1)
                BigDecimal cheight = BigDecimalUtil.parseNull2Zero(gtView.getMeasureValue()).subtract(BigDecimalUtil.parseNull2Zero(leView.getMeasureValue()));
                //(y2-y1)
                BigDecimal cubage = BigDecimalUtil.parseNull2Zero(gtView.getFixValue()).subtract(BigDecimalUtil.parseNull2Zero(leView.getFixValue()));
                //(x-x1)*(y2-y1)
                BigDecimal total = height.multiply(cubage);
                //(x-x1)*(y2-y1)/(x2-x1)
                BigDecimal divide = total.divide(cheight , 6, BigDecimal.ROUND_HALF_UP);
                vc = BigDecimalUtil.parseNull2Zero(leView.getFixValue()).add(divide).divide(new BigDecimal(1000));
            }
        }
        QueryBaseSmallMeteringFixCoefficientOutput out = new QueryBaseSmallMeteringFixCoefficientOutput();
        out.setFixValue(BigDecimalUtil.parseNull2Zero(vc));
        return XSingleResult.success(out);
    }

    public XSingleResult<QueryBaseSmallMeteringFixCoefficientOutput> getBaseSmallMeteringFixValueNew(XContext context, QueryBaseSmallMeteringFixCoefficientInput input) {
        String meterId = input.getMeterId();
        BigDecimal val = input.getMeasureValue();
        BaseSmallMeteringFixCoefficientMapper mapper = context.getBean(BaseSmallMeteringFixCoefficientMapper.class);
        QueryWrapper<BaseSmallMeteringFixCoefficientEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseSmallMeteringFixCoefficientEnt::getMeterId,meterId)
                .eq(BaseSmallMeteringFixCoefficientEnt::getMeasureValue,val);
        List<BaseSmallMeteringFixCoefficientEnt> list = mapper.selectList(queryWrapper);
        BigDecimal vc = new BigDecimal("0");
        if(ObjectUtils.isNotEmpty(list)){
            BigDecimal fixValue = list.get(0).getFixValue();
            if(fixValue != null){
                //取到后，需要除以1000，用于后面计算
                vc = fixValue.divide(new BigDecimal(1000));
            }
        }else{
            //查询小于输入值
            QueryWrapper<BaseSmallMeteringFixCoefficientEnt> querylt = new QueryWrapper<>();
            querylt.lambda().eq(BaseSmallMeteringFixCoefficientEnt::getMeterId,meterId)
                    .lt(BaseSmallMeteringFixCoefficientEnt::getMeasureValue,val).orderByDesc(BaseSmallMeteringFixCoefficientEnt::getMeasureValue);
            List<BaseSmallMeteringFixCoefficientEnt> listlt = mapper.selectList(querylt);
            //查询大于输入值
            QueryWrapper<BaseSmallMeteringFixCoefficientEnt> querygt = new QueryWrapper<>();
            querygt.lambda().eq(BaseSmallMeteringFixCoefficientEnt::getMeterId,meterId)
                    .gt(BaseSmallMeteringFixCoefficientEnt::getMeasureValue,val).orderByAsc(BaseSmallMeteringFixCoefficientEnt::getMeasureValue);
            List<BaseSmallMeteringFixCoefficientEnt> listgt = mapper.selectList(querygt);
            //（2）如油高匹配则直接取值对应容积
            //（3）如油高不匹配，则根据x1、x2查表获得对应的容积y1、y2，并利用内插法计算容积膨胀值，计算公式为：△Vc=y1+(x-x1)*(y2-y1)/(x2-x1)
            BaseSmallMeteringFixCoefficientEnt leView = null;
            BaseSmallMeteringFixCoefficientEnt gtView = null;
            if(ObjectUtils.isNotEmpty(listlt)){
                leView = listlt.get(0);
            }
            if(ObjectUtils.isNotEmpty(listgt)){
                gtView = listgt.get(0);
            }
            if(ObjectUtils.isNotEmpty(leView) && ObjectUtils.isNotEmpty(gtView) && ObjectUtils.isNotEmpty(leView.getFixValue())
                    && ObjectUtils.isNotEmpty(gtView.getFixValue())&& ObjectUtils.isNotEmpty(leView.getMeasureValue())&& ObjectUtils.isNotEmpty(gtView.getMeasureValue())
                    && ObjectUtils.isNotEmpty(val)){
                //(x-x1)
                BigDecimal height = val.subtract(BigDecimalUtil.parseNull2Zero(leView.getMeasureValue()));
                //(x2-x1)
                BigDecimal cheight = BigDecimalUtil.parseNull2Zero(gtView.getMeasureValue()).subtract(BigDecimalUtil.parseNull2Zero(leView.getMeasureValue()));
                //(y2-y1)
                BigDecimal cubage = BigDecimalUtil.parseNull2Zero(gtView.getFixValue()).subtract(BigDecimalUtil.parseNull2Zero(leView.getFixValue()));
                //(x-x1)*(y2-y1)
                BigDecimal total = height.multiply(cubage);
                //(x-x1)*(y2-y1)/(x2-x1)
                BigDecimal divide = total.divide(cheight , 6, BigDecimal.ROUND_HALF_UP);
                vc = BigDecimalUtil.parseNull2Zero(leView.getFixValue()).add(divide).divide(new BigDecimal(1000));
            }
        }
        QueryBaseSmallMeteringFixCoefficientOutput out = new QueryBaseSmallMeteringFixCoefficientOutput();
        out.setFixValue(BigDecimalUtil.parseNull2Zero(vc));
        return XSingleResult.success(out);
    }
}
