package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.base_client_property.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class BaseClientPropertyService {
    @XApiPost
    public XServiceResult createBaseClientProperty(XContext context, CreateBaseClientPropertyInput input){
        BaseClientPropertyMapper mapper = context.getBean(BaseClientPropertyMapper.class);
        BaseClientPropertyEnt entity = new BaseClientPropertyEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiPost
    public XServiceResult updateBaseClientProperty(XContext context, UpdateBaseClientPropertyInput input){
        BaseClientPropertyMapper mapper = context.getBean(BaseClientPropertyMapper.class);
        QueryWrapper<BaseClientPropertyEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseClientPropertyEnt::getId, input.getId());
        BaseClientPropertyEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiPost
    public XServiceResult deleteBaseClientProperty(XContext context, DeleteBaseClientPropertyInput input){
        BaseClientPropertyMapper mapper = context.getBean(BaseClientPropertyMapper.class);
        QueryWrapper<BaseClientPropertyEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseClientPropertyEnt::getId, input.getId());
        BaseClientPropertyEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiGet
    public XSingleResult<GetBaseClientPropertyOutput> getBaseClientProperty(XContext context, GetBaseClientPropertyInput input){
        BaseClientPropertyMapper mapper = context.getBean(BaseClientPropertyMapper.class);
        QueryWrapper<BaseClientPropertyEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseClientPropertyEnt::getId, input.getId());
        BaseClientPropertyEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBaseClientPropertyOutput output = new GetBaseClientPropertyOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiGet
    public XPageResult<QueryBaseClientPropertyOutput> queryBaseClientProperty(XContext context, QueryBaseClientPropertyInput input){
        BaseClientPropertyMapper mapper = context.getBean(BaseClientPropertyMapper.class);
        QueryWrapper<BaseClientPropertyEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(BaseClientPropertyEnt::getId, input.getId())
            .like(BaseClientPropertyEnt::getClientId, input.getClientId())
            .like(BaseClientPropertyEnt::getPropertyId, input.getPropertyId())
            .eq(BaseClientPropertyEnt::getPropertyValue, input.getPropertyValue())
            .eq(BaseClientPropertyEnt::getEffectTime, input.getEffectTime())
            .eq(BaseClientPropertyEnt::getEndTime, input.getEndTime())
            .like(BaseClientPropertyEnt::getCreateById, input.getCreateById())
            .like(BaseClientPropertyEnt::getCreateByName, input.getCreateByName())
            .eq(BaseClientPropertyEnt::getCreateTime, input.getCreateTime())
            .like(BaseClientPropertyEnt::getModifyById, input.getModifyById())
            .like(BaseClientPropertyEnt::getModifyByName, input.getModifyByName())
            .eq(BaseClientPropertyEnt::getModifyTime, input.getModifyTime());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryBaseClientPropertyOutput.class);
    }

    @XApiGet
    public XPageResult<QueryBaseClientPropertyOutput> dynamicQueryBaseClientProperty(XContext context, CustomQueryInput input){
        BaseClientPropertyMapper mapper = context.getBean(BaseClientPropertyMapper.class);
        return XMapperHelper.query(mapper, input, BaseClientPropertyEnt.class, QueryBaseClientPropertyOutput.class);
    }

    @XApiGet
    public XSingleResult<GetBaseClientPropertyViewOutput> getBaseClientPropertyView(XContext context, GetBaseClientPropertyViewInput input){
        BaseClientPropertyViewMapper mapper = context.getBean(BaseClientPropertyViewMapper.class);
        BaseClientPropertyView record = new BaseClientPropertyView();
        XCopyUtils.copyObject(input, record);
        BaseClientPropertyView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBaseClientPropertyViewOutput output = new GetBaseClientPropertyViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiGet
    public XPageResult<QueryBaseClientPropertyViewOutput> queryBaseClientPropertyView(XContext context, QueryBaseClientPropertyViewInput input){
        BaseClientPropertyViewMapper mapper = context.getBean(BaseClientPropertyViewMapper.class);
        BaseClientPropertyView record = new BaseClientPropertyView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<BaseClientPropertyView> list = mapper.selectList(record);
        PageInfo<BaseClientPropertyView> pageInfo = new PageInfo<>(list);
        List<QueryBaseClientPropertyViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryBaseClientPropertyViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
