package pps.core.base.service;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.base_client_station_rel.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import pps.core.common.session.PpsUserSession;
import xstartup.annotation.XService;
import xstartup.base.util.XDateUtils;
import xstartup.base.util.XStringUtils;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import xstartup.feature.mybatis.helper.XMapperHelper;
import xstartup.helper.XTransactionHelper;

import java.util.List;
import java.util.UUID;

@XText("上游or下游关系")
@XService
public class BaseClientStationRelService {
    @XApiPost
    @XText("创建下游关系")
    public XServiceResult createBaseClientStationRelDown(XContext context, CreateBaseClientStationRelInput input){
        return XTransactionHelper.begin(context,()-> {
            Date endTime = new Date();
            try {
                endTime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").parse("9999-12-31 00:00:00");
            } catch (ParseException e) {
                e.printStackTrace();
            }
            BaseClientStationRelMapper mapper = context.getBean(BaseClientStationRelMapper.class);
            BaseSegmentMapper segmentMapper = context.getBean(BaseSegmentMapper.class);
            BaseStationMapper stationMapper = context.getBean(BaseStationMapper.class);
            BaseClientMapper clientMapper = context.getBean(BaseClientMapper.class);
            BasePipelineSegmentRelViewMapper pipelineSegmentRelMapper = context.getBean(BasePipelineSegmentRelViewMapper.class);
            BasePipelineSegmentRelMapper pipelineSegmentMapper = context.getBean(BasePipelineSegmentRelMapper.class);
            BaseClientStationRelEnt entity = new BaseClientStationRelEnt();
            input.setId(UUID.randomUUID().toString());
            XCopyUtils.copyObject(input, entity);
            entity.setType(1);
            QueryWrapper<BaseClientStationRelEnt> query = new QueryWrapper<>();
            query.lambda().eq(BaseClientStationRelEnt::getPipelineId,input.getPipelineId())
                    .eq(BaseClientStationRelEnt::getClientId,input.getClientId())
                    .eq(BaseClientStationRelEnt::getConsignor,input.getConsignor())
                    .eq(BaseClientStationRelEnt::getStationId,input.getStationId())
                    .gt(BaseClientStationRelEnt::getEndTime,new Date());
            List<BaseClientStationRelEnt> baseClientStationRelEnts = mapper.selectList(query);
            if(ObjectUtils.isNotEmpty(baseClientStationRelEnts)){
                return XServiceResult.error(200,"关系已存在！");
            }
            //生成管段信息
            //自动生成管段base_segment
            QueryWrapper<BaseStationEnt> queryStation = new QueryWrapper<>();
            QueryWrapper<BaseClientEnt> queryClient = new QueryWrapper<>();
            queryStation.lambda().eq(BaseStationEnt::getId, input.getStationId());
            queryClient.lambda().eq(BaseClientEnt::getId, input.getClientId());
            BaseStationEnt baseStationEnt = stationMapper.selectOne(queryStation);
            BaseClientEnt baseClientEnt = clientMapper.selectOne(queryClient);
            String segmentId = UUID.randomUUID().toString();
            BaseSegmentEnt baseSegmentEnt = new BaseSegmentEnt();
            baseSegmentEnt.setStartStationId(input.getStationId());
            baseSegmentEnt.setEndStationId(input.getClientId());
            baseSegmentEnt.setSegmentName(baseStationEnt.getStationName() + "-" + baseClientEnt.getClientName());
            baseSegmentEnt.setId(segmentId);
            baseSegmentEnt.setEffectTime(new Date());
            baseSegmentEnt.setEndTime(endTime);
            baseSegmentEnt.setCapacity(input.getCapacity());
            baseSegmentEnt.setSegmentLength(input.getSegmentLength());
            baseSegmentEnt.setSegmentRadius(input.getSegmentRadius());
            baseSegmentEnt.setThickness(input.getThickness());
            baseSegmentEnt.setStartStationType("STATION");
            baseSegmentEnt.setEndStationType("DOWN_USER");
            baseSegmentEnt.setBeTraderType(1);
            //baseSegmentEnt.setCreateById(context.getSession(PpsUserSession.class).getId());
            baseSegmentEnt.setCreateByName(context.getUser().getName());
            baseSegmentEnt.setCreateTime(new Date());
            BasePipelineSegmentRelView station = new BasePipelineSegmentRelView();
            station.setPipelineId(input.getPipelineId());
            station.setEndTime(new Date());
            segmentMapper.insert(baseSegmentEnt);
            //下载关系设置管段id
            entity.setSegmentId(segmentId);
            mapper.insert(entity);
            //生成管线和管段关联信息
            //新增管线管段关联表
            //sort赋值
            BasePipelineSegmentRelView stationRelView = pipelineSegmentRelMapper.selectMaxSortByPipelineId(station);
            BigDecimal sortOrder = new BigDecimal("0");
            if (stationRelView != null && stationRelView.getSort() != null) {
                sortOrder = sortOrder.add(new BigDecimal(stationRelView.getSort() + "").add(new BigDecimal("1")));
            }
            BasePipelineSegmentRelEnt opsPipelineSegmentRelEnt = new BasePipelineSegmentRelEnt();
            opsPipelineSegmentRelEnt.setPipelineId(input.getPipelineId());
            opsPipelineSegmentRelEnt.setSegmentId(segmentId);
            opsPipelineSegmentRelEnt.setId(UUID.randomUUID().toString());
            opsPipelineSegmentRelEnt.setEffectTime(new Date());
            opsPipelineSegmentRelEnt.setEndTime(endTime);
            //opsPipelineSegmentRelEnt.setCreateById(context.getSession(PpsUserSession.class).getId());
            opsPipelineSegmentRelEnt.setCreateByName(context.getUser().getName());
            opsPipelineSegmentRelEnt.setCreateTime(new Date());
            opsPipelineSegmentRelEnt.setSort(sortOrder);
            pipelineSegmentMapper.insert(opsPipelineSegmentRelEnt);
            //生成管段转供信息
            return XServiceResult.OK;
        });
    }

    @XApiPost
    @XText("创建上游关系")
    public XServiceResult createBaseClientStationRelUp(XContext context, CreateBaseClientStationRelInput input){
        return XTransactionHelper.begin(context,()-> {
            Date endTime = new Date();
            try {
                endTime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").parse("9999-12-31 00:00:00");
            } catch (ParseException e) {
                e.printStackTrace();
            }
            BaseClientStationRelMapper mapper = context.getBean(BaseClientStationRelMapper.class);
            BaseStationMapper stationMapper = context.getBean(BaseStationMapper.class);
            BaseClientMapper clientMapper = context.getBean(BaseClientMapper.class);
            PpsUserSession session = context.getSession(PpsUserSession.class);
            BaseSegmentMapper segmentMapper = context.getBean(BaseSegmentMapper.class);
            BasePipelineSegmentRelViewMapper pipelineSegmentRelMapper = context.getBean(BasePipelineSegmentRelViewMapper.class);
            BasePipelineSegmentRelMapper pipelineSegmentMapper = context.getBean(BasePipelineSegmentRelMapper.class);

            QueryWrapper<BaseClientStationRelEnt> query = new QueryWrapper<>();
            query.lambda().eq(BaseClientStationRelEnt::getPipelineId,input.getPipelineId())
                    .eq(BaseClientStationRelEnt::getClientId,input.getClientId())
                    .eq(BaseClientStationRelEnt::getConsignor,input.getConsignor())
                    .eq(BaseClientStationRelEnt::getStationId,input.getStationId()).gt(BaseClientStationRelEnt::getEndTime,new Date());
            List<BaseClientStationRelEnt> baseClientStationRelEnts = mapper.selectList(query);
            if(ObjectUtils.isNotEmpty(baseClientStationRelEnts)){
                return XServiceResult.error(200,"关系已存在！");
            }
            BaseClientStationRelEnt entity = new BaseClientStationRelEnt();
        /*if(StringUtils.isBlank(input.getCreateById())){
            PpsUserSession session = context.getSession(PpsUserSession.class);
            Date date = new Date();
            input.setModifyTime(date);
            input.setModifyByName(session.getUserName());
            input.setModifyById(session.getId()+"");
            input.setCreateTime(date);
            input.setCreateByName(session.getUserName());
            input.setCreateById(session.getId()+"");
        }*/
            input.setId(UUID.randomUUID().toString());
            XCopyUtils.copyObject(input, entity);
            entity.setCreateTime(new Date());
            entity.setCreateByName(session.getLoginName());
            entity.setCreateById(session.getId());
            entity.setType(0);
            QueryWrapper<BaseStationEnt> queryStation = new QueryWrapper<>();
            QueryWrapper<BaseClientEnt> queryClient = new QueryWrapper<>();
            queryStation.lambda().eq(BaseStationEnt::getId, input.getStationId());
            queryClient.lambda().eq(BaseClientEnt::getId, input.getClientId());
            BaseStationEnt baseStationEnt = stationMapper.selectOne(queryStation);
            BaseClientEnt baseClientEnt = clientMapper.selectOne(queryClient);
            //生成管段信息
            //自动生成管段base_segment
            String segmentId = UUID.randomUUID().toString();
            BaseSegmentEnt baseSegmentEnt = new BaseSegmentEnt();
            baseSegmentEnt.setStartStationId(input.getClientId());
            baseSegmentEnt.setEndStationId(input.getStationId());
            baseSegmentEnt.setSegmentName(baseClientEnt.getClientName() + "-" + baseStationEnt.getStationName());
            baseSegmentEnt.setId(segmentId);
            baseSegmentEnt.setEffectTime(new Date());
            baseSegmentEnt.setEndTime(endTime);
            baseSegmentEnt.setSegmentLength(input.getSegmentLength());
            baseSegmentEnt.setSegmentRadius(input.getSegmentRadius());
            baseSegmentEnt.setThickness(input.getThickness());
            baseSegmentEnt.setCapacity(input.getCapacity());
            baseSegmentEnt.setStartStationType("UP_USER");
            baseSegmentEnt.setEndStationType("STATION");
            baseSegmentEnt.setBeTraderType(1);
            baseSegmentEnt.setCreateById(context.getSession(PpsUserSession.class).getId());
            baseSegmentEnt.setCreateByName(session.getLoginName());
            baseSegmentEnt.setCreateTime(new Date());
            BasePipelineSegmentRelView station = new BasePipelineSegmentRelView();
            station.setPipelineId(input.getPipelineId());
            station.setEndTime(new Date());
            segmentMapper.insert(baseSegmentEnt);
            //上载关系设置管段id
            entity.setSegmentId(segmentId);
            mapper.insert(entity);
            //生成管线和管段关联信息
            //新增管线管段关联表
            //sort赋值
            BasePipelineSegmentRelView stationRelView = pipelineSegmentRelMapper.selectMaxSortByPipelineId(station);
            BigDecimal sortOrder = new BigDecimal("0");
            if (stationRelView != null && stationRelView.getSort() != null) {
                sortOrder = sortOrder.add(new BigDecimal(stationRelView.getSort() + "").add(new BigDecimal("1")));
            }
            BasePipelineSegmentRelEnt opsPipelineSegmentRelEnt = new BasePipelineSegmentRelEnt();
            opsPipelineSegmentRelEnt.setPipelineId(input.getPipelineId());
            opsPipelineSegmentRelEnt.setSegmentId(segmentId);
            opsPipelineSegmentRelEnt.setId(UUID.randomUUID().toString());
            opsPipelineSegmentRelEnt.setEffectTime(new Date());
            opsPipelineSegmentRelEnt.setEndTime(endTime);
            opsPipelineSegmentRelEnt.setCreateById(context.getSession(PpsUserSession.class).getId());
            opsPipelineSegmentRelEnt.setCreateByName(session.getLoginName());
            opsPipelineSegmentRelEnt.setCreateTime(new Date());
            opsPipelineSegmentRelEnt.setSort(sortOrder);
            pipelineSegmentMapper.insert(opsPipelineSegmentRelEnt);
            //生成管段转供信息
            return XServiceResult.OK;
        });
    }

    @XApiPost
    @XText("修改上下游关系")
    public XServiceResult updateBaseClientStationRel(XContext context, UpdateBaseClientStationRelInput input){
        return XTransactionHelper.begin(context,()-> {
            BaseClientStationRelMapper mapper = context.getBean(BaseClientStationRelMapper.class);
            BaseSegmentMapper segmentMapper = context.getBean(BaseSegmentMapper.class);
            PpsUserSession session = context.getSession(PpsUserSession.class);
            QueryWrapper<BaseClientStationRelEnt> query = new QueryWrapper<>();
            query.lambda().eq(BaseClientStationRelEnt::getPipelineId,input.getPipelineId())
                    .eq(BaseClientStationRelEnt::getClientId,input.getClientId())
                    .eq(BaseClientStationRelEnt::getConsignor,input.getConsignor())
                    .eq(BaseClientStationRelEnt::getStationId,input.getStationId()).gt(BaseClientStationRelEnt::getEndTime,new Date());
            List<BaseClientStationRelEnt> baseClientStationRelEnts = mapper.selectList(query);
            QueryWrapper<BaseClientStationRelEnt> queryWrapper = new QueryWrapper<>();
            queryWrapper.lambda().eq(BaseClientStationRelEnt::getId, input.getId());
            BaseClientStationRelEnt entity = mapper.selectOne(queryWrapper);
            //查重
            if(ObjectUtils.isNotEmpty(baseClientStationRelEnts)){
                BaseClientStationRelEnt baseEnt = baseClientStationRelEnts.get(0);
                if(ObjectUtils.isNotEmpty(baseEnt) && !StringUtils.equals(input.getId(),baseEnt.getId())){
                    return XServiceResult.error(200,"关系已存在！");
                }
            }
            XCopyUtils.copyObject(input, entity);
            entity.setModifyById(session.getId());
            entity.setModifyByName(session.getLoginName());
            entity.setModifyTime(new Date());
            mapper.updateById(entity);
            if(StringUtils.isNotBlank(entity.getSegmentId())){
                QueryWrapper<BaseSegmentEnt> querySegment = new QueryWrapper<>();
                querySegment.lambda().eq(BaseSegmentEnt::getId,entity.getSegmentId());
                BaseSegmentEnt baseSegmentEnt = segmentMapper.selectOne(querySegment);
                if(ObjectUtils.isNotEmpty(querySegment)){
                    baseSegmentEnt.setSegmentName(input.getSegmentName());
                    segmentMapper.updateById(baseSegmentEnt);
                }
            }
            return XServiceResult.OK;
        });
    }

    @XApiPost
    @XText("删除上下游关系")
    public XServiceResult deleteBaseClientStationRel(XContext context, DeleteBaseClientStationRelInput input){
        return XTransactionHelper.begin(context,()-> {
            BaseClientStationRelMapper mapper = context.getBean(BaseClientStationRelMapper.class);
            BaseSegmentViewMapper segmentViewMapper = context.getBean(BaseSegmentViewMapper.class);
            BaseSegmentMapper segmentMapper = context.getBean(BaseSegmentMapper.class);
            PpsUserSession session = context.getSession(PpsUserSession.class);
            BasePipelineSegmentRelMapper pipelineSegmentRelMapper = context.getBean(BasePipelineSegmentRelMapper.class);
            //删除上下游关系
            QueryWrapper<BaseClientStationRelEnt> queryWrapper = new QueryWrapper<>();
            queryWrapper.lambda().eq(BaseClientStationRelEnt::getId, input.getId());
            BaseClientStationRelEnt entity = mapper.selectOne(queryWrapper);
            if (entity == null) {
                return XServiceResult.error(context, XError.NotFound);
            }
            entity.setEndTime(XDateUtils.addMunites(new Date(),-1));
            entity.setModifyTime(new Date());
            entity.setModifyByName(session.getLoginName());
            entity.setModifyById(session.getId());
            mapper.updateById(entity);
            if(StringUtils.isNotBlank(entity.getSegmentId())){
                QueryWrapper<BaseSegmentEnt> query = new QueryWrapper<>();
                query.lambda().eq(BaseSegmentEnt::getId,entity.getSegmentId());
                BaseSegmentEnt baseSegment = segmentMapper.selectOne(query);
                if(ObjectUtils.isNotEmpty(baseSegment)){
                    baseSegment.setEndTime(XDateUtils.addMunites(new Date(),-1));
                    baseSegment.setModifyTime(new Date());
                    baseSegment.setModifyByName(session.getLoginName());
                    baseSegment.setModifyById(session.getId());
                    segmentMapper.updateById(baseSegment);
                    QueryWrapper<BasePipelineSegmentRelEnt> queryRel = new QueryWrapper<>();
                    queryRel.lambda().eq(BasePipelineSegmentRelEnt::getSegmentId, baseSegment.getId())
                            .eq(BasePipelineSegmentRelEnt::getPipelineId, entity.getPipelineId()).last("limit 1");;
                    BasePipelineSegmentRelEnt basePipelineSegmentRelEnt = pipelineSegmentRelMapper.selectOne(queryRel);
                    basePipelineSegmentRelEnt.setEndTime(XDateUtils.addMunites(new Date(),-1));
                    basePipelineSegmentRelEnt.setModifyTime(new Date());
                    basePipelineSegmentRelEnt.setModifyByName(session.getLoginName());
                    basePipelineSegmentRelEnt.setModifyById(session.getId());
                    pipelineSegmentRelMapper.updateById(basePipelineSegmentRelEnt);
                }
            }
            return XServiceResult.OK;
        });
    }

    @XApiPost
    @XText("获取上下游关系")
    public XSingleResult<GetBaseClientStationRelOutput> getBaseClientStationRel(XContext context, GetBaseClientStationRelInput input){
        BaseClientStationRelMapper mapper = context.getBean(BaseClientStationRelMapper.class);
        QueryWrapper<BaseClientStationRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseClientStationRelEnt::getId, input.getId());
        BaseClientStationRelEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBaseClientStationRelOutput output = new GetBaseClientStationRelOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiPost
    @XText("查询上游下游关系列表2")
    public XPageResult<QueryBaseClientStationRelOutput> queryBaseClientStationRel(XContext context, QueryBaseClientStationRelInput input){
        BaseClientStationRelMapper mapper = context.getBean(BaseClientStationRelMapper.class);
        QueryWrapper<BaseClientStationRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(BaseClientStationRelEnt::getId, input.getId())
            .like(BaseClientStationRelEnt::getStationId, input.getStationId())
            .like(BaseClientStationRelEnt::getPipelineId, input.getPipelineId())
            .like(BaseClientStationRelEnt::getOuid, input.getOuid())
            .like(BaseClientStationRelEnt::getClientId, input.getClientId())
            .like(BaseClientStationRelEnt::getConsignor, input.getConsignor())
            .eq(BaseClientStationRelEnt::getType, input.getType())
            .eq(BaseClientStationRelEnt::getEffectTime, input.getEffectTime())
            .eq(BaseClientStationRelEnt::getEndTime, input.getEndTime())
            .like(BaseClientStationRelEnt::getCreateById, input.getCreateById())
            .like(BaseClientStationRelEnt::getCreateByName, input.getCreateByName())
            .eq(BaseClientStationRelEnt::getCreateTime, input.getCreateTime())
            .like(BaseClientStationRelEnt::getModifyById, input.getModifyById())
            .like(BaseClientStationRelEnt::getModifyByName, input.getModifyByName())
            .eq(BaseClientStationRelEnt::getModifyTime, input.getModifyTime());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryBaseClientStationRelOutput.class);
    }

    @XApiPost
    public XPageResult<QueryBaseClientStationRelOutput> dynamicQueryBaseClientStationRel(XContext context, CustomQueryInput input){
        BaseClientStationRelMapper mapper = context.getBean(BaseClientStationRelMapper.class);
        return XMapperHelper.query(mapper, input, BaseClientStationRelEnt.class, QueryBaseClientStationRelOutput.class);
    }

    @XApiPost
    public XSingleResult<GetBaseClientStationRelViewOutput> getBaseClientStationRelView(XContext context, GetBaseClientStationRelViewInput input){
        BaseClientStationRelViewMapper mapper = context.getBean(BaseClientStationRelViewMapper.class);
        BaseClientStationRelView record = new BaseClientStationRelView();
        XCopyUtils.copyObject(input, record);
        BaseClientStationRelView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBaseClientStationRelViewOutput output = new GetBaseClientStationRelViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiPost
    @XText("上游or下游关系列表")
    public XPageResult<QueryBaseClientStationRelViewOutput> queryBaseClientStationRelView(XContext context, QueryBaseClientStationRelViewInput input){
        BaseClientStationRelViewMapper mapper = context.getBean(BaseClientStationRelViewMapper.class);
        BaseClientStationRelView record = new BaseClientStationRelView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        record.setEndTime(new Date());
        List<BaseClientStationRelView> list = mapper.selectList(record);
        PageInfo<BaseClientStationRelView> pageInfo = new PageInfo<>(list);
        List<QueryBaseClientStationRelViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryBaseClientStationRelViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

    @XApiPost
    @XText("查询上游下游关系列表")
    public XPageResult<QueryBaseClientStationRelViewOutput> queryBaseClientStationRel(XContext context, QueryBaseClientStationRelViewInput input){
        BaseClientStationRelViewMapper mapper = context.getBean(BaseClientStationRelViewMapper.class);
        BaseClientStationRelView record = new BaseClientStationRelView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<BaseClientStationRelView> list = mapper.selectListByStationId(record);
        PageInfo<BaseClientStationRelView> pageInfo = new PageInfo<>(list);
        List<QueryBaseClientStationRelViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryBaseClientStationRelViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

    @XApiGet
    @XText("查询上游下游关系列表")
    public XListResult<GetBaseClientStationRelOutput> getBaseClientStationRelList(XContext context, GetBaseClientStationRelInput input){
        BaseClientStationRelViewMapper mapper = context.getBean(BaseClientStationRelViewMapper.class);
        BaseClientStationRelView record = new BaseClientStationRelView();
        XCopyUtils.copyObject(input, record);
        List<BaseClientStationRelView> list = mapper.selectListByStationIdAndPipelineId(record);
        List<GetBaseClientStationRelOutput> outputs = XCopyUtils.copyNewList(list, GetBaseClientStationRelOutput.class);
        return XListResult.success(outputs);
    }

}
