package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.util.CollectionUtils;
import pps.cloud.base.service.BaseBaseClientStationRelService;
import pps.cloud.base.service.data.*;
import pps.core.base.entity.BaseClientStationRelEnt;
import pps.core.base.entity.BaseClientStationRelView;
import pps.core.base.mapper.BaseClientStationRelMapper;
import pps.core.base.mapper.BaseClientStationRelViewMapper;
import pps.core.base.mapper.BaseClientViewMapper;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.base.util.XStringUtils;
import xstartup.data.XListResult;

import java.util.List;

@XService
public class BaseClientStationRelServiceImpl implements BaseBaseClientStationRelService {
    @XText("根据场站、管线、管道查询客户数据")
    @Override
    public XListResult<GetBaseClientStationRelViewOutput> selectListByStationIdAndPipelineIdAndSegmentId(XContext context, GetBaseClientStationRelViewInput input) {
        BaseClientStationRelViewMapper mapper = context.getBean(BaseClientStationRelViewMapper.class);
        BaseClientStationRelView record = new BaseClientStationRelView();
        XCopyUtils.copyObject(input, record);
        List<BaseClientStationRelView> list = mapper.selectListByStationIdAndPipelineIdAndSegmentId(record);
        List<GetBaseClientStationRelViewOutput> outputs = XCopyUtils.copyNewList(list , GetBaseClientStationRelViewOutput.class);
        return XListResult.success(outputs);
    }

    @XText("根据场站获取托运商数据")
    @Override
    public XListResult<FindBaseClientOutput> selectConsignorByStationIds(XContext context, BaseStationIdInput input) {
        BaseClientStationRelViewMapper mapper = context.getBean(BaseClientStationRelViewMapper.class);
        BaseClientStationRelView record = new BaseClientStationRelView();
        XCopyUtils.copyObject(input, record);
        List<BaseClientStationRelView> list = mapper.selectConsignorListByStationIds(record);
        List<FindBaseClientOutput> outputs = XCopyUtils.copyNewList(list , FindBaseClientOutput.class);
        return XListResult.success(outputs);
    }

    @XText("根据下游用户，查询场站数据")
    @Override
    public XListResult<GetBaseClientStationRelViewOutput> selectListByClientIds(XContext context, BaseClientIdInput input) {
        BaseClientStationRelViewMapper mapper = context.getBean(BaseClientStationRelViewMapper.class);
        BaseClientStationRelView relView = new BaseClientStationRelView();
        if(XStringUtils.isNotEmpty(input.getClientId()))
            relView.setClientId(input.getClientId());
        if(!CollectionUtils.isEmpty(input.getClientIds()))
            relView.setClientIds(input.getClientIds());
        List<BaseClientStationRelView> list = mapper.selectListByClientIds(relView);
        List<GetBaseClientStationRelViewOutput> outputs = XCopyUtils.copyNewList(list , GetBaseClientStationRelViewOutput.class);
        return XListResult.success(outputs);
    }
}
