package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.base_equipment_client_rel.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class BaseEquipmentClientRelService {
    
    @XApiPost
    public XServiceResult createBaseEquipmentClientRel(XContext context, CreateBaseEquipmentClientRelInput input){
        BaseEquipmentClientRelMapper mapper = context.getBean(BaseEquipmentClientRelMapper.class);
        BaseEquipmentClientRelEnt entity = new BaseEquipmentClientRelEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    
    @XApiPost
    public XServiceResult updateBaseEquipmentClientRel(XContext context, UpdateBaseEquipmentClientRelInput input){
        BaseEquipmentClientRelMapper mapper = context.getBean(BaseEquipmentClientRelMapper.class);
        QueryWrapper<BaseEquipmentClientRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseEquipmentClientRelEnt::getId, input.getId());
        BaseEquipmentClientRelEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    
    @XApiPost
    public XServiceResult deleteBaseEquipmentClientRel(XContext context, DeleteBaseEquipmentClientRelInput input){
        BaseEquipmentClientRelMapper mapper = context.getBean(BaseEquipmentClientRelMapper.class);
        QueryWrapper<BaseEquipmentClientRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseEquipmentClientRelEnt::getId, input.getId());
        BaseEquipmentClientRelEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    
    @XApiGet
    public XSingleResult<GetBaseEquipmentClientRelOutput> getBaseEquipmentClientRel(XContext context, GetBaseEquipmentClientRelInput input){
        BaseEquipmentClientRelMapper mapper = context.getBean(BaseEquipmentClientRelMapper.class);
        QueryWrapper<BaseEquipmentClientRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseEquipmentClientRelEnt::getId, input.getId());
        BaseEquipmentClientRelEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBaseEquipmentClientRelOutput output = new GetBaseEquipmentClientRelOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    
    @XApiGet
    public XPageResult<QueryBaseEquipmentClientRelOutput> queryBaseEquipmentClientRel(XContext context, QueryBaseEquipmentClientRelInput input){
        BaseEquipmentClientRelMapper mapper = context.getBean(BaseEquipmentClientRelMapper.class);
        QueryWrapper<BaseEquipmentClientRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(BaseEquipmentClientRelEnt::getId, input.getId())
            .like(BaseEquipmentClientRelEnt::getEquipmentId, input.getEquipmentId())
            .like(BaseEquipmentClientRelEnt::getClientId, input.getClientId())
            .eq(BaseEquipmentClientRelEnt::getEffectTime, input.getEffectTime())
            .eq(BaseEquipmentClientRelEnt::getEndTime, input.getEndTime())
            .like(BaseEquipmentClientRelEnt::getCreateById, input.getCreateById())
            .like(BaseEquipmentClientRelEnt::getCreateByName, input.getCreateByName())
            .eq(BaseEquipmentClientRelEnt::getCreateTime, input.getCreateTime())
            .like(BaseEquipmentClientRelEnt::getModifyById, input.getModifyById())
            .like(BaseEquipmentClientRelEnt::getModifyByName, input.getModifyByName())
            .eq(BaseEquipmentClientRelEnt::getModifyTime, input.getModifyTime());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryBaseEquipmentClientRelOutput.class);
    }

    
    @XApiGet
    public XPageResult<QueryBaseEquipmentClientRelOutput> dynamicQueryBaseEquipmentClientRel(XContext context, CustomQueryInput input){
        BaseEquipmentClientRelMapper mapper = context.getBean(BaseEquipmentClientRelMapper.class);
        return XMapperHelper.query(mapper, input, BaseEquipmentClientRelEnt.class, QueryBaseEquipmentClientRelOutput.class);
    }

    
    @XApiGet
    public XSingleResult<GetBaseEquipmentClientRelViewOutput> getBaseEquipmentClientRelView(XContext context, GetBaseEquipmentClientRelViewInput input){
        BaseEquipmentClientRelViewMapper mapper = context.getBean(BaseEquipmentClientRelViewMapper.class);
        BaseEquipmentClientRelView record = new BaseEquipmentClientRelView();
        XCopyUtils.copyObject(input, record);
        BaseEquipmentClientRelView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBaseEquipmentClientRelViewOutput output = new GetBaseEquipmentClientRelViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    
    @XApiGet
    public XPageResult<QueryBaseEquipmentClientRelViewOutput> queryBaseEquipmentClientRelView(XContext context, QueryBaseEquipmentClientRelViewInput input){
        BaseEquipmentClientRelViewMapper mapper = context.getBean(BaseEquipmentClientRelViewMapper.class);
        BaseEquipmentClientRelView record = new BaseEquipmentClientRelView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<BaseEquipmentClientRelView> list = mapper.selectList(record);
        PageInfo<BaseEquipmentClientRelView> pageInfo = new PageInfo<>(list);
        List<QueryBaseEquipmentClientRelViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryBaseEquipmentClientRelViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
