package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.base.entity.BasePipelineOuRelEnt;
import pps.core.base.entity.BasePipelineOuRelView;
import pps.core.base.mapper.BasePipelineOuRelMapper;
import pps.core.base.mapper.BasePipelineOuRelViewMapper;
import pps.core.base.service.data.base_pipeline_ou_rel.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class BasePipelineOuRelService {
    @XApiPost
    public XServiceResult createBasePipelineOuRel(XContext context, CreateBasePipelineOuRelInput input){
        BasePipelineOuRelMapper mapper = context.getBean(BasePipelineOuRelMapper.class);
        BasePipelineOuRelEnt entity = new BasePipelineOuRelEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiPost
    public XServiceResult updateBasePipelineOuRel(XContext context, UpdateBasePipelineOuRelInput input){
        BasePipelineOuRelMapper mapper = context.getBean(BasePipelineOuRelMapper.class);
        QueryWrapper<BasePipelineOuRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePipelineOuRelEnt::getId, input.getId());
        BasePipelineOuRelEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiPost
    public XServiceResult deleteBasePipelineOuRel(XContext context, DeleteBasePipelineOuRelInput input){
        BasePipelineOuRelMapper mapper = context.getBean(BasePipelineOuRelMapper.class);
        QueryWrapper<BasePipelineOuRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePipelineOuRelEnt::getId, input.getId());
        BasePipelineOuRelEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiGet
    public XSingleResult<GetBasePipelineOuRelOutput> getBasePipelineOuRel(XContext context, GetBasePipelineOuRelInput input){
        BasePipelineOuRelMapper mapper = context.getBean(BasePipelineOuRelMapper.class);
        QueryWrapper<BasePipelineOuRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePipelineOuRelEnt::getId, input.getId());
        BasePipelineOuRelEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBasePipelineOuRelOutput output = new GetBasePipelineOuRelOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiGet
    public XPageResult<QueryBasePipelineOuRelOutput> queryBasePipelineOuRel(XContext context, QueryBasePipelineOuRelInput input){
        BasePipelineOuRelMapper mapper = context.getBean(BasePipelineOuRelMapper.class);
        QueryWrapper<BasePipelineOuRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(BasePipelineOuRelEnt::getId, input.getId())
            .like(BasePipelineOuRelEnt::getPipelineId, input.getPipelineId())
            .like(BasePipelineOuRelEnt::getOuId, input.getOuId())
            .like(BasePipelineOuRelEnt::getRelType, input.getRelType())
            .eq(BasePipelineOuRelEnt::getEffectTime, input.getEffectTime())
            .eq(BasePipelineOuRelEnt::getEndTime, input.getEndTime())
            .like(BasePipelineOuRelEnt::getCreateById, input.getCreateById())
            .like(BasePipelineOuRelEnt::getCreateByName, input.getCreateByName())
            .eq(BasePipelineOuRelEnt::getCreateTime, input.getCreateTime())
            .like(BasePipelineOuRelEnt::getModifyById, input.getModifyById())
            .like(BasePipelineOuRelEnt::getModifyByName, input.getModifyByName())
            .eq(BasePipelineOuRelEnt::getModifyTime, input.getModifyTime());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryBasePipelineOuRelOutput.class);
    }

    @XApiGet
    public XPageResult<QueryBasePipelineOuRelOutput> dynamicQueryBasePipelineOuRel(XContext context, CustomQueryInput input){
        BasePipelineOuRelMapper mapper = context.getBean(BasePipelineOuRelMapper.class);
        return XMapperHelper.query(mapper, input, BasePipelineOuRelEnt.class, QueryBasePipelineOuRelOutput.class);
    }

    @XApiGet
    public XSingleResult<GetBasePipelineOuRelViewOutput> getBasePipelineOuRelView(XContext context, GetBasePipelineOuRelViewInput input){
        BasePipelineOuRelViewMapper mapper = context.getBean(BasePipelineOuRelViewMapper.class);
        BasePipelineOuRelView record = new BasePipelineOuRelView();
        XCopyUtils.copyObject(input, record);
        BasePipelineOuRelView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBasePipelineOuRelViewOutput output = new GetBasePipelineOuRelViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiGet
    public XPageResult<QueryBasePipelineOuRelViewOutput> queryBasePipelineOuRelView(XContext context, QueryBasePipelineOuRelViewInput input){
        BasePipelineOuRelViewMapper mapper = context.getBean(BasePipelineOuRelViewMapper.class);
        BasePipelineOuRelView record = new BasePipelineOuRelView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<BasePipelineOuRelView> list = mapper.selectList(record);
        PageInfo<BasePipelineOuRelView> pageInfo = new PageInfo<>(list);
        List<QueryBasePipelineOuRelViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryBasePipelineOuRelViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
