package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.base_small_metering_fix_coefficient.*;
import pps.core.common.session.PpsUserSession;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.data.XServiceResult;
import xstartup.data.XPageResult;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.Date;
import java.util.UUID;


@XText("小型计量器具校准系数")
@XService
public class BaseSmallMeteringFixCoefficientService {

    @XText("增加小型计量器具系数")
    @XApiPost
    public XServiceResult createBaseSmallMeteringFixCoefficient(XContext context, CreateBaseSmallMeteringFixCoefficientInput input){
        BaseSmallMeteringFixCoefficientMapper mapper = context.getBean(BaseSmallMeteringFixCoefficientMapper.class);
        PpsUserSession session = context.getSession(PpsUserSession.class);
        BaseSmallMeteringFixCoefficientEnt entity = new BaseSmallMeteringFixCoefficientEnt();
        XCopyUtils.copyObject(input, entity);
        String s = UUID.randomUUID().toString();
        entity.setId(s);
        entity.setCreateById(session.getId());
        entity.setCreateByName(session.getLoginName());
        entity.setCreateTime(new Date());
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XText("修改小型计量器具")
    @XApiPost
    public XServiceResult updateBaseSmallMeteringFixCoefficient(XContext context, UpdateBaseSmallMeteringFixCoefficientInput input){
        BaseSmallMeteringFixCoefficientMapper mapper = context.getBean(BaseSmallMeteringFixCoefficientMapper.class);
        PpsUserSession session = context.getSession(PpsUserSession.class);
        QueryWrapper<BaseSmallMeteringFixCoefficientEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseSmallMeteringFixCoefficientEnt::getId, input.getId());
        BaseSmallMeteringFixCoefficientEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        entity.setModifyById(session.getId());
        entity.setModifyByName(session.getLoginName());
        entity.setModifyTime(new Date());
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XText("删除小型计量器具")
    @XApiPost
    public XServiceResult deleteBaseSmallMeteringFixCoefficient(XContext context, DeleteBaseSmallMeteringFixCoefficientInput input){
        BaseSmallMeteringFixCoefficientMapper mapper = context.getBean(BaseSmallMeteringFixCoefficientMapper.class);
        QueryWrapper<BaseSmallMeteringFixCoefficientEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseSmallMeteringFixCoefficientEnt::getId, input.getId());
        BaseSmallMeteringFixCoefficientEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XText("分页查询小型计量参数")
    @XApiGet
    public XPageResult<QueryBaseSmallMeteringFixCoefficientOutput> queryBaseSmallMeteringFixCoefficient(XContext context, QueryBaseSmallMeteringFixCoefficientInput input){
        BaseSmallMeteringFixCoefficientMapper mapper = context.getBean(BaseSmallMeteringFixCoefficientMapper.class);
        QueryWrapper<BaseSmallMeteringFixCoefficientEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BaseSmallMeteringFixCoefficientEnt::getMeterId, input.getMeterId());
        queryWrapper.lambda().orderByAsc(BaseSmallMeteringFixCoefficientEnt::getMeasureValue);
        return XMapperHelper.query(mapper, input, queryWrapper, QueryBaseSmallMeteringFixCoefficientOutput.class);
    }


}
