package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.util.CollectionUtils;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.base_temperament_device_config.*;
import pps.core.common.session.PpsUserSession;
import pps.core.common.utils.UUIDHelper;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.data.XListResult;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XSingleResult;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@XService
@XText("气质参数配置相关参数")
public class BaseTemperamentDeviceConfigService {


    @XApiAnonymous
    @XApiPost
    @XText("根据管线id获取参数信息")
    public XListResult<GetConfListOutput> getConfListByPipelineId(XContext context, GetConfListByPipelineIdInput input){
        List<GetConfListOutput> resultList = new ArrayList<>();
        PpsUserSession session = context.getSession(PpsUserSession.class);
        Date date = new Date();
        //根据管线id获取参与管存计算的场站数据
        BasePipelineStationRelViewMapper basePipelineStationRelViewMapper = context.getBean(BasePipelineStationRelViewMapper.class);
        List<BasePipelineStationRelView> relViewList = basePipelineStationRelViewMapper.selectCustodyUseStation(input.getPipelineId(),"1");
        if(!relViewList.isEmpty()){
            BaseTemperamentDeviceConfigMapper mapper = context.getBean(BaseTemperamentDeviceConfigMapper.class);
            QueryWrapper<BaseTemperamentDeviceConfigEnt> qr = new QueryWrapper<>();
            qr.lambda().eq(BaseTemperamentDeviceConfigEnt::getPipelineId,input.getPipelineId()).orderByAsc(BaseTemperamentDeviceConfigEnt::getSort);
            List<BaseTemperamentDeviceConfigEnt> dataList = mapper.selectList(qr);
            if(!dataList.isEmpty()){
                if(relViewList.size() == dataList.size()){
                    XCopyUtils.copyList(dataList,resultList,GetConfListOutput.class);
                }else{
                    int index = 0;
                    for(BasePipelineStationRelView view:relViewList){
                        index++;
                        boolean haveData = false;
                        for(BaseTemperamentDeviceConfigEnt ent:dataList){
                            if(view.getStationId().equals(ent.getStationId())){
                                resultList.add(XCopyUtils.copyNewObject(ent, GetConfListOutput.class));
                                haveData = true;
                                continue;
                            }
                        }
                        if(!haveData){
                            BaseTemperamentDeviceConfigEnt insertEnt = XCopyUtils.copyNewObject(view, BaseTemperamentDeviceConfigEnt.class);
                            insertEnt.setId(UUIDHelper.newUUID());
                            insertEnt.setCreateById(session.getId());
                            insertEnt.setCreateByName(session.getUserName());
                            insertEnt.setCreateTime(date);
                            insertEnt.setSort(index);
                            resultList.add(XCopyUtils.copyNewObject(insertEnt,GetConfListOutput.class));
                            mapper.insert(insertEnt);
                        }
                    }
                }
            }else{
                int i = 0;
                for(BasePipelineStationRelView item:relViewList){
                    BaseTemperamentDeviceConfigEnt insertEnt = XCopyUtils.copyNewObject(item, BaseTemperamentDeviceConfigEnt.class);
                    insertEnt.setId(UUIDHelper.newUUID());
                    insertEnt.setCreateById(session.getId());
                    insertEnt.setCreateByName(session.getUserName());
                    insertEnt.setCreateTime(date);
                    insertEnt.setSort(++i);
                    resultList.add(XCopyUtils.copyNewObject(insertEnt,GetConfListOutput.class));
                    mapper.insert(insertEnt);
                }
            }
        }
        return XListResult.success(XCopyUtils.copyNewList(resultList,GetConfListOutput.class));
    }

    @XText("保存配置信息")
    @XApiPost
    public XSingleResult saveConfigData(XContext context,SaveConfigDataInput input){
        if(CollectionUtils.isEmpty(input.getList())) return  XSingleResult.error(400,"请选择数据");
        PpsUserSession session = context.getSession(PpsUserSession.class);
        Date date = new Date();

        BaseTemperamentDeviceConfigMapper mapper = context.getBean(BaseTemperamentDeviceConfigMapper.class);
        for(ConfDataInput item:input.getList()){
            item.setModifyById(session.getId());
            item.setModifyByName(session.getUserName());
            item.setModifyTime(date);
            BaseTemperamentDeviceConfigEnt ent = XCopyUtils.copyNewObject(item, BaseTemperamentDeviceConfigEnt.class);
            mapper.updateById(ent);
        }
        return XSingleResult.success();
    }
}
