package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import pps.cloud.base.service.IBaseTemperamentDeviceConfigService;
import pps.cloud.base.service.data.SelectTDConfListByPipelineIdOutput;
import pps.cloud.base.service.data.base_pipeline.PipelineIdInput;
import pps.core.base.entity.BaseTemperamentDeviceConfigEnt;
import pps.core.base.mapper.BaseTemperamentDeviceConfigMapper;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XListResult;

import java.util.List;

@XService
public class BaseTemperamentDeviceConfigServiceImpl implements IBaseTemperamentDeviceConfigService {


    @Override
    @XText("根据管线id获取所有的场站配置信息")
    public XListResult<SelectTDConfListByPipelineIdOutput> selectListByPipelineId(XContext context, PipelineIdInput input) {
        BaseTemperamentDeviceConfigMapper mapper = context.getBean(BaseTemperamentDeviceConfigMapper.class);
        QueryWrapper<BaseTemperamentDeviceConfigEnt> qr = new QueryWrapper<>();
        qr.lambda().eq(BaseTemperamentDeviceConfigEnt::getPipelineId,input.getId()).orderByAsc(BaseTemperamentDeviceConfigEnt::getSort);
        List<BaseTemperamentDeviceConfigEnt> list = mapper.selectList(qr);
        return XListResult.success(XCopyUtils.copyNewList(list,SelectTDConfListByPipelineIdOutput.class));
    }
}
