package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.base.entity.GasUploadDayPlanConfigEnt;
import pps.core.base.entity.GasUploadDayPlanConfigView;
import pps.core.base.mapper.GasUploadDayPlanConfigMapper;
import pps.core.base.mapper.GasUploadDayPlanConfigViewMapper;
import pps.core.base.service.data.gas_upload_day_plan_config.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class GasUploadDayPlanConfigService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createGasUploadDayPlanConfig(XContext context, CreateGasUploadDayPlanConfigInput input){
        GasUploadDayPlanConfigMapper mapper = context.getBean(GasUploadDayPlanConfigMapper.class);
        GasUploadDayPlanConfigEnt entity = new GasUploadDayPlanConfigEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateGasUploadDayPlanConfig(XContext context, UpdateGasUploadDayPlanConfigInput input){
        GasUploadDayPlanConfigMapper mapper = context.getBean(GasUploadDayPlanConfigMapper.class);
        QueryWrapper<GasUploadDayPlanConfigEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(GasUploadDayPlanConfigEnt::getId, input.getId());
        GasUploadDayPlanConfigEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteGasUploadDayPlanConfig(XContext context, DeleteGasUploadDayPlanConfigInput input){
        GasUploadDayPlanConfigMapper mapper = context.getBean(GasUploadDayPlanConfigMapper.class);
        QueryWrapper<GasUploadDayPlanConfigEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(GasUploadDayPlanConfigEnt::getId, input.getId());
        GasUploadDayPlanConfigEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetGasUploadDayPlanConfigOutput> getGasUploadDayPlanConfig(XContext context, GetGasUploadDayPlanConfigInput input){
        GasUploadDayPlanConfigMapper mapper = context.getBean(GasUploadDayPlanConfigMapper.class);
        QueryWrapper<GasUploadDayPlanConfigEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(GasUploadDayPlanConfigEnt::getId, input.getId());
        GasUploadDayPlanConfigEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetGasUploadDayPlanConfigOutput output = new GetGasUploadDayPlanConfigOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryGasUploadDayPlanConfigOutput> queryGasUploadDayPlanConfig(XContext context, QueryGasUploadDayPlanConfigInput input){
        GasUploadDayPlanConfigMapper mapper = context.getBean(GasUploadDayPlanConfigMapper.class);
        QueryWrapper<GasUploadDayPlanConfigEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(GasUploadDayPlanConfigEnt::getId, input.getId())
            .like(GasUploadDayPlanConfigEnt::getMOuId, input.getMOuId())
            .like(GasUploadDayPlanConfigEnt::getMOuName, input.getMOuName())
            .like(GasUploadDayPlanConfigEnt::getPipelineId, input.getPipelineId())
            .like(GasUploadDayPlanConfigEnt::getPipelineName, input.getPipelineName())
            .like(GasUploadDayPlanConfigEnt::getPipelineDisplayName, input.getPipelineDisplayName())
            .like(GasUploadDayPlanConfigEnt::getStationId, input.getStationId())
            .like(GasUploadDayPlanConfigEnt::getStationName, input.getStationName())
            .like(GasUploadDayPlanConfigEnt::getShipperId, input.getShipperId())
            .like(GasUploadDayPlanConfigEnt::getShipperName, input.getShipperName())
            .like(GasUploadDayPlanConfigEnt::getSourceId, input.getSourceId())
            .like(GasUploadDayPlanConfigEnt::getSourceName, input.getSourceName())
            .eq(GasUploadDayPlanConfigEnt::getSort, input.getSort())
            .eq(GasUploadDayPlanConfigEnt::getDayPlanDid, input.getUploadDayPlanDid());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryGasUploadDayPlanConfigOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryGasUploadDayPlanConfigOutput> dynamicQueryGasUploadDayPlanConfig(XContext context, CustomQueryInput input){
        GasUploadDayPlanConfigMapper mapper = context.getBean(GasUploadDayPlanConfigMapper.class);
        return XMapperHelper.query(mapper, input, GasUploadDayPlanConfigEnt.class, QueryGasUploadDayPlanConfigOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetGasUploadDayPlanConfigViewOutput> getGasUploadDayPlanConfigView(XContext context, GetGasUploadDayPlanConfigViewInput input){
        GasUploadDayPlanConfigViewMapper mapper = context.getBean(GasUploadDayPlanConfigViewMapper.class);
        GasUploadDayPlanConfigView record = new GasUploadDayPlanConfigView();
        XCopyUtils.copyObject(input, record);
        GasUploadDayPlanConfigView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetGasUploadDayPlanConfigViewOutput output = new GetGasUploadDayPlanConfigViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryGasUploadDayPlanConfigViewOutput> queryGasUploadDayPlanConfigView(XContext context, QueryGasUploadDayPlanConfigViewInput input){
        GasUploadDayPlanConfigViewMapper mapper = context.getBean(GasUploadDayPlanConfigViewMapper.class);
        GasUploadDayPlanConfigView record = new GasUploadDayPlanConfigView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<GasUploadDayPlanConfigView> list = mapper.selectList(record);
        PageInfo<GasUploadDayPlanConfigView> pageInfo = new PageInfo<>(list);
        List<QueryGasUploadDayPlanConfigViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryGasUploadDayPlanConfigViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
