package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.metering_customer.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import xstartup.feature.mybatis.helper.XMapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class MeteringCustomerService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createMeteringCustomer(XContext context, CreateMeteringCustomerInput input){
        MeteringCustomerMapper mapper = context.getBean(MeteringCustomerMapper.class);
        MeteringCustomerEnt entity = new MeteringCustomerEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateMeteringCustomer(XContext context, UpdateMeteringCustomerInput input){
        MeteringCustomerMapper mapper = context.getBean(MeteringCustomerMapper.class);
        QueryWrapper<MeteringCustomerEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringCustomerEnt::getId, input.getId());
        MeteringCustomerEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteMeteringCustomer(XContext context, DeleteMeteringCustomerInput input){
        MeteringCustomerMapper mapper = context.getBean(MeteringCustomerMapper.class);
        QueryWrapper<MeteringCustomerEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringCustomerEnt::getId, input.getId());
        MeteringCustomerEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringCustomerOutput> getMeteringCustomer(XContext context, GetMeteringCustomerInput input){
        MeteringCustomerMapper mapper = context.getBean(MeteringCustomerMapper.class);
        QueryWrapper<MeteringCustomerEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringCustomerEnt::getId, input.getId());
        MeteringCustomerEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringCustomerOutput output = new GetMeteringCustomerOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringCustomerOutput> queryMeteringCustomer(XContext context, QueryMeteringCustomerInput input){
        MeteringCustomerMapper mapper = context.getBean(MeteringCustomerMapper.class);
        QueryWrapper<MeteringCustomerEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(MeteringCustomerEnt::getId, input.getId())
            .like(MeteringCustomerEnt::getCustomerName, input.getCustomerName())
            .like(MeteringCustomerEnt::getCustomerFullName, input.getCustomerFullName())
            .eq(MeteringCustomerEnt::getCreateDate, input.getCreateDate());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryMeteringCustomerOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringCustomerOutput> dynamicQueryMeteringCustomer(XContext context, CustomQueryInput input){
        MeteringCustomerMapper mapper = context.getBean(MeteringCustomerMapper.class);
        return XMapperHelper.query(mapper, input, MeteringCustomerEnt.class, QueryMeteringCustomerOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringCustomerViewOutput> getMeteringCustomerView(XContext context, GetMeteringCustomerViewInput input){
        MeteringCustomerViewMapper mapper = context.getBean(MeteringCustomerViewMapper.class);
        MeteringCustomerView record = new MeteringCustomerView();
        XCopyUtils.copyObject(input, record);
        MeteringCustomerView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringCustomerViewOutput output = new GetMeteringCustomerViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringCustomerViewOutput> queryMeteringCustomerView(XContext context, QueryMeteringCustomerViewInput input){
        MeteringCustomerViewMapper mapper = context.getBean(MeteringCustomerViewMapper.class);
        MeteringCustomerView record = new MeteringCustomerView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<MeteringCustomerView> list = mapper.selectList(record);
        PageInfo<MeteringCustomerView> pageInfo = new PageInfo<>(list);
        List<QueryMeteringCustomerViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryMeteringCustomerViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
