package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.metering_dictionary_rel.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import xstartup.feature.mybatis.helper.XMapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class MeteringDictionaryRelService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createMeteringDictionaryRel(XContext context, CreateMeteringDictionaryRelInput input){
        MeteringDictionaryRelMapper mapper = context.getBean(MeteringDictionaryRelMapper.class);
        MeteringDictionaryRelEnt entity = new MeteringDictionaryRelEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateMeteringDictionaryRel(XContext context, UpdateMeteringDictionaryRelInput input){
        MeteringDictionaryRelMapper mapper = context.getBean(MeteringDictionaryRelMapper.class);
        QueryWrapper<MeteringDictionaryRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringDictionaryRelEnt::getId, input.getId());
        MeteringDictionaryRelEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteMeteringDictionaryRel(XContext context, DeleteMeteringDictionaryRelInput input){
        MeteringDictionaryRelMapper mapper = context.getBean(MeteringDictionaryRelMapper.class);
        QueryWrapper<MeteringDictionaryRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringDictionaryRelEnt::getId, input.getId());
        MeteringDictionaryRelEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringDictionaryRelOutput> getMeteringDictionaryRel(XContext context, GetMeteringDictionaryRelInput input){
        MeteringDictionaryRelMapper mapper = context.getBean(MeteringDictionaryRelMapper.class);
        QueryWrapper<MeteringDictionaryRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringDictionaryRelEnt::getId, input.getId());
        MeteringDictionaryRelEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringDictionaryRelOutput output = new GetMeteringDictionaryRelOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringDictionaryRelOutput> queryMeteringDictionaryRel(XContext context, QueryMeteringDictionaryRelInput input){
        MeteringDictionaryRelMapper mapper = context.getBean(MeteringDictionaryRelMapper.class);
        QueryWrapper<MeteringDictionaryRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringDictionaryRelEnt::getId, input.getId())
            .eq(MeteringDictionaryRelEnt::getDicId, input.getDicId())
            .eq(MeteringDictionaryRelEnt::getParentId, input.getParentId())
            .eq(MeteringDictionaryRelEnt::getCreateDate, input.getCreateDate());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryMeteringDictionaryRelOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringDictionaryRelOutput> dynamicQueryMeteringDictionaryRel(XContext context, CustomQueryInput input){
        MeteringDictionaryRelMapper mapper = context.getBean(MeteringDictionaryRelMapper.class);
        return XMapperHelper.query(mapper, input, MeteringDictionaryRelEnt.class, QueryMeteringDictionaryRelOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringDictionaryRelViewOutput> getMeteringDictionaryRelView(XContext context, GetMeteringDictionaryRelViewInput input){
        MeteringDictionaryRelViewMapper mapper = context.getBean(MeteringDictionaryRelViewMapper.class);
        MeteringDictionaryRelView record = new MeteringDictionaryRelView();
        XCopyUtils.copyObject(input, record);
        MeteringDictionaryRelView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringDictionaryRelViewOutput output = new GetMeteringDictionaryRelViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringDictionaryRelViewOutput> queryMeteringDictionaryRelView(XContext context, QueryMeteringDictionaryRelViewInput input){
        MeteringDictionaryRelViewMapper mapper = context.getBean(MeteringDictionaryRelViewMapper.class);
        MeteringDictionaryRelView record = new MeteringDictionaryRelView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<MeteringDictionaryRelView> list = mapper.selectList(record);
        PageInfo<MeteringDictionaryRelView> pageInfo = new PageInfo<>(list);
        List<QueryMeteringDictionaryRelViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryMeteringDictionaryRelViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
