package pps.core.base.service;

import java.util.ArrayList;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.metering_dictionary.*;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import xstartup.feature.mybatis.helper.XMapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class MeteringDictionaryService {

    @XApiAnonymous
    @XText("企业名称")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryEnterprieNameSelectBox(XContext context){
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectEnterprieNameSelectBox();
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setStrValue(view.getStrValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }


    @XApiAnonymous
    @XText("二级单位")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> querySubUnitNameSelectBox(XContext context, QuerySelectBoxInput input){
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectSubUnitNameSelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setStrValue(view.getStrValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }


    @XApiAnonymous
    @XText("场站名称")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryStationNameSelectBox(XContext context, QuerySelectBoxInput input){
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectStationNameSelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setStrValue(view.getStrValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }


    @XApiAnonymous
    @XText("管线名称")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryPipeLineNameSelectBox(XContext context, QuerySelectBoxInput input){
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectPipeLineNameSelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setStrValue(view.getStrValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }


    @XApiAnonymous
    @XText("客户名称")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> querySelectBox(XContext context, QuerySelectBoxStationPipelineInput input){
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectCustomerNameSelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setStrValue(view.getStrValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }


    @XApiAnonymous
    @XText("输送介质")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryMediumTypeSelectBox(XContext context){

        List<QuerySelectBoxOutput> result=new ArrayList<>();
        QuerySelectBoxOutput item1=new QuerySelectBoxOutput();
        item1.setName("天然气");
        item1.setStrValue("227");
        QuerySelectBoxOutput item2=new QuerySelectBoxOutput();
        item2.setName("原油");
        item2.setStrValue("228");
        QuerySelectBoxOutput item3=new QuerySelectBoxOutput();
        item3.setName("成品油");
        item3.setStrValue("229");

        result.add(item1);
        result.add(item2);
        result.add(item3);

        return XListResult.success(result);
    }


    @XApiAnonymous
    @XText("设备名称")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryEquipmentNameSelectBox(XContext context){
        QuerySelectBoxInput input=new QuerySelectBoxInput();
        input.setValue("58");
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionarySelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }


    @XApiAnonymous
    @XText("设备类型")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryEquipmentTypeSelectBox(XContext context, QuerySelectBoxInput input){
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionarySelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }


    @XApiAnonymous
    @XText("生产厂家")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryProductionFactorySelectBox(XContext context){
        QuerySelectBoxInput input=new QuerySelectBoxInput();
        input.setValue("201");
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionarySelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }

    @XApiAnonymous
    @XText("规格型号")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> querySpecificationsSelectBox(XContext context, QuerySelectBoxInput input){
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionaryRelSelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }

    @XApiAnonymous
    @XText("检定周期")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryVCylceSelectBox(XContext context){

        List<QuerySelectBoxOutput> result=new ArrayList<>();
        for (int i = 3; i < 49; i++)
        {
            QuerySelectBoxOutput item1=new QuerySelectBoxOutput();
            item1.setName(i+"个月");
            item1.setValue(i);
            result.add(item1);
        }
        return XListResult.success(result);
    }
    @XApiAnonymous
    @XText("使用状态")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryUsageStateSelectBox(XContext context){
        QuerySelectBoxInput input=new QuerySelectBoxInput();
        input.setValue("97");
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionarySelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }
    @XApiAnonymous
    @XText("资产所属")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryAssetBelongsSelectBox(XContext context){
        QuerySelectBoxInput input=new QuerySelectBoxInput();
        input.setValue("94");
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionarySelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }
    @XApiAnonymous
    @XText("资产管理权")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryAuthoritySelectBox(XContext context){
        QuerySelectBoxInput input=new QuerySelectBoxInput();
        input.setValue("165");
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionarySelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }
    @XApiAnonymous
    @XText("用途")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryUsageSelectBox(XContext context){
        QuerySelectBoxInput input=new QuerySelectBoxInput();
        input.setValue("82");
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionarySelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }
    @XApiAnonymous
    @XText("用途1")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryUsage1SelectBox(XContext context, QuerySelectBoxInput input){
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionaryRelSelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }
    @XApiAnonymous
    @XText("流量计口径")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryCaliberSelectBox(XContext context){
        QuerySelectBoxInput input=new QuerySelectBoxInput();
        input.setValue("112");
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionarySelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }
    @XApiAnonymous
    @XText("压力等级")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryPressureLevelSelectBox(XContext context){
        QuerySelectBoxInput input=new QuerySelectBoxInput();
        input.setValue("123");
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionarySelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }
    @XApiAnonymous
    @XText("准确度")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryAccuracySelectBox(XContext context){
        QuerySelectBoxInput input=new QuerySelectBoxInput();
        input.setValue("140");
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionarySelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }

    @XApiAnonymous
    @XText("检定类别")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryVerficationTypeSelectBox(XContext context){
        QuerySelectBoxInput input=new QuerySelectBoxInput();
        input.setValue("146");
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionarySelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }
    @XApiAnonymous
    @XText("检定方式")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryVerficationMethodSelectBox(XContext context){
        QuerySelectBoxInput input=new QuerySelectBoxInput();
        input.setValue("152");
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionarySelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }
    @XApiAnonymous
    @XText("检定结论")
    @XApiPost
    public XListResult<QuerySelectBoxOutput> queryVerficationResultSelectBox(XContext context){
        QuerySelectBoxInput input=new QuerySelectBoxInput();
        input.setValue("155");
        MeteringDictionaryViewMapper mapper = context.getBean(MeteringDictionaryViewMapper.class);
        List<QuerySelectBoxOutputView> result2=mapper.selectDictionarySelectBox(input);
        List<QuerySelectBoxOutput> result= new ArrayList<>();
        for(QuerySelectBoxOutputView view:result2){
            QuerySelectBoxOutput item =new QuerySelectBoxOutput();
            item.setValue(view.getValue());
            item.setName(view.getName());
            result.add(item);
        }
        return XListResult.success(result);
    }


}
