package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.metering_enterprie.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import xstartup.feature.mybatis.helper.XMapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class MeteringEnterprieService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createMeteringEnterprie(XContext context, CreateMeteringEnterprieInput input){
        MeteringEnterprieMapper mapper = context.getBean(MeteringEnterprieMapper.class);
        MeteringEnterprieEnt entity = new MeteringEnterprieEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateMeteringEnterprie(XContext context, UpdateMeteringEnterprieInput input){
        MeteringEnterprieMapper mapper = context.getBean(MeteringEnterprieMapper.class);
        QueryWrapper<MeteringEnterprieEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringEnterprieEnt::getId, input.getId());
        MeteringEnterprieEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteMeteringEnterprie(XContext context, DeleteMeteringEnterprieInput input){
        MeteringEnterprieMapper mapper = context.getBean(MeteringEnterprieMapper.class);
        QueryWrapper<MeteringEnterprieEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringEnterprieEnt::getId, input.getId());
        MeteringEnterprieEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringEnterprieOutput> getMeteringEnterprie(XContext context, GetMeteringEnterprieInput input){
        MeteringEnterprieMapper mapper = context.getBean(MeteringEnterprieMapper.class);
        QueryWrapper<MeteringEnterprieEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringEnterprieEnt::getId, input.getId());
        MeteringEnterprieEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringEnterprieOutput output = new GetMeteringEnterprieOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringEnterprieOutput> queryMeteringEnterprie(XContext context, QueryMeteringEnterprieInput input){
        MeteringEnterprieMapper mapper = context.getBean(MeteringEnterprieMapper.class);
        QueryWrapper<MeteringEnterprieEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(MeteringEnterprieEnt::getId, input.getId())
            .like(MeteringEnterprieEnt::getOuName, input.getOuName())
            .like(MeteringEnterprieEnt::getShortName, input.getShortName())
            .eq(MeteringEnterprieEnt::getSort, input.getSort());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryMeteringEnterprieOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringEnterprieOutput> dynamicQueryMeteringEnterprie(XContext context, CustomQueryInput input){
        MeteringEnterprieMapper mapper = context.getBean(MeteringEnterprieMapper.class);
        return XMapperHelper.query(mapper, input, MeteringEnterprieEnt.class, QueryMeteringEnterprieOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringEnterprieViewOutput> getMeteringEnterprieView(XContext context, GetMeteringEnterprieViewInput input){
        MeteringEnterprieViewMapper mapper = context.getBean(MeteringEnterprieViewMapper.class);
        MeteringEnterprieView record = new MeteringEnterprieView();
        XCopyUtils.copyObject(input, record);
        MeteringEnterprieView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringEnterprieViewOutput output = new GetMeteringEnterprieViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringEnterprieViewOutput> queryMeteringEnterprieView(XContext context, QueryMeteringEnterprieViewInput input){
        MeteringEnterprieViewMapper mapper = context.getBean(MeteringEnterprieViewMapper.class);
        MeteringEnterprieView record = new MeteringEnterprieView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<MeteringEnterprieView> list = mapper.selectList(record);
        PageInfo<MeteringEnterprieView> pageInfo = new PageInfo<>(list);
        List<QueryMeteringEnterprieViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryMeteringEnterprieViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
