package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.metering_equipment_ledger.*;
import pps.core.common.session.PpsUserSession;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XPageResult;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import xstartup.feature.mybatis.helper.XMapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;

import java.util.Date;
import java.util.List;

@XService
public class MeteringEquipmentLedgerService {

    @XText("新增计量设备")
    @XApiAnonymous
    @XApiPost
    public XServiceResult createMeteringEquipmentLedger(XContext context, CreateMeteringEquipmentLedgerInput input){
        MeteringEquipmentLedgerMapper mapper = context.getBean(MeteringEquipmentLedgerMapper.class);
        MeteringEquipmentLedgerEnt entity = new MeteringEquipmentLedgerEnt();
        PpsUserSession session = context.getSession(PpsUserSession.class);
        QueryWrapper<MeteringEquipmentLedgerEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.orderByDesc("id");
        MeteringEquipmentLedgerEnt model =mapper.selectList(queryWrapper).stream().findFirst().get();
        XCopyUtils.copyObject(input, entity);
        try{
            entity.setId(model.getId()+1);
        }catch (Exception ex){
            return XServiceResult.error(ex);
        }

        entity.setCreaterId(session.getId());
        entity.setCreater(session.getUserName());
        entity.setCreateDate(new Date());
        entity.setAuditStatus(0);
        entity.setWorkflowId("");
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateMeteringEquipmentLedger(XContext context, UpdateMeteringEquipmentLedgerInput input){
        MeteringEquipmentLedgerMapper mapper = context.getBean(MeteringEquipmentLedgerMapper.class);
        PpsUserSession session = context.getSession(PpsUserSession.class);
        QueryWrapper<MeteringEquipmentLedgerEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringEquipmentLedgerEnt::getId, input.getId());
        MeteringEquipmentLedgerEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);

        entity.setCreaterId(session.getId());
        entity.setCreater(session.getUserName());
        entity.setCreateDate(new Date());
        entity.setAuditStatus(0);
        entity.setWorkflowId("");
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteMeteringEquipmentLedger(XContext context, DeleteMeteringEquipmentLedgerInput input){
        MeteringEquipmentLedgerMapper mapper = context.getBean(MeteringEquipmentLedgerMapper.class);
        QueryWrapper<MeteringEquipmentLedgerEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringEquipmentLedgerEnt::getId, input.getId());
        MeteringEquipmentLedgerEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringEquipmentLedgerOutput> getMeteringEquipmentLedger(XContext context, GetMeteringEquipmentLedgerInput input){
        MeteringEquipmentLedgerMapper mapper = context.getBean(MeteringEquipmentLedgerMapper.class);
        QueryWrapper<MeteringEquipmentLedgerEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringEquipmentLedgerEnt::getId, input.getId());
        MeteringEquipmentLedgerEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringEquipmentLedgerOutput output = new GetMeteringEquipmentLedgerOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringEquipmentLedgerOutput> queryMeteringEquipmentLedger(XContext context, QueryMeteringEquipmentLedgerInput input){
        MeteringEquipmentLedgerMapper mapper = context.getBean(MeteringEquipmentLedgerMapper.class);
        QueryWrapper<MeteringEquipmentLedgerEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringEquipmentLedgerEnt::getId, input.getId())
            .like(MeteringEquipmentLedgerEnt::getPipelineId, input.getPipelineId())
            .like(MeteringEquipmentLedgerEnt::getStationId, input.getStationId())
            .like(MeteringEquipmentLedgerEnt::getCustomerId, input.getCustomerId())
            .like(MeteringEquipmentLedgerEnt::getSubunitId, input.getSubunitId())
            .like(MeteringEquipmentLedgerEnt::getEnterprieId, input.getEnterprieId())
            .eq(MeteringEquipmentLedgerEnt::getEquipmentId, input.getEquipmentId())
            .eq(MeteringEquipmentLedgerEnt::getEquipmentTypeId, input.getEquipmentTypeId())
            .like(MeteringEquipmentLedgerEnt::getTechnologyLocation, input.getTechnologyLocation())
            .like(MeteringEquipmentLedgerEnt::getTechnologyNumber, input.getTechnologyNumber())
            .like(MeteringEquipmentLedgerEnt::getPpsEquipmentId, input.getPpsEquipmentId())
            .like(MeteringEquipmentLedgerEnt::getPpsNumber, input.getPpsNumber())
            .eq(MeteringEquipmentLedgerEnt::getProductionFactoryId, input.getProductionFactoryId())
            .like(MeteringEquipmentLedgerEnt::getProductionNumber, input.getProductionNumber())
            .eq(MeteringEquipmentLedgerEnt::getProductionDate, input.getProductionDate())
            .eq(MeteringEquipmentLedgerEnt::getSpecificationsId, input.getSpecificationsId())
            .eq(MeteringEquipmentLedgerEnt::getCommissioningDate, input.getCommissioningDate())
            .eq(MeteringEquipmentLedgerEnt::getUsageId, input.getUsageId())
            .eq(MeteringEquipmentLedgerEnt::getUsage1Id, input.getUsage1Id())
            .eq(MeteringEquipmentLedgerEnt::getAssetBelongsId, input.getAssetBelongsId())
            .eq(MeteringEquipmentLedgerEnt::getAuthorityId, input.getAuthorityId())
            .eq(MeteringEquipmentLedgerEnt::getUsageStateId, input.getUsageStateId())
            .like(MeteringEquipmentLedgerEnt::getAssetUint, input.getAssetUint())
            .eq(MeteringEquipmentLedgerEnt::getVcylce, input.getVcylce())
            .like(MeteringEquipmentLedgerEnt::getMediumType, input.getMediumType())
            .eq(MeteringEquipmentLedgerEnt::getCaliber, input.getCaliber())
            .eq(MeteringEquipmentLedgerEnt::getPressureLevel, input.getPressureLevel())
            .eq(MeteringEquipmentLedgerEnt::getAccuracy, input.getAccuracy())
            .eq(MeteringEquipmentLedgerEnt::getMinflow, input.getMinflow())
            .eq(MeteringEquipmentLedgerEnt::getMaxflow, input.getMaxflow())
            .eq(MeteringEquipmentLedgerEnt::getDemarcationflow, input.getDemarcationflow())
            .like(MeteringEquipmentLedgerEnt::getPotNumber, input.getPotNumber())
            .eq(MeteringEquipmentLedgerEnt::getVolume, input.getVolume())
            .eq(MeteringEquipmentLedgerEnt::getType, input.getType())
            .eq(MeteringEquipmentLedgerEnt::getStorageMedium, input.getStorageMedium())
            .like(MeteringEquipmentLedgerEnt::getBak, input.getBak())
            .like(MeteringEquipmentLedgerEnt::getWorkflowId, input.getWorkflowId())
            .eq(MeteringEquipmentLedgerEnt::getAuditStatus, input.getAuditStatus())
            .like(MeteringEquipmentLedgerEnt::getCreaterId, input.getCreaterId())
            .like(MeteringEquipmentLedgerEnt::getCreater, input.getCreater())
            .eq(MeteringEquipmentLedgerEnt::getCreateDate, input.getCreateDate());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryMeteringEquipmentLedgerOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringEquipmentLedgerOutput> dynamicQueryMeteringEquipmentLedger(XContext context, CustomQueryInput input){
        MeteringEquipmentLedgerMapper mapper = context.getBean(MeteringEquipmentLedgerMapper.class);
        return XMapperHelper.query(mapper, input, MeteringEquipmentLedgerEnt.class, QueryMeteringEquipmentLedgerOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringEquipmentLedgerViewOutput> getMeteringEquipmentLedgerView(XContext context, GetMeteringEquipmentLedgerViewInput input){
        MeteringEquipmentLedgerViewMapper mapper = context.getBean(MeteringEquipmentLedgerViewMapper.class);
        MeteringEquipmentLedgerView record = new MeteringEquipmentLedgerView();
        XCopyUtils.copyObject(input, record);
        MeteringEquipmentLedgerView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringEquipmentLedgerViewOutput output = new GetMeteringEquipmentLedgerViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringEquipmentLedgerViewOutput> queryMeteringEquipmentLedgerView(XContext context, QueryMeteringEquipmentLedgerViewInput input){
        MeteringEquipmentLedgerViewMapper mapper = context.getBean(MeteringEquipmentLedgerViewMapper.class);
        MeteringEquipmentLedgerView record = new MeteringEquipmentLedgerView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<MeteringEquipmentLedgerView> list = mapper.selectList(record);
        PageInfo<MeteringEquipmentLedgerView> pageInfo = new PageInfo<>(list);
        List<QueryMeteringEquipmentLedgerViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryMeteringEquipmentLedgerViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
