package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.metering_new_customer_name.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import pps.core.common.session.PpsUserSession;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import xstartup.feature.mybatis.helper.XMapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class MeteringNewCustomerNameService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createMeteringNewCustomerName(XContext context, CreateMeteringNewCustomerNameInput input){
        MeteringNewCustomerNameMapper mapper = context.getBean(MeteringNewCustomerNameMapper.class);
        MeteringNewCustomerNameEnt entity = new MeteringNewCustomerNameEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XText("修改用户名称")
    @XApiAnonymous
    @XApiPost
    public XServiceResult updateMeteringNewCustomerName(XContext context, UpdateMeteringNewCustomerNameInput input){
        MeteringNewCustomerNameMapper mapper = context.getBean(MeteringNewCustomerNameMapper.class);
        PpsUserSession session = context.getSession(PpsUserSession.class);
        QueryWrapper<MeteringNewCustomerNameEnt> queryWrapper = new QueryWrapper<>();
        if(input==null||input.getCustomerName()==null||input.getCustomerName()==""){
            return XServiceResult.error(0,"新名称不能为空!");
        }

        MeteringNewCustomerNameEnt entity=new MeteringNewCustomerNameEnt();
        entity.setId(input.getId());
        entity.setCustomerName(input.getCustomerName());
        entity.setCreateDate(new Date());
        entity.setCreater(session.getUserName());

        mapper.deleteById(input.getId());
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteMeteringNewCustomerName(XContext context, DeleteMeteringNewCustomerNameInput input){
        MeteringNewCustomerNameMapper mapper = context.getBean(MeteringNewCustomerNameMapper.class);
        QueryWrapper<MeteringNewCustomerNameEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringNewCustomerNameEnt::getId, input.getId());
        MeteringNewCustomerNameEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringNewCustomerNameOutput> getMeteringNewCustomerName(XContext context, GetMeteringNewCustomerNameInput input){
        MeteringNewCustomerNameMapper mapper = context.getBean(MeteringNewCustomerNameMapper.class);
        QueryWrapper<MeteringNewCustomerNameEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringNewCustomerNameEnt::getId, input.getId());
        MeteringNewCustomerNameEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringNewCustomerNameOutput output = new GetMeteringNewCustomerNameOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringNewCustomerNameOutput> queryMeteringNewCustomerName(XContext context, QueryMeteringNewCustomerNameInput input){
        MeteringNewCustomerNameMapper mapper = context.getBean(MeteringNewCustomerNameMapper.class);
        QueryWrapper<MeteringNewCustomerNameEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(MeteringNewCustomerNameEnt::getId, input.getId())
            .like(MeteringNewCustomerNameEnt::getCustomerName, input.getCustomerName())
            .eq(MeteringNewCustomerNameEnt::getCreateDate, input.getCreateDate())
            .like(MeteringNewCustomerNameEnt::getCreater, input.getCreater());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryMeteringNewCustomerNameOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringNewCustomerNameOutput> dynamicQueryMeteringNewCustomerName(XContext context, CustomQueryInput input){
        MeteringNewCustomerNameMapper mapper = context.getBean(MeteringNewCustomerNameMapper.class);
        return XMapperHelper.query(mapper, input, MeteringNewCustomerNameEnt.class, QueryMeteringNewCustomerNameOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringNewCustomerNameViewOutput> getMeteringNewCustomerNameView(XContext context, GetMeteringNewCustomerNameViewInput input){
        MeteringNewCustomerNameViewMapper mapper = context.getBean(MeteringNewCustomerNameViewMapper.class);
        MeteringNewCustomerNameView record = new MeteringNewCustomerNameView();
        XCopyUtils.copyObject(input, record);
        MeteringNewCustomerNameView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringNewCustomerNameViewOutput output = new GetMeteringNewCustomerNameViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringNewCustomerNameViewOutput> queryMeteringNewCustomerNameView(XContext context, QueryMeteringNewCustomerNameViewInput input){
        MeteringNewCustomerNameViewMapper mapper = context.getBean(MeteringNewCustomerNameViewMapper.class);
        MeteringNewCustomerNameView record = new MeteringNewCustomerNameView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<MeteringNewCustomerNameView> list = mapper.selectList(record);
        PageInfo<MeteringNewCustomerNameView> pageInfo = new PageInfo<>(list);
        List<QueryMeteringNewCustomerNameViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryMeteringNewCustomerNameViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
