package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.metering_participation.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import xstartup.feature.mybatis.helper.XMapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class MeteringParticipationService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createMeteringParticipation(XContext context, CreateMeteringParticipationInput input){
        MeteringParticipationMapper mapper = context.getBean(MeteringParticipationMapper.class);
        MeteringParticipationEnt entity = new MeteringParticipationEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateMeteringParticipation(XContext context, UpdateMeteringParticipationInput input){
        MeteringParticipationMapper mapper = context.getBean(MeteringParticipationMapper.class);
        QueryWrapper<MeteringParticipationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringParticipationEnt::getId, input.getId());
        MeteringParticipationEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteMeteringParticipation(XContext context, DeleteMeteringParticipationInput input){
        MeteringParticipationMapper mapper = context.getBean(MeteringParticipationMapper.class);
        QueryWrapper<MeteringParticipationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringParticipationEnt::getId, input.getId());
        MeteringParticipationEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringParticipationOutput> getMeteringParticipation(XContext context, GetMeteringParticipationInput input){
        MeteringParticipationMapper mapper = context.getBean(MeteringParticipationMapper.class);
        QueryWrapper<MeteringParticipationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringParticipationEnt::getId, input.getId());
        MeteringParticipationEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringParticipationOutput output = new GetMeteringParticipationOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringParticipationOutput> queryMeteringParticipation(XContext context, QueryMeteringParticipationInput input){
        MeteringParticipationMapper mapper = context.getBean(MeteringParticipationMapper.class);
        QueryWrapper<MeteringParticipationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringParticipationEnt::getId, input.getId())
            .like(MeteringParticipationEnt::getStationId, input.getStationId())
            .like(MeteringParticipationEnt::getCustomerId, input.getCustomerId())
            .like(MeteringParticipationEnt::getCreateId, input.getCreateId())
            .like(MeteringParticipationEnt::getCreateName, input.getCreateName())
            .eq(MeteringParticipationEnt::getCreateDate, input.getCreateDate())
            .like(MeteringParticipationEnt::getPipelineId, input.getPipelineId());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryMeteringParticipationOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringParticipationOutput> dynamicQueryMeteringParticipation(XContext context, CustomQueryInput input){
        MeteringParticipationMapper mapper = context.getBean(MeteringParticipationMapper.class);
        return XMapperHelper.query(mapper, input, MeteringParticipationEnt.class, QueryMeteringParticipationOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringParticipationViewOutput> getMeteringParticipationView(XContext context, GetMeteringParticipationViewInput input){
        MeteringParticipationViewMapper mapper = context.getBean(MeteringParticipationViewMapper.class);
        MeteringParticipationView record = new MeteringParticipationView();
        XCopyUtils.copyObject(input, record);
        MeteringParticipationView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringParticipationViewOutput output = new GetMeteringParticipationViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringParticipationViewOutput> queryMeteringParticipationView(XContext context, QueryMeteringParticipationViewInput input){
        MeteringParticipationViewMapper mapper = context.getBean(MeteringParticipationViewMapper.class);
        MeteringParticipationView record = new MeteringParticipationView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<MeteringParticipationView> list = mapper.selectList(record);
        PageInfo<MeteringParticipationView> pageInfo = new PageInfo<>(list);
        List<QueryMeteringParticipationViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryMeteringParticipationViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
