package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.metering_pipe_station_customer_rel.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import xstartup.feature.mybatis.helper.XMapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class MeteringPipeStationCustomerRelService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createMeteringPipeStationCustomerRel(XContext context, CreateMeteringPipeStationCustomerRelInput input){
        MeteringPipeStationCustomerRelMapper mapper = context.getBean(MeteringPipeStationCustomerRelMapper.class);
        MeteringPipeStationCustomerRelEnt entity = new MeteringPipeStationCustomerRelEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateMeteringPipeStationCustomerRel(XContext context, UpdateMeteringPipeStationCustomerRelInput input){
        MeteringPipeStationCustomerRelMapper mapper = context.getBean(MeteringPipeStationCustomerRelMapper.class);
        QueryWrapper<MeteringPipeStationCustomerRelEnt> queryWrapper = new QueryWrapper<>();
        //queryWrapper.lambda().eq(MeteringPipeStationCustomerRelEnt::getId, input.getId());
        MeteringPipeStationCustomerRelEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteMeteringPipeStationCustomerRel(XContext context, DeleteMeteringPipeStationCustomerRelInput input){
        MeteringPipeStationCustomerRelMapper mapper = context.getBean(MeteringPipeStationCustomerRelMapper.class);
        QueryWrapper<MeteringPipeStationCustomerRelEnt> queryWrapper = new QueryWrapper<>();
        //queryWrapper.lambda().eq(MeteringPipeStationCustomerRelEnt::getId, input.getId());
        MeteringPipeStationCustomerRelEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringPipeStationCustomerRelOutput> getMeteringPipeStationCustomerRel(XContext context, GetMeteringPipeStationCustomerRelInput input){
        MeteringPipeStationCustomerRelMapper mapper = context.getBean(MeteringPipeStationCustomerRelMapper.class);
        QueryWrapper<MeteringPipeStationCustomerRelEnt> queryWrapper = new QueryWrapper<>();
        //queryWrapper.lambda().eq(MeteringPipeStationCustomerRelEnt::getId, input.getId());
        MeteringPipeStationCustomerRelEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringPipeStationCustomerRelOutput output = new GetMeteringPipeStationCustomerRelOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringPipeStationCustomerRelOutput> queryMeteringPipeStationCustomerRel(XContext context, QueryMeteringPipeStationCustomerRelInput input){
        MeteringPipeStationCustomerRelMapper mapper = context.getBean(MeteringPipeStationCustomerRelMapper.class);
        QueryWrapper<MeteringPipeStationCustomerRelEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(MeteringPipeStationCustomerRelEnt::getPipelineId, input.getPipelineId())
            .like(MeteringPipeStationCustomerRelEnt::getStationId, input.getStationId())
            .like(MeteringPipeStationCustomerRelEnt::getClientId, input.getClientId())
            .eq(MeteringPipeStationCustomerRelEnt::getCreateDate, input.getCreateDate())
            .like(MeteringPipeStationCustomerRelEnt::getCreater, input.getCreater());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryMeteringPipeStationCustomerRelOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringPipeStationCustomerRelOutput> dynamicQueryMeteringPipeStationCustomerRel(XContext context, CustomQueryInput input){
        MeteringPipeStationCustomerRelMapper mapper = context.getBean(MeteringPipeStationCustomerRelMapper.class);
        return XMapperHelper.query(mapper, input, MeteringPipeStationCustomerRelEnt.class, QueryMeteringPipeStationCustomerRelOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringPipeStationCustomerRelViewOutput> getMeteringPipeStationCustomerRelView(XContext context, GetMeteringPipeStationCustomerRelViewInput input){
        MeteringPipeStationCustomerRelViewMapper mapper = context.getBean(MeteringPipeStationCustomerRelViewMapper.class);
        MeteringPipeStationCustomerRelView record = new MeteringPipeStationCustomerRelView();
        XCopyUtils.copyObject(input, record);
        MeteringPipeStationCustomerRelView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringPipeStationCustomerRelViewOutput output = new GetMeteringPipeStationCustomerRelViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringPipeStationCustomerRelViewOutput> queryMeteringPipeStationCustomerRelView(XContext context, QueryMeteringPipeStationCustomerRelViewInput input){
        MeteringPipeStationCustomerRelViewMapper mapper = context.getBean(MeteringPipeStationCustomerRelViewMapper.class);
        MeteringPipeStationCustomerRelView record = new MeteringPipeStationCustomerRelView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<MeteringPipeStationCustomerRelView> list = mapper.selectList(record);
        PageInfo<MeteringPipeStationCustomerRelView> pageInfo = new PageInfo<>(list);
        List<QueryMeteringPipeStationCustomerRelViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryMeteringPipeStationCustomerRelViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
