package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.metering_verfication_info.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import pps.core.common.session.PpsUserSession;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import xstartup.feature.mybatis.helper.XMapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class MeteringVerficationInfoService {

    @XText("新增检定信息")
    @XApiAnonymous
    @XApiPost
    public XServiceResult createMeteringVerficationInfo(XContext context, CreateMeteringVerficationInfoInput input){
        MeteringVerficationInfoMapper mapper = context.getBean(MeteringVerficationInfoMapper.class);
        MeteringVerficationInfoEnt entity = new MeteringVerficationInfoEnt();
        PpsUserSession session = context.getSession(PpsUserSession.class);
        XCopyUtils.copyObject(input, entity);

        QueryWrapper<MeteringVerficationInfoEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.orderByDesc("id");
        MeteringVerficationInfoEnt model =mapper.selectList(queryWrapper).stream().findFirst().get();
        try{
            entity.setId(model.getId()+1);
        }catch (Exception ex){
            return XServiceResult.error(ex);
        }
        entity.setCreaterId(session.getId());
        entity.setCreater(session.getUserName());
        entity.setCreateDate(new Date());
        entity.setAuditStatus(0);
        entity.setWorkflowId("");

        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateMeteringVerficationInfo(XContext context, UpdateMeteringVerficationInfoInput input){
        MeteringVerficationInfoMapper mapper = context.getBean(MeteringVerficationInfoMapper.class);
        QueryWrapper<MeteringVerficationInfoEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringVerficationInfoEnt::getId, input.getId());
        MeteringVerficationInfoEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteMeteringVerficationInfo(XContext context, DeleteMeteringVerficationInfoInput input){
        MeteringVerficationInfoMapper mapper = context.getBean(MeteringVerficationInfoMapper.class);
        QueryWrapper<MeteringVerficationInfoEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringVerficationInfoEnt::getId, input.getId());
        MeteringVerficationInfoEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringVerficationInfoOutput> getMeteringVerficationInfo(XContext context, GetMeteringVerficationInfoInput input){
        MeteringVerficationInfoMapper mapper = context.getBean(MeteringVerficationInfoMapper.class);
        QueryWrapper<MeteringVerficationInfoEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringVerficationInfoEnt::getId, input.getId());
        MeteringVerficationInfoEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringVerficationInfoOutput output = new GetMeteringVerficationInfoOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringVerficationInfoOutput> queryMeteringVerficationInfo(XContext context, QueryMeteringVerficationInfoInput input){
        MeteringVerficationInfoMapper mapper = context.getBean(MeteringVerficationInfoMapper.class);
        QueryWrapper<MeteringVerficationInfoEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MeteringVerficationInfoEnt::getId, input.getId())
            .eq(MeteringVerficationInfoEnt::getEquipmentId, input.getEquipmentId())
            .like(MeteringVerficationInfoEnt::getUint, input.getUint())
            .eq(MeteringVerficationInfoEnt::getDate, input.getDate())
            .eq(MeteringVerficationInfoEnt::getResult, input.getResult())
            .eq(MeteringVerficationInfoEnt::getType, input.getType())
            .eq(MeteringVerficationInfoEnt::getMethod, input.getMethod())
            .like(MeteringVerficationInfoEnt::getCertificateNumber, input.getCertificateNumber())
            .like(MeteringVerficationInfoEnt::getOverdueCause, input.getOverdueCause())
            .like(MeteringVerficationInfoEnt::getWorkflowId, input.getWorkflowId())
            .eq(MeteringVerficationInfoEnt::getAuditStatus, input.getAuditStatus())
            .like(MeteringVerficationInfoEnt::getCreaterId, input.getCreaterId())
            .like(MeteringVerficationInfoEnt::getCreater, input.getCreater())
            .eq(MeteringVerficationInfoEnt::getCreateDate, input.getCreateDate());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryMeteringVerficationInfoOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringVerficationInfoOutput> dynamicQueryMeteringVerficationInfo(XContext context, CustomQueryInput input){
        MeteringVerficationInfoMapper mapper = context.getBean(MeteringVerficationInfoMapper.class);
        return XMapperHelper.query(mapper, input, MeteringVerficationInfoEnt.class, QueryMeteringVerficationInfoOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetMeteringVerficationInfoViewOutput> getMeteringVerficationInfoView(XContext context, GetMeteringVerficationInfoViewInput input){
        MeteringVerficationInfoViewMapper mapper = context.getBean(MeteringVerficationInfoViewMapper.class);
        MeteringVerficationInfoView record = new MeteringVerficationInfoView();
        XCopyUtils.copyObject(input, record);
        MeteringVerficationInfoView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetMeteringVerficationInfoViewOutput output = new GetMeteringVerficationInfoViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryMeteringVerficationInfoViewOutput> queryMeteringVerficationInfoView(XContext context, QueryMeteringVerficationInfoViewInput input){
        MeteringVerficationInfoViewMapper mapper = context.getBean(MeteringVerficationInfoViewMapper.class);
        MeteringVerficationInfoView record = new MeteringVerficationInfoView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<MeteringVerficationInfoView> list = mapper.selectList(record);
        PageInfo<MeteringVerficationInfoView> pageInfo = new PageInfo<>(list);
        List<QueryMeteringVerficationInfoViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryMeteringVerficationInfoViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
