package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.scada_environment_info.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;
@XText("scada环境管理")
@XService
public class ScadaEnvironmentInfoService {

    @XText("scada环境查询")
    @XApiPost
    public XListResult<GetScadaEnvironmentInfoOutput> queryScadaEnvironmentInfos(XContext context, GetScadaEnvironmentInfoInput input){
        ScadaEnvironmentInfoMapper mapper = context.getBean(ScadaEnvironmentInfoMapper.class);
        QueryWrapper<ScadaEnvironmentInfoEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.orderByAsc("sort");
        List<ScadaEnvironmentInfoEnt> ents = mapper.selectList(queryWrapper);
        List<GetScadaEnvironmentInfoOutput> outputs = XCopyUtils.copyNewList(ents, GetScadaEnvironmentInfoOutput.class);
        return XListResult.success(outputs);
    }


    @XApiAnonymous
    @XApiPost
    public XServiceResult createScadaEnvironmentInfo(XContext context, CreateScadaEnvironmentInfoInput input){
        ScadaEnvironmentInfoMapper mapper = context.getBean(ScadaEnvironmentInfoMapper.class);
        ScadaEnvironmentInfoEnt entity = new ScadaEnvironmentInfoEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateScadaEnvironmentInfo(XContext context, UpdateScadaEnvironmentInfoInput input){
        ScadaEnvironmentInfoMapper mapper = context.getBean(ScadaEnvironmentInfoMapper.class);
        QueryWrapper<ScadaEnvironmentInfoEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaEnvironmentInfoEnt::getId, input.getId());
        ScadaEnvironmentInfoEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteScadaEnvironmentInfo(XContext context, DeleteScadaEnvironmentInfoInput input){
        ScadaEnvironmentInfoMapper mapper = context.getBean(ScadaEnvironmentInfoMapper.class);
        QueryWrapper<ScadaEnvironmentInfoEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaEnvironmentInfoEnt::getId, input.getId());
        ScadaEnvironmentInfoEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetScadaEnvironmentInfoOutput> getScadaEnvironmentInfo(XContext context, GetScadaEnvironmentInfoInput input){
        ScadaEnvironmentInfoMapper mapper = context.getBean(ScadaEnvironmentInfoMapper.class);
        QueryWrapper<ScadaEnvironmentInfoEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaEnvironmentInfoEnt::getId, input.getId());
        ScadaEnvironmentInfoEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetScadaEnvironmentInfoOutput output = new GetScadaEnvironmentInfoOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryScadaEnvironmentInfoOutput> queryScadaEnvironmentInfo(XContext context, QueryScadaEnvironmentInfoInput input){
        ScadaEnvironmentInfoMapper mapper = context.getBean(ScadaEnvironmentInfoMapper.class);
        QueryWrapper<ScadaEnvironmentInfoEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(ScadaEnvironmentInfoEnt::getId, input.getId())
            .like(ScadaEnvironmentInfoEnt::getEnvironmentInfoName, input.getEnvironmentInfoName())
            .like(ScadaEnvironmentInfoEnt::getIpAddress, input.getIpAddress())
            .like(ScadaEnvironmentInfoEnt::getUserName, input.getUserName())
            .like(ScadaEnvironmentInfoEnt::getPwd, input.getPwd())
            .like(ScadaEnvironmentInfoEnt::getKeys, input.getKeys())
            .eq(ScadaEnvironmentInfoEnt::getCreateTime, input.getCreateTime())
            .like(ScadaEnvironmentInfoEnt::getCreateById, input.getCreateById())
            .like(ScadaEnvironmentInfoEnt::getCreateByName, input.getCreateByName())
            .eq(ScadaEnvironmentInfoEnt::getModifyTime, input.getModifyTime())
            .like(ScadaEnvironmentInfoEnt::getModifyById, input.getModifyById())
            .like(ScadaEnvironmentInfoEnt::getModifyByName, input.getModifyByName())
            .like(ScadaEnvironmentInfoEnt::getPort, input.getPort())
            .like(ScadaEnvironmentInfoEnt::getAgreement, input.getAgreement());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryScadaEnvironmentInfoOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryScadaEnvironmentInfoOutput> dynamicQueryScadaEnvironmentInfo(XContext context, CustomQueryInput input){
        ScadaEnvironmentInfoMapper mapper = context.getBean(ScadaEnvironmentInfoMapper.class);
        return XMapperHelper.query(mapper, input, ScadaEnvironmentInfoEnt.class, QueryScadaEnvironmentInfoOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetScadaEnvironmentInfoViewOutput> getScadaEnvironmentInfoView(XContext context, GetScadaEnvironmentInfoViewInput input){
        ScadaEnvironmentInfoViewMapper mapper = context.getBean(ScadaEnvironmentInfoViewMapper.class);
        ScadaEnvironmentInfoView record = new ScadaEnvironmentInfoView();
        XCopyUtils.copyObject(input, record);
        ScadaEnvironmentInfoView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetScadaEnvironmentInfoViewOutput output = new GetScadaEnvironmentInfoViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryScadaEnvironmentInfoViewOutput> queryScadaEnvironmentInfoView(XContext context, QueryScadaEnvironmentInfoViewInput input){
        ScadaEnvironmentInfoViewMapper mapper = context.getBean(ScadaEnvironmentInfoViewMapper.class);
        ScadaEnvironmentInfoView record = new ScadaEnvironmentInfoView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<ScadaEnvironmentInfoView> list = mapper.selectList(record);
        PageInfo<ScadaEnvironmentInfoView> pageInfo = new PageInfo<>(list);
        List<QueryScadaEnvironmentInfoViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryScadaEnvironmentInfoViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
