package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.scada_gather_box_m_ou.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class ScadaGatherBoxMOuService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createScadaGatherBoxMOu(XContext context, CreateScadaGatherBoxMOuInput input){
        ScadaGatherBoxMOuMapper mapper = context.getBean(ScadaGatherBoxMOuMapper.class);
        ScadaGatherBoxMOuEnt entity = new ScadaGatherBoxMOuEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateScadaGatherBoxMOu(XContext context, UpdateScadaGatherBoxMOuInput input){
        ScadaGatherBoxMOuMapper mapper = context.getBean(ScadaGatherBoxMOuMapper.class);
        QueryWrapper<ScadaGatherBoxMOuEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherBoxMOuEnt::getId, input.getId());
        ScadaGatherBoxMOuEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteScadaGatherBoxMOu(XContext context, DeleteScadaGatherBoxMOuInput input){
        ScadaGatherBoxMOuMapper mapper = context.getBean(ScadaGatherBoxMOuMapper.class);
        QueryWrapper<ScadaGatherBoxMOuEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherBoxMOuEnt::getId, input.getId());
        ScadaGatherBoxMOuEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetScadaGatherBoxMOuOutput> getScadaGatherBoxMOu(XContext context, GetScadaGatherBoxMOuInput input){
        ScadaGatherBoxMOuMapper mapper = context.getBean(ScadaGatherBoxMOuMapper.class);
        QueryWrapper<ScadaGatherBoxMOuEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherBoxMOuEnt::getId, input.getId());
        ScadaGatherBoxMOuEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetScadaGatherBoxMOuOutput output = new GetScadaGatherBoxMOuOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryScadaGatherBoxMOuOutput> queryScadaGatherBoxMOu(XContext context, QueryScadaGatherBoxMOuInput input){
        ScadaGatherBoxMOuMapper mapper = context.getBean(ScadaGatherBoxMOuMapper.class);
        QueryWrapper<ScadaGatherBoxMOuEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(ScadaGatherBoxMOuEnt::getId, input.getId())
            .like(ScadaGatherBoxMOuEnt::getGatherBoxId, input.getGatherBoxId())
            .like(ScadaGatherBoxMOuEnt::getOuId, input.getOuId())
            .like(ScadaGatherBoxMOuEnt::getOuName, input.getOuName())
            .eq(ScadaGatherBoxMOuEnt::getIsDelete, input.getIsDelete())
            .eq(ScadaGatherBoxMOuEnt::getCreateTime, input.getCreateTime())
            .like(ScadaGatherBoxMOuEnt::getCreateById, input.getCreateById())
            .like(ScadaGatherBoxMOuEnt::getCreateByName, input.getCreateByName())
            .eq(ScadaGatherBoxMOuEnt::getModifyTime, input.getModifyTime())
            .like(ScadaGatherBoxMOuEnt::getModifyById, input.getModifyById())
            .like(ScadaGatherBoxMOuEnt::getModifyByName, input.getModifyByName());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryScadaGatherBoxMOuOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryScadaGatherBoxMOuOutput> dynamicQueryScadaGatherBoxMOu(XContext context, CustomQueryInput input){
        ScadaGatherBoxMOuMapper mapper = context.getBean(ScadaGatherBoxMOuMapper.class);
        return XMapperHelper.query(mapper, input, ScadaGatherBoxMOuEnt.class, QueryScadaGatherBoxMOuOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetScadaGatherBoxMOuViewOutput> getScadaGatherBoxMOuView(XContext context, GetScadaGatherBoxMOuViewInput input){
        ScadaGatherBoxMOuViewMapper mapper = context.getBean(ScadaGatherBoxMOuViewMapper.class);
        ScadaGatherBoxMOuView record = new ScadaGatherBoxMOuView();
        XCopyUtils.copyObject(input, record);
        ScadaGatherBoxMOuView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetScadaGatherBoxMOuViewOutput output = new GetScadaGatherBoxMOuViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryScadaGatherBoxMOuViewOutput> queryScadaGatherBoxMOuView(XContext context, QueryScadaGatherBoxMOuViewInput input){
        ScadaGatherBoxMOuViewMapper mapper = context.getBean(ScadaGatherBoxMOuViewMapper.class);
        ScadaGatherBoxMOuView record = new ScadaGatherBoxMOuView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<ScadaGatherBoxMOuView> list = mapper.selectList(record);
        PageInfo<ScadaGatherBoxMOuView> pageInfo = new PageInfo<>(list);
        List<QueryScadaGatherBoxMOuViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryScadaGatherBoxMOuViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
