package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.scada_gather_box_property.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class ScadaGatherBoxPropertyService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createScadaGatherBoxProperty(XContext context, CreateScadaGatherBoxPropertyInput input){
        ScadaGatherBoxPropertyMapper mapper = context.getBean(ScadaGatherBoxPropertyMapper.class);
        ScadaGatherBoxPropertyEnt entity = new ScadaGatherBoxPropertyEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateScadaGatherBoxProperty(XContext context, UpdateScadaGatherBoxPropertyInput input){
        ScadaGatherBoxPropertyMapper mapper = context.getBean(ScadaGatherBoxPropertyMapper.class);
        QueryWrapper<ScadaGatherBoxPropertyEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherBoxPropertyEnt::getId, input.getId());
        ScadaGatherBoxPropertyEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteScadaGatherBoxProperty(XContext context, DeleteScadaGatherBoxPropertyInput input){
        ScadaGatherBoxPropertyMapper mapper = context.getBean(ScadaGatherBoxPropertyMapper.class);
        QueryWrapper<ScadaGatherBoxPropertyEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherBoxPropertyEnt::getId, input.getId());
        ScadaGatherBoxPropertyEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetScadaGatherBoxPropertyOutput> getScadaGatherBoxProperty(XContext context, GetScadaGatherBoxPropertyInput input){
        ScadaGatherBoxPropertyMapper mapper = context.getBean(ScadaGatherBoxPropertyMapper.class);
        QueryWrapper<ScadaGatherBoxPropertyEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherBoxPropertyEnt::getId, input.getId());
        ScadaGatherBoxPropertyEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetScadaGatherBoxPropertyOutput output = new GetScadaGatherBoxPropertyOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }





    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetScadaGatherBoxPropertyViewOutput> getScadaGatherBoxPropertyView(XContext context, GetScadaGatherBoxPropertyViewInput input){
        ScadaGatherBoxPropertyViewMapper mapper = context.getBean(ScadaGatherBoxPropertyViewMapper.class);
        ScadaGatherBoxPropertyView record = new ScadaGatherBoxPropertyView();
        XCopyUtils.copyObject(input, record);
        ScadaGatherBoxPropertyView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetScadaGatherBoxPropertyViewOutput output = new GetScadaGatherBoxPropertyViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryScadaGatherBoxPropertyViewOutput> queryScadaGatherBoxPropertyView(XContext context, QueryScadaGatherBoxPropertyViewInput input){
        ScadaGatherBoxPropertyViewMapper mapper = context.getBean(ScadaGatherBoxPropertyViewMapper.class);
        ScadaGatherBoxPropertyView record = new ScadaGatherBoxPropertyView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<ScadaGatherBoxPropertyView> list = mapper.selectList(record);
        PageInfo<ScadaGatherBoxPropertyView> pageInfo = new PageInfo<>(list);
        List<QueryScadaGatherBoxPropertyViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryScadaGatherBoxPropertyViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
