package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.scada_gather_conf_in.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class ScadaGatherConfInService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createScadaGatherConfIn(XContext context, CreateScadaGatherConfInInput input){
        ScadaGatherConfInMapper mapper = context.getBean(ScadaGatherConfInMapper.class);
        ScadaGatherConfInEnt entity = new ScadaGatherConfInEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateScadaGatherConfIn(XContext context, UpdateScadaGatherConfInInput input){
        ScadaGatherConfInMapper mapper = context.getBean(ScadaGatherConfInMapper.class);
        QueryWrapper<ScadaGatherConfInEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherConfInEnt::getId, input.getId());
        ScadaGatherConfInEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteScadaGatherConfIn(XContext context, DeleteScadaGatherConfInInput input){
        ScadaGatherConfInMapper mapper = context.getBean(ScadaGatherConfInMapper.class);
        QueryWrapper<ScadaGatherConfInEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherConfInEnt::getId, input.getId());
        ScadaGatherConfInEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetScadaGatherConfInOutput> getScadaGatherConfIn(XContext context, GetScadaGatherConfInInput input){
        ScadaGatherConfInMapper mapper = context.getBean(ScadaGatherConfInMapper.class);
        QueryWrapper<ScadaGatherConfInEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherConfInEnt::getId, input.getId());
        ScadaGatherConfInEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetScadaGatherConfInOutput output = new GetScadaGatherConfInOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }



    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetScadaGatherConfInViewOutput> getScadaGatherConfInView(XContext context, GetScadaGatherConfInViewInput input){
        ScadaGatherConfInViewMapper mapper = context.getBean(ScadaGatherConfInViewMapper.class);
        ScadaGatherConfInView record = new ScadaGatherConfInView();
        XCopyUtils.copyObject(input, record);
        ScadaGatherConfInView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetScadaGatherConfInViewOutput output = new GetScadaGatherConfInViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryScadaGatherConfInViewOutput> queryScadaGatherConfInView(XContext context, QueryScadaGatherConfInViewInput input){
        ScadaGatherConfInViewMapper mapper = context.getBean(ScadaGatherConfInViewMapper.class);
        ScadaGatherConfInView record = new ScadaGatherConfInView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<ScadaGatherConfInView> list = mapper.selectList(record);
        PageInfo<ScadaGatherConfInView> pageInfo = new PageInfo<>(list);
        List<QueryScadaGatherConfInViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryScadaGatherConfInViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
