package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.scada_gather_conf_log.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class ScadaGatherConfLogService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createScadaGatherConfLog(XContext context, CreateScadaGatherConfLogInput input){
        ScadaGatherConfLogMapper mapper = context.getBean(ScadaGatherConfLogMapper.class);
        ScadaGatherConfLogEnt entity = new ScadaGatherConfLogEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateScadaGatherConfLog(XContext context, UpdateScadaGatherConfLogInput input){
        ScadaGatherConfLogMapper mapper = context.getBean(ScadaGatherConfLogMapper.class);
        QueryWrapper<ScadaGatherConfLogEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherConfLogEnt::getId, input.getId());
        ScadaGatherConfLogEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteScadaGatherConfLog(XContext context, DeleteScadaGatherConfLogInput input){
        ScadaGatherConfLogMapper mapper = context.getBean(ScadaGatherConfLogMapper.class);
        QueryWrapper<ScadaGatherConfLogEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherConfLogEnt::getId, input.getId());
        ScadaGatherConfLogEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetScadaGatherConfLogOutput> getScadaGatherConfLog(XContext context, GetScadaGatherConfLogInput input){
        ScadaGatherConfLogMapper mapper = context.getBean(ScadaGatherConfLogMapper.class);
        QueryWrapper<ScadaGatherConfLogEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherConfLogEnt::getId, input.getId());
        ScadaGatherConfLogEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetScadaGatherConfLogOutput output = new GetScadaGatherConfLogOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }


    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetScadaGatherConfLogViewOutput> getScadaGatherConfLogView(XContext context, GetScadaGatherConfLogViewInput input){
        ScadaGatherConfLogViewMapper mapper = context.getBean(ScadaGatherConfLogViewMapper.class);
        ScadaGatherConfLogView record = new ScadaGatherConfLogView();
        XCopyUtils.copyObject(input, record);
        ScadaGatherConfLogView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetScadaGatherConfLogViewOutput output = new GetScadaGatherConfLogViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryScadaGatherConfLogViewOutput> queryScadaGatherConfLogView(XContext context, QueryScadaGatherConfLogViewInput input){
        ScadaGatherConfLogViewMapper mapper = context.getBean(ScadaGatherConfLogViewMapper.class);
        ScadaGatherConfLogView record = new ScadaGatherConfLogView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<ScadaGatherConfLogView> list = mapper.selectList(record);
        PageInfo<ScadaGatherConfLogView> pageInfo = new PageInfo<>(list);
        List<QueryScadaGatherConfLogViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryScadaGatherConfLogViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
