package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.scada_gather_data.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class ScadaGatherDataService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createScadaGatherData(XContext context, CreateScadaGatherDataInput input){
        ScadaGatherDataMapper mapper = context.getBean(ScadaGatherDataMapper.class);
        ScadaGatherDataEnt entity = new ScadaGatherDataEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateScadaGatherData(XContext context, UpdateScadaGatherDataInput input){
        ScadaGatherDataMapper mapper = context.getBean(ScadaGatherDataMapper.class);
        QueryWrapper<ScadaGatherDataEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherDataEnt::getId, input.getId());
        ScadaGatherDataEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteScadaGatherData(XContext context, DeleteScadaGatherDataInput input){
        ScadaGatherDataMapper mapper = context.getBean(ScadaGatherDataMapper.class);
        QueryWrapper<ScadaGatherDataEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherDataEnt::getId, input.getId());
        ScadaGatherDataEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetScadaGatherDataOutput> getScadaGatherData(XContext context, GetScadaGatherDataInput input){
        ScadaGatherDataMapper mapper = context.getBean(ScadaGatherDataMapper.class);
        QueryWrapper<ScadaGatherDataEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherDataEnt::getId, input.getId());
        ScadaGatherDataEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetScadaGatherDataOutput output = new GetScadaGatherDataOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryScadaGatherDataOutput> queryScadaGatherData(XContext context, QueryScadaGatherDataInput input){
        ScadaGatherDataMapper mapper = context.getBean(ScadaGatherDataMapper.class);
        QueryWrapper<ScadaGatherDataEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(ScadaGatherDataEnt::getId, input.getId())
            .like(ScadaGatherDataEnt::getScadaGatherConfId, input.getScadaGatherConfId())
            .like(ScadaGatherDataEnt::getScadaTag, input.getScadaTag())
            .like(ScadaGatherDataEnt::getTagValue, input.getTagValue())
            .eq(ScadaGatherDataEnt::getTagTime, input.getTagTime())
            .eq(ScadaGatherDataEnt::getIsSync, input.getIsSync());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryScadaGatherDataOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryScadaGatherDataOutput> dynamicQueryScadaGatherData(XContext context, CustomQueryInput input){
        ScadaGatherDataMapper mapper = context.getBean(ScadaGatherDataMapper.class);
        return XMapperHelper.query(mapper, input, ScadaGatherDataEnt.class, QueryScadaGatherDataOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetScadaGatherDataViewOutput> getScadaGatherDataView(XContext context, GetScadaGatherDataViewInput input){
        ScadaGatherDataViewMapper mapper = context.getBean(ScadaGatherDataViewMapper.class);
        ScadaGatherDataView record = new ScadaGatherDataView();
        XCopyUtils.copyObject(input, record);
        ScadaGatherDataView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetScadaGatherDataViewOutput output = new GetScadaGatherDataViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryScadaGatherDataViewOutput> queryScadaGatherDataView(XContext context, QueryScadaGatherDataViewInput input){
        ScadaGatherDataViewMapper mapper = context.getBean(ScadaGatherDataViewMapper.class);
        ScadaGatherDataView record = new ScadaGatherDataView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<ScadaGatherDataView> list = mapper.selectList(record);
        PageInfo<ScadaGatherDataView> pageInfo = new PageInfo<>(list);
        List<QueryScadaGatherDataViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryScadaGatherDataViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
