package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.scada_gather_manual_conf.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import pps.core.common.session.PpsUserSession;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
@XText("scada手动采集配置")
public class ScadaGatherManualConfService {

    @XText("新增采集配置")
    @XApiPost
    public XServiceResult createScadaGatherManualConf(XContext context, CreateScadaGatherManualConfInput input){
        ScadaGatherManualConfMapper mapper = context.getBean(ScadaGatherManualConfMapper.class);
        ScadaGatherManualConfEnt entity = new ScadaGatherManualConfEnt();
        XCopyUtils.copyObject(input, entity);
        PpsUserSession session = context.getSession(PpsUserSession.class);
        entity.setCreateById(session.getId());
        entity.setCreateTime(new Date());
        entity.setCreateByName(session.getUserName());
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiPost
    public XServiceResult updateScadaGatherManualConf(XContext context, UpdateScadaGatherManualConfInput input){
        ScadaGatherManualConfMapper mapper = context.getBean(ScadaGatherManualConfMapper.class);
        QueryWrapper<ScadaGatherManualConfEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherManualConfEnt::getId, input.getId());
        ScadaGatherManualConfEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteScadaGatherManualConf(XContext context, DeleteScadaGatherManualConfInput input){
        ScadaGatherManualConfMapper mapper = context.getBean(ScadaGatherManualConfMapper.class);
        QueryWrapper<ScadaGatherManualConfEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherManualConfEnt::getId, input.getId());
        ScadaGatherManualConfEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetScadaGatherManualConfOutput> getScadaGatherManualConf(XContext context, GetScadaGatherManualConfInput input){
        ScadaGatherManualConfMapper mapper = context.getBean(ScadaGatherManualConfMapper.class);
        QueryWrapper<ScadaGatherManualConfEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ScadaGatherManualConfEnt::getId, input.getId());
        ScadaGatherManualConfEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetScadaGatherManualConfOutput output = new GetScadaGatherManualConfOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }


    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetScadaGatherManualConfViewOutput> getScadaGatherManualConfView(XContext context, GetScadaGatherManualConfViewInput input){
        ScadaGatherManualConfViewMapper mapper = context.getBean(ScadaGatherManualConfViewMapper.class);
        ScadaGatherManualConfView record = new ScadaGatherManualConfView();
        XCopyUtils.copyObject(input, record);
        ScadaGatherManualConfView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetScadaGatherManualConfViewOutput output = new GetScadaGatherManualConfViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryScadaGatherManualConfViewOutput> queryScadaGatherManualConfView(XContext context, QueryScadaGatherManualConfViewInput input){
        ScadaGatherManualConfViewMapper mapper = context.getBean(ScadaGatherManualConfViewMapper.class);
        ScadaGatherManualConfView record = new ScadaGatherManualConfView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<ScadaGatherManualConfView> list = mapper.selectList(record);
        PageInfo<ScadaGatherManualConfView> pageInfo = new PageInfo<>(list);
        List<QueryScadaGatherManualConfViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryScadaGatherManualConfViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
