package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.google.common.base.Strings;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.view_metering_equipment_ledger.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import xstartup.feature.mybatis.helper.XMapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class ViewMeteringEquipmentLedgerService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createViewMeteringEquipmentLedger(XContext context, CreateViewMeteringEquipmentLedgerInput input){
        ViewMeteringEquipmentLedgerMapper mapper = context.getBean(ViewMeteringEquipmentLedgerMapper.class);
        ViewMeteringEquipmentLedgerEnt entity = new ViewMeteringEquipmentLedgerEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateViewMeteringEquipmentLedger(XContext context, UpdateViewMeteringEquipmentLedgerInput input){
        ViewMeteringEquipmentLedgerMapper mapper = context.getBean(ViewMeteringEquipmentLedgerMapper.class);
        QueryWrapper<ViewMeteringEquipmentLedgerEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ViewMeteringEquipmentLedgerEnt::getId, input.getId());
        ViewMeteringEquipmentLedgerEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteViewMeteringEquipmentLedger(XContext context, DeleteViewMeteringEquipmentLedgerInput input){
        ViewMeteringEquipmentLedgerMapper mapper = context.getBean(ViewMeteringEquipmentLedgerMapper.class);
        QueryWrapper<ViewMeteringEquipmentLedgerEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ViewMeteringEquipmentLedgerEnt::getId, input.getId());
        ViewMeteringEquipmentLedgerEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetViewMeteringEquipmentLedgerOutput> getViewMeteringEquipmentLedger(XContext context, GetViewMeteringEquipmentLedgerInput input){
        ViewMeteringEquipmentLedgerMapper mapper = context.getBean(ViewMeteringEquipmentLedgerMapper.class);
        QueryWrapper<ViewMeteringEquipmentLedgerEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ViewMeteringEquipmentLedgerEnt::getId, input.getId());
        ViewMeteringEquipmentLedgerEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetViewMeteringEquipmentLedgerOutput output = new GetViewMeteringEquipmentLedgerOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiPost
    public XPageResult<QueryViewMeteringEquipmentLedgerOutput> queryViewMeteringEquipmentLedger(XContext context, QueryViewMeteringEquipmentLedgerInput input){
        ViewMeteringEquipmentLedgerMapper mapper = context.getBean(ViewMeteringEquipmentLedgerMapper.class);
        QueryWrapper<ViewMeteringEquipmentLedgerEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(!Strings.isNullOrEmpty(input.getEnterprieName()),ViewMeteringEquipmentLedgerEnt::getEnterprieName, input.getEnterprieName())
                .like(!Strings.isNullOrEmpty(input.getSubunitName()),ViewMeteringEquipmentLedgerEnt::getSubunitName, input.getSubunitName())
                .like(!Strings.isNullOrEmpty(input.getStationName()),ViewMeteringEquipmentLedgerEnt::getStationName, input.getStationName())
                .like(!Strings.isNullOrEmpty(input.getPipelineName()),ViewMeteringEquipmentLedgerEnt::getPipelineName, input.getPipelineName())
                .like(!Strings.isNullOrEmpty(input.getCustomerName()),ViewMeteringEquipmentLedgerEnt::getCustomerName, input.getCustomerName())
                .like(!Strings.isNullOrEmpty(input.getProductionNumber()),ViewMeteringEquipmentLedgerEnt::getProductionNumber, input.getProductionNumber())
                .like(!Strings.isNullOrEmpty(input.getEquipmentName()),ViewMeteringEquipmentLedgerEnt::getEquipmentName, input.getEquipmentName())
                .like(!Strings.isNullOrEmpty(input.getEquipmentType()),ViewMeteringEquipmentLedgerEnt::getEquipmentType, input.getEquipmentType())
                .like(!Strings.isNullOrEmpty(input.getMediumType()),ViewMeteringEquipmentLedgerEnt::getMediumType, input.getMediumType());

        return XMapperHelper.query(mapper, input, queryWrapper, QueryViewMeteringEquipmentLedgerOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryViewMeteringEquipmentLedgerOutput> dynamicQueryViewMeteringEquipmentLedger(XContext context, CustomQueryInput input){
        ViewMeteringEquipmentLedgerMapper mapper = context.getBean(ViewMeteringEquipmentLedgerMapper.class);
        return XMapperHelper.query(mapper, input, ViewMeteringEquipmentLedgerEnt.class, QueryViewMeteringEquipmentLedgerOutput.class);
    }

    @XApiAnonymous
    @XApiPost
    public XSingleResult<GetViewMeteringEquipmentLedgerViewOutput> getViewMeteringEquipmentLedgerView(XContext context, GetViewMeteringEquipmentLedgerViewInput input){
        ViewMeteringEquipmentLedgerViewMapper mapper = context.getBean(ViewMeteringEquipmentLedgerViewMapper.class);
        ViewMeteringEquipmentLedgerView record = new ViewMeteringEquipmentLedgerView();
        XCopyUtils.copyObject(input, record);
        ViewMeteringEquipmentLedgerView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetViewMeteringEquipmentLedgerViewOutput output = new GetViewMeteringEquipmentLedgerViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiPost
    public XPageResult<QueryViewMeteringEquipmentLedgerViewOutput> queryViewMeteringEquipmentLedgerView(XContext context, QueryViewMeteringEquipmentLedgerViewInput input){
        ViewMeteringEquipmentLedgerViewMapper mapper = context.getBean(ViewMeteringEquipmentLedgerViewMapper.class);
        ViewMeteringEquipmentLedgerView record = new ViewMeteringEquipmentLedgerView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<ViewMeteringEquipmentLedgerView> list = mapper.selectList(record);
        PageInfo<ViewMeteringEquipmentLedgerView> pageInfo = new PageInfo<>(list);
        List<QueryViewMeteringEquipmentLedgerViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryViewMeteringEquipmentLedgerViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
