package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.view_metering_station_customer.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import xstartup.feature.mybatis.helper.XMapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class ViewMeteringStationCustomerService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createViewMeteringStationCustomer(XContext context, CreateViewMeteringStationCustomerInput input){
        ViewMeteringStationCustomerMapper mapper = context.getBean(ViewMeteringStationCustomerMapper.class);
        ViewMeteringStationCustomerEnt entity = new ViewMeteringStationCustomerEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateViewMeteringStationCustomer(XContext context, UpdateViewMeteringStationCustomerInput input){
        ViewMeteringStationCustomerMapper mapper = context.getBean(ViewMeteringStationCustomerMapper.class);
        QueryWrapper<ViewMeteringStationCustomerEnt> queryWrapper = new QueryWrapper<>();
        //queryWrapper.lambda().eq(ViewMeteringStationCustomerEnt::getId, input.getId());
        ViewMeteringStationCustomerEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteViewMeteringStationCustomer(XContext context, DeleteViewMeteringStationCustomerInput input){
        ViewMeteringStationCustomerMapper mapper = context.getBean(ViewMeteringStationCustomerMapper.class);
        QueryWrapper<ViewMeteringStationCustomerEnt> queryWrapper = new QueryWrapper<>();
        //queryWrapper.lambda().eq(ViewMeteringStationCustomerEnt::getId, input.getId());
        ViewMeteringStationCustomerEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetViewMeteringStationCustomerOutput> getViewMeteringStationCustomer(XContext context, GetViewMeteringStationCustomerInput input){
        ViewMeteringStationCustomerMapper mapper = context.getBean(ViewMeteringStationCustomerMapper.class);
        QueryWrapper<ViewMeteringStationCustomerEnt> queryWrapper = new QueryWrapper<>();
        //queryWrapper.lambda().eq(ViewMeteringStationCustomerEnt::getId, input.getId());
        ViewMeteringStationCustomerEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetViewMeteringStationCustomerOutput output = new GetViewMeteringStationCustomerOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryViewMeteringStationCustomerOutput> queryViewMeteringStationCustomer(XContext context, QueryViewMeteringStationCustomerInput input){
        ViewMeteringStationCustomerMapper mapper = context.getBean(ViewMeteringStationCustomerMapper.class);
        QueryWrapper<ViewMeteringStationCustomerEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(ViewMeteringStationCustomerEnt::getPipelineId, input.getPipelineId())
            .like(ViewMeteringStationCustomerEnt::getPipelineName, input.getPipelineName())
            .like(ViewMeteringStationCustomerEnt::getStationId, input.getStationId())
            .like(ViewMeteringStationCustomerEnt::getStationName, input.getStationName())
            .like(ViewMeteringStationCustomerEnt::getClientId, input.getClientId())
            .like(ViewMeteringStationCustomerEnt::getClientShortAme, input.getClientShortAme())
            .like(ViewMeteringStationCustomerEnt::getClientName, input.getClientName());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryViewMeteringStationCustomerOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryViewMeteringStationCustomerOutput> dynamicQueryViewMeteringStationCustomer(XContext context, CustomQueryInput input){
        ViewMeteringStationCustomerMapper mapper = context.getBean(ViewMeteringStationCustomerMapper.class);
        return XMapperHelper.query(mapper, input, ViewMeteringStationCustomerEnt.class, QueryViewMeteringStationCustomerOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetViewMeteringStationCustomerViewOutput> getViewMeteringStationCustomerView(XContext context, GetViewMeteringStationCustomerViewInput input){
        ViewMeteringStationCustomerViewMapper mapper = context.getBean(ViewMeteringStationCustomerViewMapper.class);
        ViewMeteringStationCustomerView record = new ViewMeteringStationCustomerView();
        XCopyUtils.copyObject(input, record);
        ViewMeteringStationCustomerView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetViewMeteringStationCustomerViewOutput output = new GetViewMeteringStationCustomerViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryViewMeteringStationCustomerViewOutput> queryViewMeteringStationCustomerView(XContext context, QueryViewMeteringStationCustomerViewInput input){
        ViewMeteringStationCustomerViewMapper mapper = context.getBean(ViewMeteringStationCustomerViewMapper.class);
        ViewMeteringStationCustomerView record = new ViewMeteringStationCustomerView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<ViewMeteringStationCustomerView> list = mapper.selectList(record);
        PageInfo<ViewMeteringStationCustomerView> pageInfo = new PageInfo<>(list);
        List<QueryViewMeteringStationCustomerViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryViewMeteringStationCustomerViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
