package pps.core.base.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.base.mapper.*;
import pps.core.base.entity.*;
import pps.core.base.service.data.view_metering_verfication_info.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import xstartup.feature.mybatis.helper.XMapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class ViewMeteringVerficationInfoService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createViewMeteringVerficationInfo(XContext context, CreateViewMeteringVerficationInfoInput input){
        ViewMeteringVerficationInfoMapper mapper = context.getBean(ViewMeteringVerficationInfoMapper.class);
        ViewMeteringVerficationInfoEnt entity = new ViewMeteringVerficationInfoEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateViewMeteringVerficationInfo(XContext context, UpdateViewMeteringVerficationInfoInput input){
        ViewMeteringVerficationInfoMapper mapper = context.getBean(ViewMeteringVerficationInfoMapper.class);
        QueryWrapper<ViewMeteringVerficationInfoEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ViewMeteringVerficationInfoEnt::getId, input.getId());
        ViewMeteringVerficationInfoEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteViewMeteringVerficationInfo(XContext context, DeleteViewMeteringVerficationInfoInput input){
        ViewMeteringVerficationInfoMapper mapper = context.getBean(ViewMeteringVerficationInfoMapper.class);
        QueryWrapper<ViewMeteringVerficationInfoEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ViewMeteringVerficationInfoEnt::getId, input.getId());
        ViewMeteringVerficationInfoEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetViewMeteringVerficationInfoOutput> getViewMeteringVerficationInfo(XContext context, GetViewMeteringVerficationInfoInput input){
        ViewMeteringVerficationInfoMapper mapper = context.getBean(ViewMeteringVerficationInfoMapper.class);
        QueryWrapper<ViewMeteringVerficationInfoEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ViewMeteringVerficationInfoEnt::getId, input.getId());
        ViewMeteringVerficationInfoEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetViewMeteringVerficationInfoOutput output = new GetViewMeteringVerficationInfoOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiPost
    public XPageResult<QueryViewMeteringVerficationInfoOutput> queryViewMeteringVerficationInfo(XContext context, QueryViewMeteringVerficationInfoInput input){
        ViewMeteringVerficationInfoMapper mapper = context.getBean(ViewMeteringVerficationInfoMapper.class);
        QueryWrapper<ViewMeteringVerficationInfoEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda()
//                .eq(ViewMeteringVerficationInfoEnt::getId, input.getId())
            .eq(ViewMeteringVerficationInfoEnt::getEquipmentId, input.getEquipmentId());
//            .like(ViewMeteringVerficationInfoEnt::getVUint, input.getVUint())
//            .eq(ViewMeteringVerficationInfoEnt::getVDate, input.getVDate())
//            .eq(ViewMeteringVerficationInfoEnt::getVResult, input.getVResult())
//            .eq(ViewMeteringVerficationInfoEnt::getVType, input.getVType())
//            .eq(ViewMeteringVerficationInfoEnt::getVMethod, input.getVMethod())
//            .like(ViewMeteringVerficationInfoEnt::getVCertificateNumber, input.getVCertificateNumber())
//            .like(ViewMeteringVerficationInfoEnt::getVOverdueCause, input.getVOverdueCause())
//            .like(ViewMeteringVerficationInfoEnt::getWorkflowId, input.getWorkflowId())
//            .eq(ViewMeteringVerficationInfoEnt::getAuditStatus, input.getAuditStatus())
//            .like(ViewMeteringVerficationInfoEnt::getCreaterId, input.getCreaterId())
//            .like(ViewMeteringVerficationInfoEnt::getCreater, input.getCreater())
//            .eq(ViewMeteringVerficationInfoEnt::getCreateDate, input.getCreateDate())
//            .like(ViewMeteringVerficationInfoEnt::getVMethodName, input.getVMethodName())
//            .like(ViewMeteringVerficationInfoEnt::getVResultName, input.getVResultName())
//            .like(ViewMeteringVerficationInfoEnt::getVTypeName, input.getVTypeName());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryViewMeteringVerficationInfoOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryViewMeteringVerficationInfoOutput> dynamicQueryViewMeteringVerficationInfo(XContext context, CustomQueryInput input){
        ViewMeteringVerficationInfoMapper mapper = context.getBean(ViewMeteringVerficationInfoMapper.class);
        return XMapperHelper.query(mapper, input, ViewMeteringVerficationInfoEnt.class, QueryViewMeteringVerficationInfoOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetViewMeteringVerficationInfoViewOutput> getViewMeteringVerficationInfoView(XContext context, GetViewMeteringVerficationInfoViewInput input){
        ViewMeteringVerficationInfoViewMapper mapper = context.getBean(ViewMeteringVerficationInfoViewMapper.class);
        ViewMeteringVerficationInfoView record = new ViewMeteringVerficationInfoView();
        XCopyUtils.copyObject(input, record);
        ViewMeteringVerficationInfoView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetViewMeteringVerficationInfoViewOutput output = new GetViewMeteringVerficationInfoViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryViewMeteringVerficationInfoViewOutput> queryViewMeteringVerficationInfoView(XContext context, QueryViewMeteringVerficationInfoViewInput input){
        ViewMeteringVerficationInfoViewMapper mapper = context.getBean(ViewMeteringVerficationInfoViewMapper.class);
        ViewMeteringVerficationInfoView record = new ViewMeteringVerficationInfoView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<ViewMeteringVerficationInfoView> list = mapper.selectList(record);
        PageInfo<ViewMeteringVerficationInfoView> pageInfo = new PageInfo<>(list);
        List<QueryViewMeteringVerficationInfoViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryViewMeteringVerficationInfoViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
