package pps.core.task.job;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import pps.cloud.scadapi.service.ScadaPiService;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.data.XServiceResult;
import xstartup.service.job.XJob;
import xstartup.service.job.annotation.XCronTrigger;

/**
 * @Title： [标题] 预处理Job
 * @Description: [功能描述]
 * @author：lyy
 */

@XText("默认值同步sql预处理")
@XService
public class DataPreproccessJob implements XJob {
    private static Logger logger = LoggerFactory.getLogger(DataPreproccessJob.class);

    @XCronTrigger(value = "0 10 0 * * ?")
    @Override
    public XServiceResult execute(XContext xContext) {
        logger.info("默认值同步sql预处理开始");
        ScadaPiService service = xContext.getBean(ScadaPiService.class);
        service.syncDataPreproccess(xContext);
        logger.info("默认值同步sql预处理结束 ");
        return XServiceResult.OK;
    }
}
