package pps.core.task.job;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import pps.cloud.scadapi.service.ScadaPiService;
import pps.cloud.scadapi.service.data.FindByPidInput;
import pps.cloud.scadapi.service.data.GetTagsInput;
import xstartup.annotation.XService;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.data.XServiceResult;
import xstartup.service.job.XJob;
import xstartup.service.job.annotation.XCronTrigger;

import java.text.SimpleDateFormat;
import java.util.*;

@XText("SCADAPI Tag点号 数据同步")
@XService
public class ScadaPiJob implements XJob {

    private static Logger logger = LoggerFactory.getLogger(ScadaPiJob.class);

    @Override
    @XCronTrigger(value = "0 0 2,15,23 * * ?")
    public XServiceResult execute(XContext context) {
        logger.info("SCADAPI Tag点号 数据同步 每天早上2点 晚上23点执行");
        ScadaPiService service = context.getBean(ScadaPiService.class);
        GetTagsInput input = new GetTagsInput();
        Date current = new Date();
        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        input.setEndDate(formatter.format(current));
        Calendar calendar = new GregorianCalendar();
        calendar.add(Calendar.DATE, -1);
        input.setStartDate(formatter.format(calendar.getTime()));

        service.syncScadaTags(context,input);
        context.getLogger().debug("SCADAPI Tag点号 数据同步 每天早上2点 晚上23点执行");
        return XServiceResult.OK;
    }
}
