package app;

//import pps.core.common.job.CounterJob;
import pps.core.common.utils.CounterBuilder;
import pps.core.task.job.*;
import xstartup.base.XStartup;
import xstartup.base.conf.XServerConf;
import xstartup.base.conf.XServiceConf;
import xstartup.base.util.XEncryptUtils;
import xstartup.boot.XStartupApplication;
import xstartup.feature.XJobFeature;
import xstartup.feature.api.XApiFeature;
import xstartup.feature.api.conf.XApiCookieConf;
import xstartup.feature.cloud.XCloudHuaweiCseFeature;
import xstartup.feature.cloud.conf.XCloudBundle;
import xstartup.feature.cloud.conf.XCloudBundlesConf;
import xstartup.feature.cors.XCorsFeature;
import xstartup.feature.mybatis.XMybatisFeature;
import xstartup.feature.rpc.XRpcFeature;
import xstartup.service.job.conf.XJobServiceConf;

public class DeployPpsTaskApplication {
    public static void main(String... args) {

        CounterBuilder.globalCounterBuilder.setFieldValue(CounterBuilder.DEPLOY_KEY, DeployPpsTaskApplication.class.getSimpleName());
        XStartup startup = new XStartupApplication("pps");
        startup.config(new XServerConf(22062).naming("pps-task"))
                .config(new XServiceConf("pps"));
        startup.enable(XApiFeature.class)
                .config(new XApiCookieConf("%4bH8s9&",43200));
        startup.enable(XCorsFeature.class);
        startup.enable(XMybatisFeature.class);
        startup.enable(XJobFeature.class).config(new XJobServiceConf(MeasureJob.class));
//        startup.enable(XJobFeature.class).config(new XJobServiceConf(CounterJob.class));
       startup.enable(XJobFeature.class).config(new XJobServiceConf(TestTaskJob.class));
       startup.enable(XJobFeature.class).config(new XJobServiceConf(AccessLogConsumeJob.class));
       startup.enable(XJobFeature.class).config(new XJobServiceConf(MdmJob.class));
       startup.enable(XJobFeature.class).config(new XJobServiceConf(NgOnDutyMatJob.class));
       //startup.enable(XJobFeature.class).config(new XJobServiceConf(DispTaskPlanCountdownHoursJob.class));
       //startup.enable(XJobFeature.class).config(new XJobServiceConf(ImsJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(ScadaPiJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(ScadaPiDataJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(ScadaPiDataDayJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(ScadaPiDataOilAmountJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(TransferRzdRetryJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(SmsTimingSendJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(OndutySmsTimingSendJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(DataPreproccessJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(SyncBaseInfoJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(TaskPlanImsJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(TaskPlanAckImsJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(TaskPlanTransferJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(ScadaPiDataDayComJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(TradeSyncDataFirstJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(ScadaPiDataTwoHourJob.class));
        startup.enable(XJobFeature.class).config(new XJobServiceConf(ScadaPiDataFourHourJob.class));

        startup.enable(XRpcFeature.class);
        startup.enable(XCloudHuaweiCseFeature.class)
                .config(XCloudBundlesConf.with(
//                        XCloudBundle.naming("pps-workflow").addModule("pps", "cloud", "task"),
                        XCloudBundle.naming("pps-interface").addModule("pps", "cloud", "mdm"),
                        XCloudBundle.naming("pps-interface").addModule("pps", "cloud", "ims"),
                        XCloudBundle.naming("pps-interface").addModule("pps", "cloud", "measure"),
                        XCloudBundle.naming("pps-interface").addModule("pps", "cloud", "transfer"),
                        XCloudBundle.naming("pps-interface").addModule("pps", "cloud", "scadapi"),
                        XCloudBundle.naming("pps-base-info").addModule("pps", "cloud", "system"),
                        XCloudBundle.naming("pps-interface").addModule("pps", "cloud", "trade"),
                        XCloudBundle.naming("pps-dispatch").addModule("pps", "cloud", "dispatch"),
                        XCloudBundle.naming("pps-base-info").addModule("pps", "cloud", "base")));

        startup.run(args);
    }
}
