-- pps_base_info
ALTER TABLE pps_base_info.sys_menu ADD menu_pattern varchar NULL;
COMMENT ON COLUMN pps_base_info.sys_menu.menu_pattern IS '菜单模式';
ALTER TABLE pps_base_info.sys_menu ALTER COLUMN menu_name TYPE varchar(200) USING menu_name::varchar;

ALTER TABLE pps_base_info.sys_role ALTER COLUMN role_name TYPE varchar USING role_name::varchar;
ALTER TABLE pps_base_info.scada_gather_conf ADD sort int2 NULL;
COMMENT ON COLUMN pps_base_info.scada_gather_conf.sort IS '序号';
ALTER TABLE pps_base_info.scada_environment_info ADD en_type varchar NULL;
COMMENT ON COLUMN pps_base_info.scada_environment_info.en_type IS '环境类型（1-生产；2-测试；3-灾备）';
ALTER TABLE pps_base_info.scada_environment_info ADD is_enable bool NULL;
COMMENT ON COLUMN pps_base_info.scada_environment_info.is_enable IS 'true:启动;false:禁用';
ALTER TABLE pps_base_info.scada_environment_info ADD client_ip varchar NULL;
COMMENT ON COLUMN pps_base_info.scada_environment_info.client_ip IS '客户端ip';
ALTER TABLE pps_base_info.scada_environment_info ADD client_port int8 NULL;
COMMENT ON COLUMN pps_base_info.scada_environment_info.client_port IS '客户端端口';


-- pps_base_frame
ALTER TABLE pps_base_frame.form_workflow_rel ADD sync_interim_pps int1 NULL;
COMMENT ON COLUMN pps_base_frame.form_workflow_rel.sync_interim_pps IS '是否同步过渡期';
ALTER TABLE pps_base_info.scada_gather_conf_in ADD param_code varchar NULL;
COMMENT ON COLUMN pps_base_info.scada_gather_conf_in.param_code IS '参数列名';
ALTER TABLE pps_base_info.scada_gather_conf_in ADD param_type varchar NULL;
COMMENT ON COLUMN pps_base_info.scada_gather_conf_in.param_type IS '参数类型 1-字典；2-固定值';
ALTER TABLE pps_base_frame.form_data_box_detail ADD compute_way varchar NULL;
COMMENT ON COLUMN pps_base_frame.form_data_box_detail.compute_way IS '计算方式（字典）';
ALTER TABLE pps_base_frame.form_data_box_detail ADD compute_coefficient int4 NULL;
COMMENT ON COLUMN pps_base_frame.form_data_box_detail.compute_coefficient IS '计算系数';
ALTER TABLE pps_base_frame.form_fill_conf ADD show_home bool NULL;
COMMENT ON COLUMN pps_base_frame.form_fill_conf.show_home IS '首页展示。true:展示；false:不展示';
COMMENT ON COLUMN pps_base_frame.form_fill_conf.id IS '主键id';
COMMENT ON COLUMN pps_base_frame.form_fill_conf.business_type IS '业务类型';
COMMENT ON COLUMN pps_base_frame.form_fill_conf.media_type IS '介质类型';
COMMENT ON COLUMN pps_base_frame.form_fill_conf.data_source IS '业务模块';
COMMENT ON COLUMN pps_base_frame.form_fill_conf.fun_name IS '存储过程名称';
COMMENT ON COLUMN pps_base_frame.form_fill_conf.fun_describe IS '存储过程描述';
COMMENT ON COLUMN pps_base_frame.form_fill_conf.freq_front_number IS '正式填报页展示天数（当前日期之前）';
COMMENT ON COLUMN pps_base_frame.form_fill_conf.freq_latter_number IS '正式填报页展示天数（当前日期之后）';
COMMENT ON COLUMN pps_base_frame.form_fill_conf.fill_conf_name IS '填报配置名称';
COMMENT ON COLUMN pps_base_frame.form_fill_conf.freq IS '周期';
ALTER TABLE pps_base_frame.form_fill_conf ADD home_front_number int4 NULL;
COMMENT ON COLUMN pps_base_frame.form_fill_conf.home_front_number IS '首页展示天数（当前日期之前）';
ALTER TABLE pps_base_frame.form_fill_conf ADD home_latter_number int4 NULL;
COMMENT ON COLUMN pps_base_frame.form_fill_conf.home_latter_number IS '首页展示天数（当前日期之后）';
COMMENT ON COLUMN pps_base_frame.form_fill_conf_sub.fun_out_param IS '存储过程输出名称';
COMMENT ON COLUMN pps_base_frame.form_fill_conf_sub.is_show IS '是否展示';
COMMENT ON COLUMN pps_base_frame.form_fill_conf_sub.fun_out_param_name IS '存储过程输出描述';
COMMENT ON COLUMN pps_base_frame.form_fill_conf_sub.column_width IS '列宽';
COMMENT ON COLUMN pps_base_frame.form_fill_conf_sub.sort IS '排序';
COMMENT ON COLUMN pps_base_frame.form_fill_conf_sub.is_query_condition IS '是否为查询条件';
COMMENT ON COLUMN pps_base_frame.form_fill_conf_sub.form_fill_conf_id IS 'form_fill_conf_id表id';
ALTER TABLE pps_base_frame.form_fill_conf_sub ADD show_home bool NULL;
COMMENT ON COLUMN pps_base_frame.form_fill_conf_sub.show_home IS '首页展示';
ALTER TABLE pps_base_frame.form_fill_conf ADD alias_name varchar NULL;
COMMENT ON COLUMN pps_base_frame.form_fill_conf.alias_name IS '别名';
ALTER TABLE pps_base_frame.form_fill_conf ADD sort int4 NULL;
COMMENT ON COLUMN pps_base_frame.form_fill_conf.sort IS '序号';





-- pps_measure
ALTER TABLE pps_measure.crude_voucher_metalcans ADD scene_temp_before numeric(20, 8) NULL;
COMMENT ON COLUMN pps_measure.crude_voucher_metalcans.scene_temp_before IS '现场温变温度前';
ALTER TABLE pps_measure.crude_voucher_metalcans ADD scene_temp_after numeric(20, 8) NULL;
COMMENT ON COLUMN pps_measure.crude_voucher_metalcans.scene_temp_after IS '现场温变温度后';

ALTER TABLE pps_measure.gas_voucher ADD transfer_id varchar(50) NULL;
COMMENT ON COLUMN pps_measure.gas_voucher.transfer_id IS '中转单位id';
ALTER TABLE pps_measure.gas_voucher ADD transfer_name varchar(50) NULL;
COMMENT ON COLUMN pps_measure.gas_voucher.transfer_name IS '中转单位名称';

ALTER TABLE pps_measure.crude_voucher_three ADD m_measure_time varchar(50) NULL;
COMMENT ON COLUMN pps_measure.crude_voucher_three.m_measure_time IS '早计量时间段';
ALTER TABLE pps_measure.crude_voucher_three ADD n_measure_time varchar(50) NULL;
COMMENT ON COLUMN pps_measure.crude_voucher_three.n_measure_time IS '中计量时间段';
ALTER TABLE pps_measure.crude_voucher_three ADD e_measure_time varchar(50) NULL;
COMMENT ON COLUMN pps_measure.crude_voucher_three.e_measure_time IS '晚计量时间段';
ALTER TABLE pps_measure.cpy_voucher_sale ADD filling_date smalldatetime NULL;
COMMENT ON COLUMN pps_measure.cpy_voucher_sale.filling_date IS '填报日期';
ALTER TABLE pps_measure.cpy_voucher_sale ADD equipment_verification_flow_mf1 varchar NULL;
COMMENT ON COLUMN pps_measure.cpy_voucher_sale.equipment_verification_flow_mf1 IS '流量计检定-平均流量MF1';
ALTER TABLE pps_measure.cpy_voucher_sale ADD equipment_verification_flow_mf2 varchar NULL;
COMMENT ON COLUMN pps_measure.cpy_voucher_sale.equipment_verification_flow_mf2 IS '流量计检定-平均流量MF2';
ALTER TABLE pps_measure.cpy_voucher_sale ADD equipment_verification_flow_mf3 varchar NULL;
COMMENT ON COLUMN pps_measure.cpy_voucher_sale.equipment_verification_flow_mf3 IS '流量计检定-平均流量MF3';
ALTER TABLE pps_measure.cpy_voucher_metalcans_receive  ADD filling_date smalldatetime NULL;
COMMENT ON COLUMN pps_measure.cpy_voucher_metalcans_receive.filling_date IS '填报日期';
ALTER TABLE pps_measure.cpy_voucher_metalcans_sale  ADD filling_date smalldatetime NULL;
COMMENT ON COLUMN pps_measure.cpy_voucher_metalcans_sale.filling_date IS '填报日期';
ALTER TABLE pps_measure.cpy_voucher_sale RENAME COLUMN oil_code TO oil_type;
COMMENT ON COLUMN pps_measure.cpy_voucher_sale.oil_type IS '油品类型';
ALTER TABLE pps_measure.cpy_voucher_sale DROP COLUMN oil_name;
ALTER TABLE pps_measure.cpy_voucher_metalcans_sale RENAME COLUMN oil_code TO oil_type;
COMMENT ON COLUMN pps_measure.cpy_voucher_metalcans_sale.oil_type IS '油品类型';
ALTER TABLE pps_measure.cpy_voucher_metalcans_sale DROP COLUMN oil_name;
ALTER TABLE pps_measure.cpy_voucher_metalcans_receive RENAME COLUMN oil_code TO oil_type;
COMMENT ON COLUMN pps_measure.cpy_voucher_metalcans_receive.oil_type IS '油品类型';
ALTER TABLE pps_measure.cpy_voucher_metalcans_receive DROP COLUMN oil_name;
ALTER TABLE pps_measure.cpy_voucher_equipment_sale RENAME COLUMN oil_code TO oil_type;
COMMENT ON COLUMN pps_measure.cpy_voucher_equipment_sale.oil_type IS '油品类型';
ALTER TABLE pps_measure.cpy_voucher_equipment_sale DROP COLUMN oil_name;
ALTER TABLE pps_measure.cpy_voucher_equipment_receive RENAME COLUMN oil_code TO oil_type;
COMMENT ON COLUMN pps_measure.cpy_voucher_equipment_receive.oil_type IS '油品类型';
ALTER TABLE pps_measure.cpy_voucher_equipment_receive DROP COLUMN oil_name;
ALTER TABLE pps_measure.cpy_voucher_equipment_common RENAME COLUMN oil_code TO oil_type;
COMMENT ON COLUMN pps_measure.cpy_voucher_equipment_common.oil_type IS '油品类型';
ALTER TABLE pps_measure.cpy_voucher_equipment_common DROP COLUMN oil_name;
ALTER TABLE pps_measure.crude_voucher_single  ADD m_value_type varchar(50) NULL;
ALTER TABLE pps_measure.crude_voucher_single_receive  ADD m_value_type varchar(50) NULL;
ALTER TABLE pps_measure.crude_voucher_three  ADD m_value_type varchar(50) NULL;
ALTER TABLE pps_measure.crude_voucher_three  ADD n_value_type varchar(50) NULL;
ALTER TABLE pps_measure.crude_voucher_three  ADD e_value_type varchar(50) NULL;


-- pps_interface
ALTER TABLE pps_interface.config_data_define_white ADD "type" varchar(50) NULL;
COMMENT ON COLUMN pps_interface.config_data_define_white."type" IS '类型：rjl(日指令)、jljj(计量交接)';


-- pps_workflow
ALTER TABLE pps_workflow.bpm_process_approval ADD party_process_code varchar NULL;
COMMENT ON COLUMN pps_workflow.bpm_process_approval.party_process_code IS '党建-流程编码';
ALTER TABLE pps_workflow.bpm_process_approval ADD party_active_node varchar NULL;
COMMENT ON COLUMN pps_workflow.bpm_process_approval.party_active_node IS '党建-节点编号';

--pps_base_frame
ALTER TABLE pps_base_frame.form_input_record ALTER COLUMN filter_data TYPE varchar(2048) USING filter_data::varchar;


--pps_interface
CREATE TABLE pps_interface.transfer_old_pps_trace_log (
	id varchar(40) NOT NULL,
	traceid varchar(40) NULL,
	trace_info text NULL,
	create_time timestamp(3) NULL,
	CONSTRAINT form_trace_log_pkey PRIMARY KEY (id)
)
WITH (
	orientation=row,
	compression=no
);

-- Column comments

COMMENT ON COLUMN pps_interface.transfer_old_pps_trace_log.id IS '主键';
COMMENT ON COLUMN pps_interface.transfer_old_pps_trace_log.traceid IS '跟踪id';
COMMENT ON COLUMN pps_interface.transfer_old_pps_trace_log.trace_info IS '跟踪内容';
COMMENT ON COLUMN pps_interface.transfer_old_pps_trace_log.create_time IS '创建时间';


--pps_base_frame
--所有相关数据盒子
ALTER TABLE pps_base_frame.form_input_record ADD databoxes varchar(2000) NULL;

ALTER TABLE pps_base_frame.form_control_config ADD is_excel bool NULL;

--pps_dispatch
ALTER TABLE pps_dispatch.disp_lng_shipping_schedule ADD station_id varchar(50) NULL;
COMMENT ON COLUMN pps_dispatch.disp_lng_shipping_schedule.station_id IS '场站id';
ALTER TABLE pps_dispatch.disp_lng_shipping_schedule ADD station_name varchar(50) NULL;
COMMENT ON COLUMN pps_dispatch.disp_lng_shipping_schedule.station_name IS '场站名称';
ALTER TABLE pps_dispatch.disp_lng_discharge_registration ADD loading_port varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.disp_lng_discharge_registration.loading_port IS '装货港';
ALTER TABLE pps_dispatch.disp_lng_discharge_registration ADD density numeric(15, 5) NULL;
COMMENT ON COLUMN pps_dispatch.disp_lng_discharge_registration.density IS '密度';
ALTER TABLE pps_dispatch.disp_lng_discharge_registration ADD vaporization_rate numeric(15, 5) NULL;
COMMENT ON COLUMN pps_dispatch.disp_lng_discharge_registration.vaporization_rate IS '气化率';
ALTER TABLE pps_dispatch.disp_lng_discharge_registration ADD methane_concentration numeric(15, 5) NULL;
COMMENT ON COLUMN pps_dispatch.disp_lng_discharge_registration.methane_concentration IS '甲烷含量';
ALTER TABLE pps_dispatch.disp_lng_discharge_registration ADD volume_calorific numeric(15, 5) NULL;
COMMENT ON COLUMN pps_dispatch.disp_lng_discharge_registration.volume_calorific IS '体积热值';
ALTER TABLE pps_dispatch.disp_lng_discharge_registration ADD quality_calorific numeric(15, 5) NULL;
COMMENT ON COLUMN pps_dispatch.disp_lng_discharge_registration.quality_calorific IS '质量热值';
ALTER TABLE pps_dispatch.disp_lng_discharge_registration ADD conditions_calorific numeric(15, 5) NULL;
COMMENT ON COLUMN pps_dispatch.disp_lng_discharge_registration.conditions_calorific IS '热值条件';
ALTER TABLE pps_dispatch.disp_lng_discharge_registration ADD report_date date NULL;
COMMENT ON COLUMN pps_dispatch.disp_lng_discharge_registration.report_date IS '检测报告日期';
ALTER TABLE pps_dispatch.disp_lng_discharge_registration ADD first_start_time timestamp(3) NULL;
COMMENT ON COLUMN pps_dispatch.disp_lng_discharge_registration.first_start_time IS '第一台启动时间';
ALTER TABLE pps_dispatch.disp_lng_discharge_registration ADD last_end_time timestamp(3) NULL;
COMMENT ON COLUMN pps_dispatch.disp_lng_discharge_registration.last_end_time IS '最后一台结束时间';
ALTER TABLE pps_dispatch.disp_lng_discharge_registration ADD work_hours numeric(15, 5) NULL;
COMMENT ON COLUMN pps_dispatch.disp_lng_discharge_registration.work_hours IS '作业时间(小时)';
ALTER TABLE pps_dispatch.disp_lng_discharge_registration ADD calorific numeric(15, 5) NULL;
COMMENT ON COLUMN pps_dispatch.disp_lng_discharge_registration.calorific IS '热值';

create table pps_base_frame.form_transfer_trace (
	id varchar(40) NOT NULL,
	form_input_record_id varchar(40) NULL,
	transfer_old_pps_status int4 NULL,
	transfer_analysis_status int4 NULL,
	create_time timestamp NULL,
PRIMARY KEY (id)
);
comment on table pps_base_frame.form_transfer_trace is '表单传输跟踪';


COMMENT ON COLUMN pps_base_frame.form_transfer_trace.id IS '主键';
COMMENT ON COLUMN pps_base_frame.form_transfer_trace.form_input_record_id IS '表单填报记录id';
COMMENT ON COLUMN pps_base_frame.form_transfer_trace.transfer_old_pps_status IS '推送过渡期pps的状态';
COMMENT ON COLUMN pps_base_frame.form_transfer_trace.transfer_analysis_status IS '分析库推送状态';
COMMENT ON COLUMN pps_base_frame.form_transfer_trace.create_time IS '创建时间';


ALTER TABLE pps_base_frame.form_transfer_to_analysis_db ADD consumed int4 NULL;
COMMENT ON COLUMN pps_base_frame.form_transfer_to_analysis_db.consumed IS '是否消费';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_analysis_db.post_by IS '发送人';

COMMENT ON COLUMN pps_base_frame.form_transfer_to_analysis_db_removed_id.id IS '主键';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_analysis_db_removed_id.form_input_record_id IS '表单填报id';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_analysis_db_removed_id.msg_body IS '消息内容';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_analysis_db_removed_id.create_time IS '创建时间';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_analysis_db_removed_id.valid_time IS '有效时间';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_analysis_db_removed_id.post_time IS '发送时间';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_analysis_db_removed_id.table_name IS '表名称';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_analysis_db_removed_id.post_by IS '发送者';

COMMENT ON COLUMN pps_base_frame.form_transfer_to_analysis_db.consumed IS '是否消费，1已消费';

ALTER TABLE pps_base_frame.form_transfer_to_mq ADD consumed int4 NULL;
COMMENT ON COLUMN pps_base_frame.form_transfer_to_mq.consumed IS '是否消费，1已消费';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_mq.id IS '主键';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_mq.form_input_record_id IS '表单填报id';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_mq.msg_body IS '消息内容';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_mq.channel IS '消息通道';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_mq.create_time IS '创建时间';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_mq.post_time IS '发送时间';
COMMENT ON COLUMN pps_base_frame.form_transfer_to_mq.post_by IS '发送者';

COMMENT ON COLUMN pps_base_frame.form_transfer_to_old_pps.post_by IS '发送者';
ALTER TABLE pps_base_frame.form_transfer_to_old_pps ADD consumed int4 NULL;

COMMENT ON COLUMN pps_base_frame.form_transfer_to_old_pps_removed_id.post_by IS '发送者';
ALTER TABLE pps_base_frame.form_transfer_to_old_pps_removed_id ADD consumed int4 NULL;


ALTER TABLE pps_base_frame.form_transfer_to_pdf ADD consumed int4 NULL;
COMMENT ON COLUMN pps_base_frame.form_transfer_to_pdf.post_by IS '发送者';

ALTER TABLE pps_base_frame.form_transfer_to_pdf_invalid ADD consumed int4 NULL;
COMMENT ON COLUMN pps_base_frame.form_transfer_to_pdf_invalid.post_by IS '发送者';



