--新增原油成品油-动火作业表的字段类型
--pps_dispatch start
CREATE TABLE pps_dispatch.hot_work_of_crude_oil_and_product_oil (
                                                                    id varchar(40) NOT NULL,
                                                                    m_ou_id varchar(40) NULL,
                                                                    m_ou_name varchar(100) NULL,
                                                                    data_date smalldatetime NULL,
                                                                    pipeline_id varchar(40) NULL,
                                                                    pipeline_name varchar(100) NULL,
                                                                    regionalcompanies varchar(100) NULL,
                                                                    job_name varchar(100) NULL,
                                                                    description_of_hot_work_content varchar(500) NULL,
                                                                    impact_during_hot_work varchar(500) NULL,
                                                                    risk_type_flag_id varchar(40) NULL,
                                                                    risk_type_flag_name varchar(100) NULL,
                                                                    star_date smalldatetime NULL,
                                                                    end_date smalldatetime NULL,
                                                                    is_delete int NULL,
                                                                    create_time smalldatetime NULL,
                                                                    create_by_id varchar(40) NULL,
                                                                    create_by_name varchar(50) NULL,
                                                                    modify_time smalldatetime NULL,
                                                                    modify_by_id varchar(40) NULL,
                                                                    modify_by_name varchar(50) NULL,
                                                                    CONSTRAINT hot_work_of_crude_oil_and_product_oil_pk PRIMARY KEY (id)
);
COMMENT ON TABLE pps_dispatch.hot_work_of_crude_oil_and_product_oil IS '动火作业表（原油成品油）';

-- Column comments

COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.m_ou_id IS '填报单位id';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.m_ou_name IS '填报单位名字';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.data_date IS '单据提交时间';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.pipeline_id IS '所在管线id';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.pipeline_name IS '所在管线';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.regionalcompanies IS '地区公司';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.job_name IS '动火作业名称';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.description_of_hot_work_content IS '动火作业内容描述';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.impact_during_hot_work IS '动火作业期间影响';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.risk_type_flag_id IS '动火作业分级id';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.risk_type_flag_name IS '动火作业分级名字';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.star_date IS '开始时间';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.end_date IS '结束时间';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.is_delete IS '删除（0 删除 1 正常）';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.create_time IS '创建时间';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.create_by_id IS '创建人id';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.create_by_name IS '创建人名称';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.modify_time IS '修改时间';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.modify_by_id IS '修改人id';
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.modify_by_name IS '修改人名称';
GRANT INSERT, SELECT, DELETE, TRIGGER, UPDATE, TRUNCATE, REFERENCES ON TABLE pps_dispatch.hot_work_of_crude_oil_and_product_oil TO root;


--   添加设备故障表四个字段

ALTER TABLE pps_dispatch.equipment_failure_ledger ADD faulty_equipment_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.equipment_failure_ledger.faulty_equipment_id IS '故障设备id';
ALTER TABLE pps_dispatch.equipment_failure_ledger ADD equipment_classification_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.equipment_failure_ledger.equipment_classification_id IS '设备分类id';
ALTER TABLE pps_dispatch.equipment_failure_ledger ADD fault_classification_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.equipment_failure_ledger.fault_classification_dic_id IS '故障分类id';
ALTER TABLE pps_dispatch.equipment_failure_ledger ADD fault_level_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.equipment_failure_ledger.fault_level_dic_id IS '故障等级id';

--pps_dispatch end



--运行方案上报增加组织机构-开始
--pps_dispatch
ALTER TABLE pps_dispatch.disp_run_plan_escalation ADD ou_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.disp_run_plan_escalation.ou_id IS '组织机构id';
ALTER TABLE pps_dispatch.disp_run_plan_escalation ADD ou_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.disp_run_plan_escalation.ou_name IS '组织机构名称';
--运行方案上报增加组织机构-结束

--气质分析报告配置增加管线相关信息-开始
--pps_base_info
ALTER TABLE pps_base_info.base_temperament_device_config ADD master_pipeline_id varchar(40) NULL;
COMMENT ON COLUMN pps_base_info.base_temperament_device_config.master_pipeline_id IS '气质参数来源主管线id';
ALTER TABLE pps_base_info.base_temperament_device_config ADD master_pipeline_name varchar(100) NULL;
COMMENT ON COLUMN pps_base_info.base_temperament_device_config.master_pipeline_name IS '气质参数来源主管线名称';
ALTER TABLE pps_base_info.base_temperament_device_config ADD spare_pipeline_id varchar(40) NULL;
COMMENT ON COLUMN pps_base_info.base_temperament_device_config.spare_pipeline_id IS '气质参数来源备管线id';
ALTER TABLE pps_base_info.base_temperament_device_config ADD spare_pipeline_name varchar(100) NULL;
COMMENT ON COLUMN pps_base_info.base_temperament_device_config.spare_pipeline_name IS '气质参数来源备场站名称';
--气质分析报告配置增加管线相关信息-结束

























