--pps_dispatch start
-- 新建批次月计划表

-- pps_dispatch.batch_monthly_plan definition

-- Drop table

-- DROP TABLE pps_dispatch.batch_monthly_plan;

CREATE TABLE pps_dispatch.batch_monthly_plan (
                                                 id varchar(40) NOT NULL, -- id
                                                 m_ou_id varchar(40) NULL, -- 填报单位id
                                                 m_ou_name varchar(100) NULL, -- 填报单位名字
                                                 data_date smalldatetime NULL, -- 单据提交时间
                                                 pipeline_id varchar(40) NULL, -- 管线id
                                                 pipeline_name varchar(100) NULL, -- 管线名称
                                                 month_time smalldatetime NULL, -- 时间（月份）
                                                 file_key_id varchar(40) NULL, -- 附件id
                                                 file_key varchar(100) NULL, -- 附件
                                                 auditor_id varchar(40) NULL, -- 审核人员id
                                                 auditor_name varchar(100) NULL, -- 审核人员
                                                 auditstatus int4 NULL, -- 审核状态
                                                 is_delete int4 NULL, -- 删除（0 删除 1 正常）
                                                 create_time smalldatetime NULL, -- 创建时间
                                                 create_by_id varchar(40) NULL, -- 创建人id
                                                 create_by_name varchar(100) NULL, -- 创建人名称
                                                 modify_time smalldatetime NULL, -- 修改时间
                                                 modify_by_id varchar(40) NULL, -- 修改人id
                                                 modify_by_name varchar(100) NULL, -- 修改人名称
                                                 reserve1 varchar(100) NULL, -- 备用字段1
                                                 reserve2 varchar(500) NULL, -- 备用字段2
                                                 reserve3 varchar(100) NULL, -- 备用字段3
                                                 reserve4 varchar(100) NULL, -- 备用字段4
                                                 CONSTRAINT batch_monthly_plan_pk PRIMARY KEY (id)
)
    WITH (
        orientation=row,
        compression=no
        );
COMMENT ON TABLE pps_dispatch.batch_monthly_plan IS '批次月计划表';

-- Column comments

COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.id IS 'id';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.m_ou_id IS '填报单位id';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.m_ou_name IS '填报单位名字';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.data_date IS '单据提交时间';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.pipeline_id IS '管线id';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.pipeline_name IS '管线名称';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.month_time IS '时间（月份）';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.file_key_id IS '附件id';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.file_key IS '附件';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.auditor_id IS '审核人员id';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.auditor_name IS '审核人员';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.auditstatus IS '审核状态';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.is_delete IS '删除（0 删除 1 正常）';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.create_time IS '创建时间';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.create_by_id IS '创建人id';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.create_by_name IS '创建人名称';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.modify_time IS '修改时间';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.modify_by_id IS '修改人id';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.modify_by_name IS '修改人名称';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.reserve1 IS '备用字段1';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.reserve2 IS '备用字段2';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.reserve3 IS '备用字段3';
COMMENT ON COLUMN pps_dispatch.batch_monthly_plan.reserve4 IS '备用字段4';


--pps_dispatch end