
-- 升压添加获取数据字段
ALTER TABLE pps_into_production.pro_pressure_rise_record_sheet ADD extraction_time smalldatetime NULL;
COMMENT ON COLUMN pps_into_production.pro_pressure_rise_record_sheet.extraction_time IS '获取数据的时间';




-- pps_into_production.pro_nitrogen_injection_record_sheet definition

-- Drop table

-- DROP TABLE pps_into_production.pro_nitrogen_injection_record_sheet;

CREATE TABLE pps_into_production.pro_nitrogen_injection_record_sheet (
                                                                         id varchar(40) NOT NULL, -- 主键id
                                                                         m_ou_id varchar(100) NULL, -- 填报单位id
                                                                         m_ou_name varchar(100) NULL, -- 填报单位名称
                                                                         pipeline_id varchar(40) NULL, -- 管线id
                                                                         pipeline_name varchar(300) NULL, -- 管线名称
                                                                         station_id varchar(40) NULL, -- 场站id
                                                                         station_name varchar(50) NULL, -- 场站名称
                                                                         km_id varchar(50) NULL, -- 里程数据id
                                                                         proinfo_id varchar(50) NULL, -- 投产基本信息id
                                                                         initial_nitrogen_replacement_time_in_the_station smalldatetime NULL, -- 站内起始氮气置换时间
                                                                         time_to_complete_nitrogen_replacement_in_the_station smalldatetime NULL, -- 站内完成氮气置换时间
                                                                         sealing_pressure numeric(15, 5) NULL, -- 封存压力
                                                                         nitrogen_injection numeric(15, 5) NULL, -- 注氮量（T)
                                                                         completion_time_of_nitrogen_replacement_in_valve_chamber smalldatetime NULL, -- 阀室完成氮气置换时间
                                                                         initial_nitrogen_replacement_time_of_valve_chamber smalldatetime NULL, -- 阀室起始氮气置换时间
                                                                         completion_time_of_natural_gas_replacement_in_the_station smalldatetime NULL, -- 站内完成天然气气置换时间
                                                                         residual_nitrogen numeric(15, 5) NULL, -- 氮气剩余量
                                                                         effective_nitrogen_injection_percentage varchar(50) NULL, -- 有效注氮百分比
                                                                         remaining_length_of_pure_nitrogen numeric(15, 5) NULL, -- 纯氮剩余长度
                                                                         order_number int4 NULL, -- 序号(用来排序)
                                                                         is_deleted int4 NULL, -- 是否删除(0是已删除,1是正常)
                                                                         create_by_id varchar(40) NULL, -- 创建人
                                                                         create_by_name varchar(50) NULL, -- 创建人名称
                                                                         create_time smalldatetime NULL, -- 创建时间
                                                                         modify_by_id varchar(40) NULL, -- 修改人
                                                                         modify_by_name varchar(50) NULL, -- 修改人名称
                                                                         modify_time smalldatetime NULL, -- 修改时间
                                                                         data_date date NULL -- 数据填报时间
)
    WITH (
        orientation=row,
        compression=no
        );
CREATE INDEX pro_nitrogen_injection_record_sheet_id_idx ON pps_into_production.pro_nitrogen_injection_record_sheet USING btree (id) TABLESPACE pg_default;
COMMENT ON TABLE pps_into_production.pro_nitrogen_injection_record_sheet IS '注氮记录表';

-- Column comments

COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.id IS '主键id';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.m_ou_id IS '填报单位id';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.m_ou_name IS '填报单位名称';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.pipeline_id IS '管线id';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.pipeline_name IS '管线名称';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.station_id IS '场站id';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.station_name IS '场站名称';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.km_id IS '里程数据id';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.proinfo_id IS '投产基本信息id';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.initial_nitrogen_replacement_time_in_the_station IS '站内起始氮气置换时间';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.time_to_complete_nitrogen_replacement_in_the_station IS '站内完成氮气置换时间';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.sealing_pressure IS '封存压力';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.nitrogen_injection IS '注氮量（T)';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.completion_time_of_nitrogen_replacement_in_valve_chamber IS '阀室完成氮气置换时间';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.initial_nitrogen_replacement_time_of_valve_chamber IS '阀室起始氮气置换时间';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.completion_time_of_natural_gas_replacement_in_the_station IS '站内完成天然气气置换时间';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.residual_nitrogen IS '氮气剩余量';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.effective_nitrogen_injection_percentage IS '有效注氮百分比';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.remaining_length_of_pure_nitrogen IS '纯氮剩余长度';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.order_number IS '序号(用来排序)';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.is_deleted IS '是否删除(0是已删除,1是正常)';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.create_by_id IS '创建人';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.create_by_name IS '创建人名称';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.create_time IS '创建时间';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.modify_by_id IS '修改人';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.modify_by_name IS '修改人名称';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.modify_time IS '修改时间';
COMMENT ON COLUMN pps_into_production.pro_nitrogen_injection_record_sheet.data_date IS '数据填报时间';



COMMENT ON TABLE pps_dispatch.disp_reg_oper_sta_and_shut_acc IS '启停输台账表';
ALTER TABLE pps_dispatch.disp_reg_oper_sta_and_shut_acc ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_sta_and_shut_acc.console_dic_name IS '调度台字典名称';
ALTER TABLE pps_dispatch.disp_reg_oper_sta_and_shut_acc ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_sta_and_shut_acc.console_dic_id IS '调度台字典id';



COMMENT ON TABLE pps_dispatch.disp_reg_oper_acc_pigg_acc IS '清管台账表';
ALTER TABLE pps_dispatch.disp_reg_oper_acc_pigg_acc ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_pigg_acc.console_dic_id IS '调度台字典id';
ALTER TABLE pps_dispatch.disp_reg_oper_acc_pigg_acc ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_pigg_acc.console_dic_name IS '调度台字典名称';


COMMENT ON TABLE pps_dispatch.disp_reg_oper_acc_inj_acc IS '注入台账表';
ALTER TABLE pps_dispatch.disp_reg_oper_acc_inj_acc ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_inj_acc.console_dic_name IS '调度台字典名称';
ALTER TABLE pps_dispatch.disp_reg_oper_acc_inj_acc ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_inj_acc.console_dic_id IS '调度台字典id';



COMMENT ON TABLE pps_dispatch.disp_reg_oper_acc_inc_dec_acc IS '增减量台账表';
ALTER TABLE pps_dispatch.disp_reg_oper_acc_inc_dec_acc ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_inc_dec_acc.console_dic_id IS '调度台字典id';
ALTER TABLE pps_dispatch.disp_reg_oper_acc_inc_dec_acc ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_inc_dec_acc.console_dic_name IS '调度台字典名称';



ALTER TABLE pps_dispatch.disp_reg_oper_acc_excep_acc ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_excep_acc.console_dic_id IS '调度台字典id';
ALTER TABLE pps_dispatch.disp_reg_oper_acc_excep_acc ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_excep_acc.console_dic_name IS '调度台字典名称';
COMMENT ON TABLE pps_dispatch.disp_reg_oper_acc_excep_acc IS '异常事件台账表';



COMMENT ON TABLE pps_dispatch.disp_reg_oper_acc_dist_acc IS '分输台账表';
ALTER TABLE pps_dispatch.disp_reg_oper_acc_dist_acc ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_dist_acc.console_dic_id IS '调度台字典id';
ALTER TABLE pps_dispatch.disp_reg_oper_acc_dist_acc ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_dist_acc.console_dic_name IS '调度台字典名称';


COMMENT ON TABLE pps_dispatch.crude_oil_disp_reg_oper_acc_pigg_tubi_acc IS '清管台账(热油管道)';
ALTER TABLE pps_dispatch.crude_oil_disp_reg_oper_acc_pigg_tubi_acc ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.crude_oil_disp_reg_oper_acc_pigg_tubi_acc.console_dic_id IS '调度台字典id';
ALTER TABLE pps_dispatch.crude_oil_disp_reg_oper_acc_pigg_tubi_acc ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.crude_oil_disp_reg_oper_acc_pigg_tubi_acc.console_dic_name IS '调度台字典名称';


COMMENT ON TABLE pps_dispatch.product_oil_disp_reg_oper_acc_mi_oi_cu_acc IS '混油切台账';
ALTER TABLE pps_dispatch.product_oil_disp_reg_oper_acc_mi_oi_cu_acc ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.product_oil_disp_reg_oper_acc_mi_oi_cu_acc.console_dic_id IS '调度台字典id';
ALTER TABLE pps_dispatch.product_oil_disp_reg_oper_acc_mi_oi_cu_acc ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.product_oil_disp_reg_oper_acc_mi_oi_cu_acc.console_dic_name IS '调度台字典名称';


COMMENT ON TABLE pps_dispatch.product_oil_disp_reg_oper_acc_cu_bat_acc IS '切批次台账';
ALTER TABLE pps_dispatch.product_oil_disp_reg_oper_acc_cu_bat_acc ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.product_oil_disp_reg_oper_acc_cu_bat_acc.console_dic_id IS '调度台字典id';
ALTER TABLE pps_dispatch.product_oil_disp_reg_oper_acc_cu_bat_acc ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.product_oil_disp_reg_oper_acc_cu_bat_acc.console_dic_name IS '调度台字典名称';


ALTER TABLE pps_dispatch.disp_pum_reje_account ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.disp_pum_reje_account.console_dic_id IS '调度台字典id';
ALTER TABLE pps_dispatch.disp_pum_reje_account ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.disp_pum_reje_account.console_dic_name IS '调度台字典名称';

-- 原油物性记录台账(新增调度台console_dic_id，console_dic_name俩字段)
ALTER TABLE pps_dispatch.crude_oil_physical_property_record_account ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.crude_oil_physical_property_record_account.console_dic_id IS '调度台id';
ALTER TABLE pps_dispatch.crude_oil_physical_property_record_account ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.crude_oil_physical_property_record_account.console_dic_name IS '调度台名字';
-- 成品油物性记录台账(新增调度台console_dic_id，console_dic_name俩字段)
ALTER TABLE pps_dispatch.physical_property_record_account_of_product_oil ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.physical_property_record_account_of_product_oil.console_dic_id IS '调度台id';
ALTER TABLE pps_dispatch.physical_property_record_account_of_product_oil ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.physical_property_record_account_of_product_oil.console_dic_name IS '调度台名字';
-- 切泵台账(新增调度台console_dic_id，console_dic_name俩字段)
ALTER TABLE pps_dispatch.pump_switching_account ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.pump_switching_account.console_dic_id IS '调度台id';
ALTER TABLE pps_dispatch.pump_switching_account ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.pump_switching_account.console_dic_name IS '调度台名字';
-- 加热炉调整台账(新增调度台console_dic_id，console_dic_name俩字段)
ALTER TABLE pps_dispatch.heating_furnace_adjustment_account ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.heating_furnace_adjustment_account.console_dic_id IS '调度台id';
ALTER TABLE pps_dispatch.heating_furnace_adjustment_account ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.heating_furnace_adjustment_account.console_dic_name IS '调度台名字';
-- 设备故障台账(新增调度台console_dic_id，console_dic_name俩字段)
ALTER TABLE pps_dispatch.equipment_failure_ledger ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.equipment_failure_ledger.console_dic_id IS '调度台id';
ALTER TABLE pps_dispatch.equipment_failure_ledger ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.equipment_failure_ledger.console_dic_name IS '调度台名字';
-- 生产记事台账(新增调度台console_dic_id，console_dic_name俩字段)
ALTER TABLE pps_dispatch.production_record_account ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.production_record_account.console_dic_id IS '调度台id';
ALTER TABLE pps_dispatch.production_record_account ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.production_record_account.console_dic_name IS '调度台名字';
-- 生产问题台账(新增调度台console_dic_id，console_dic_name俩字段)
ALTER TABLE pps_dispatch.production_problem_account ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.production_problem_account.console_dic_id IS '调度台id';
ALTER TABLE pps_dispatch.production_problem_account ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.production_problem_account.console_dic_name IS '调度台名字';
-- 混油界面台账(新增调度台console_dic_id，console_dic_name俩字段)
ALTER TABLE pps_dispatch.oil_mixing_interface_account ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.oil_mixing_interface_account.console_dic_id IS '调度台id';
ALTER TABLE pps_dispatch.oil_mixing_interface_account ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.oil_mixing_interface_account.console_dic_name IS '调度台名字';
-- 混油界面跟踪及下载台账(新增调度台console_dic_id，console_dic_name俩字段)
ALTER TABLE pps_dispatch.oil_mixing_interface_tracking_and_downloading_account ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.oil_mixing_interface_tracking_and_downloading_account.console_dic_id IS '调度台id';
ALTER TABLE pps_dispatch.oil_mixing_interface_tracking_and_downloading_account ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.oil_mixing_interface_tracking_and_downloading_account.console_dic_name IS '调度台名字';
-- 管线运行记录台账(新增调度台console_dic_id，console_dic_name俩字段)
ALTER TABLE pps_dispatch.pipeline_operation_record_account ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.pipeline_operation_record_account.console_dic_id IS '调度台id';
ALTER TABLE pps_dispatch.pipeline_operation_record_account ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.pipeline_operation_record_account.console_dic_name IS '调度台名字';
-- 动火作业表（原油成品油）(新增调度台console_dic_id，console_dic_name俩字段)
ALTER TABLE pps_dispatch.hot_work_of_crude_oil_and_product_oil ADD console_dic_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.console_dic_id IS '调度台id';
ALTER TABLE pps_dispatch.hot_work_of_crude_oil_and_product_oil ADD console_dic_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.hot_work_of_crude_oil_and_product_oil.console_dic_name IS '调度台名字';





