-- pps_dispatch.duty_log_record_form definition

-- Drop table

-- DROP TABLE pps_dispatch.duty_log_record_form;

CREATE TABLE pps_dispatch.duty_log_record_form (
                                                   id varchar(50) NOT NULL, -- 主键id
                                                   m_ou_id varchar(100) NULL, -- 组织机构id
                                                   m_ou_name varchar(100) NULL, -- 组织机构名称
                                                   pipeline_id varchar(40) NULL, -- 管线id
                                                   pipeline_name varchar(300) NULL, -- 管线名称
                                                   short_name varchar(150) NULL, -- 管线缩写名称
                                                   station_id varchar(40) NULL, -- 场站id
                                                   station_name varchar(50) NULL, -- 场站名称
                                                   theme_which_day varchar(500) NULL, -- 主题
                                                   vocational_work_id varchar(50) NULL, -- 业务id
                                                   vocational_work_name varchar(50) NULL, -- 业务名称
                                                   type_id varchar(50) NULL, -- 类型id
                                                   type_name varchar(100) NULL, -- 类型名称
                                                   classes_which_day int4 NULL, -- 班次
                                                   console_dic_id varchar(500) NULL, -- 调度台字典id(对应填报单位id)
                                                   console_dic_name varchar(500) NULL, -- 调度台名称(对应填报单位名称)
                                                   emergency_level_id varchar(50) NULL, -- 紧急层度id
                                                   emergency_level_name varchar(50) NULL, -- 紧急层度名称
                                                   content_validity varchar NULL, -- 内容简介
                                                   process_selection int4 NULL, -- 是否处理完毕(0是否1是是)
                                                   processing_results varchar(1000) NULL, -- 处理结果
                                                   is_deleted int4 NULL, -- 是否删除(0是已删除,1是正常)
                                                   create_by_id varchar(40) NULL, -- 创建人id
                                                   create_by_name varchar(50) NULL, -- 创建人名称
                                                   create_time smalldatetime NULL, -- 创建时间
                                                   modify_by_id varchar(40) NULL, -- 修改人id
                                                   modify_by_name varchar(50) NULL, -- 修改人名称
                                                   modify_time smalldatetime NULL, -- 修改时间
                                                   data_date smalldatetime NULL -- 数据填报时间
)
    WITH (
        orientation=row,
        compression=no
        );
CREATE INDEX duty_log_record_form_id_idx ON pps_dispatch.duty_log_record_form USING btree (id) TABLESPACE pg_default;
COMMENT ON TABLE pps_dispatch.duty_log_record_form IS '值班日志记录表';

-- Column comments

COMMENT ON COLUMN pps_dispatch.duty_log_record_form.id IS '主键id';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.m_ou_id IS '组织机构id';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.m_ou_name IS '组织机构名称';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.pipeline_id IS '管线id';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.pipeline_name IS '管线名称';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.short_name IS '管线缩写名称';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.station_id IS '场站id';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.station_name IS '场站名称';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.theme_which_day IS '主题';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.vocational_work_id IS '业务id';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.vocational_work_name IS '业务名称';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.type_id IS '类型id';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.type_name IS '类型名称';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.classes_which_day IS '班次';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.console_dic_id IS '调度台字典id(对应填报单位id)';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.console_dic_name IS '调度台名称(对应填报单位名称)';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.emergency_level_id IS '紧急层度id';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.emergency_level_name IS '紧急层度名称';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.content_validity IS '内容简介';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.process_selection IS '是否处理完毕(0是否1是是)';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.processing_results IS '处理结果';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.is_deleted IS '是否删除(0是已删除,1是正常)';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.create_by_id IS '创建人id';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.create_by_name IS '创建人名称';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.create_time IS '创建时间';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.modify_by_id IS '修改人id';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.modify_by_name IS '修改人名称';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.modify_time IS '修改时间';
COMMENT ON COLUMN pps_dispatch.duty_log_record_form.data_date IS '数据填报时间';