
-- 启停输
ALTER TABLE pps_dispatch.disp_reg_oper_sta_and_shut_acc ADD choose_whether int4 NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_sta_and_shut_acc.choose_whether IS '用户是否完成';

-- 注入台账
ALTER TABLE pps_dispatch.disp_reg_oper_acc_inj_acc ADD choose_whether int4 NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_inj_acc.choose_whether IS '用户是否完成';
-- 分输
ALTER TABLE pps_dispatch.disp_reg_oper_acc_dist_acc ADD choose_whether int4 NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_dist_acc.choose_whether IS '用户是否完成';

-- 增减量
ALTER TABLE pps_dispatch.disp_reg_oper_acc_inc_dec_acc ADD choose_whether int4 NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_inc_dec_acc.choose_whether IS '用户是否完成';

-- 异常事件
ALTER TABLE pps_dispatch.disp_reg_oper_acc_excep_acc ADD choose_whether int4 NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_excep_acc.choose_whether IS '用户是否完成';

-- 清管台账
ALTER TABLE pps_dispatch.disp_reg_oper_acc_pigg_acc ADD choose_whether int4 NULL;
COMMENT ON COLUMN pps_dispatch.disp_reg_oper_acc_pigg_acc.choose_whether IS '用户是否完成';

-- 清管热油管道
ALTER TABLE pps_dispatch.crude_oil_disp_reg_oper_acc_pigg_tubi_acc ADD choose_whether int4 NULL;
COMMENT ON COLUMN pps_dispatch.crude_oil_disp_reg_oper_acc_pigg_tubi_acc.choose_whether IS '用户是否完成';

-- 混油切
ALTER TABLE pps_dispatch.product_oil_disp_reg_oper_acc_mi_oi_cu_acc ADD choose_whether int4 NULL;
COMMENT ON COLUMN pps_dispatch.product_oil_disp_reg_oper_acc_mi_oi_cu_acc.choose_whether IS '用户是否完成';

-- 切批次
ALTER TABLE pps_dispatch.product_oil_disp_reg_oper_acc_cu_bat_acc ADD choose_whether int4 NULL;
COMMENT ON COLUMN pps_dispatch.product_oil_disp_reg_oper_acc_cu_bat_acc.choose_whether IS '用户是否完成';

-- 甩泵
ALTER TABLE pps_dispatch.disp_pum_reje_account ADD choose_whether int4 NULL;
COMMENT ON COLUMN pps_dispatch.disp_pum_reje_account.choose_whether IS '用户是否完成';



--pps_dispatch start
--运行方案上报相关操作
CREATE TABLE pps_dispatch.disp_run_plan_escalation_feedback (
	id varchar(40) NOT NULL, -- 主键
	run_plan_receiver_id varchar(40) NULL, -- 运行方案业务收件人id disp_run_plan_receiver表id
	escalation_id varchar(40) NULL, -- 运行方案上报id
	remark varchar NULL, -- 反馈意见
	feedback_date smalldatetime NULL, -- 反馈时间
	media_type varchar(40) NULL, -- 介质类型
	CONSTRAINT "_disp_run_plan_escalation_feedback_pkey" PRIMARY KEY (id)
)
WITH (
	orientation=row,
	compression=no
);
COMMENT ON TABLE pps_dispatch.disp_run_plan_escalation_feedback IS '调度运行-运行方案上报-反馈';

-- Column comments

COMMENT ON COLUMN pps_dispatch.disp_run_plan_escalation_feedback.id IS '主键';
COMMENT ON COLUMN pps_dispatch.disp_run_plan_escalation_feedback.run_plan_receiver_id IS '运行方案业务收件人id	disp_run_plan_receiver表id';
COMMENT ON COLUMN pps_dispatch.disp_run_plan_escalation_feedback.escalation_id IS '运行方案上报id';
COMMENT ON COLUMN pps_dispatch.disp_run_plan_escalation_feedback.remark IS '反馈意见';
COMMENT ON COLUMN pps_dispatch.disp_run_plan_escalation_feedback.feedback_date IS '反馈时间';
COMMENT ON COLUMN pps_dispatch.disp_run_plan_escalation_feedback.media_type IS '介质类型';


ALTER TABLE pps_dispatch.disp_run_plan_escalation ALTER COLUMN audit_state TYPE int1 USING audit_state::int1;
COMMENT ON COLUMN pps_dispatch.disp_run_plan_escalation.audit_state IS '审核状态（1暂存 2 提交 3 二级单位审核通过 4 二级单位审核驳回 5 二级单位批准通过 6 二级单位审批驳回  7 所属企业审核通过 8 所属企业审核驳回）';
ALTER TABLE pps_dispatch.disp_run_plan_escalation ALTER COLUMN file_ids TYPE varchar USING file_ids::varchar;
ALTER TABLE pps_dispatch.disp_run_plan_escalation ADD be_show int1 NULL DEFAULT 0;
COMMENT ON COLUMN pps_dispatch.disp_run_plan_escalation.be_show IS '接收人和抄送人是否可以查看（0不可以 1 可以）';
ALTER TABLE pps_dispatch.disp_run_plan_escalation ADD be_feedback int1 NULL DEFAULT 0;
COMMENT ON COLUMN pps_dispatch.disp_run_plan_escalation.be_feedback IS '接收人是否可以反馈（0 不可以 1 可以）';
ALTER TABLE pps_dispatch.disp_run_plan_escalation ADD be_edit int1 NULL DEFAULT 0;
COMMENT ON COLUMN pps_dispatch.disp_run_plan_escalation.be_edit IS '提报人是否可以编辑（0 不可以 1 可以）';
ALTER TABLE pps_dispatch.disp_run_plan_escalation ADD receive_type int1 NULL;
COMMENT ON COLUMN pps_dispatch.disp_run_plan_escalation.receive_type IS '接收类型（1 按姓名 2 按角色）';
ALTER TABLE pps_dispatch.disp_run_plan_escalation ADD dispatch_copy_type int1 NULL;
COMMENT ON COLUMN pps_dispatch.disp_run_plan_escalation.dispatch_copy_type IS '调度运行接收类型（1 按姓名 2 按角色）';


--管存计算相关
ALTER TABLE pps_dispatch.disp_ng_tube_storage_cal ADD start_segment_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal.start_segment_id IS '开始管段id';
ALTER TABLE pps_dispatch.disp_ng_tube_storage_cal ADD start_segment_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal.start_segment_name IS '开始管段名称';

ALTER TABLE pps_dispatch.disp_ng_tube_storage_cal ADD end_segment_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal.end_segment_id IS '结束管段id';
ALTER TABLE pps_dispatch.disp_ng_tube_storage_cal ADD end_segment_name varchar(100) NULL;
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal.end_segment_name IS '结束管段名称';

ALTER TABLE pps_dispatch.disp_ng_tube_storage_cal ADD temperament_status varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal.temperament_status IS '气质分析报告状态';

ALTER TABLE pps_dispatch.disp_ng_tube_storage_cal ADD temperament_form_id varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal.temperament_form_id IS '气质分析报告form_id';

COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_confirm.state IS '状态（0 禁用 1 发布 2 预发布）';

ALTER TABLE pps_dispatch.disp_ng_tube_storage_cal_confirm ADD cal_data_date varchar(40) NULL;
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_confirm.cal_data_date IS '管存计算时间';

--pps_dispatch end
