--pps_dispatch start
--增加管存计算操作日志
CREATE TABLE pps_dispatch.disp_tube_cal_log (
	id varchar(40) NOT NULL, -- 主键
  oper_type varchar(40) null, --操作类型
  oper_table_name varchar(80) null, --操作表名
  oper_search_key varchar(300) null,  --搜索关键字
  oper_context varchar null,   --操作内容
	create_by_id varchar(40) NULL, -- 创建人
	create_by_name varchar(100) NULL, -- 创建人名称
	create_time timestamp(3) NULL, -- 创建时间
	CONSTRAINT ops_base_operational_constraint_extend_pkey PRIMARY KEY (id)
)
WITH (
	orientation=row,
	compression=no
);
COMMENT ON TABLE pps_dispatch.disp_tube_cal_log IS '管存计算操作日志';

-- Column comments

COMMENT ON COLUMN pps_dispatch.disp_tube_cal_log.id IS '主键';
COMMENT ON COLUMN pps_dispatch.disp_tube_cal_log.oper_type IS '操作类型';
COMMENT ON COLUMN pps_dispatch.disp_tube_cal_log.oper_table_name IS '操作表名';
COMMENT ON COLUMN pps_dispatch.disp_tube_cal_log.oper_search_key IS '搜索关键字';
COMMENT ON COLUMN pps_dispatch.disp_tube_cal_log.oper_context IS '操作内容';
COMMENT ON COLUMN pps_dispatch.disp_tube_cal_log.create_by_id IS '创建人';
COMMENT ON COLUMN pps_dispatch.disp_tube_cal_log.create_by_name IS '创建人名称';
COMMENT ON COLUMN pps_dispatch.disp_tube_cal_log.create_time IS '创建时间';

--管存计算增加发布数据表
CREATE TABLE pps_dispatch.disp_ng_tube_storage_cal_release (
	id varchar(40) NOT NULL, -- 主键
	data_date timestamp(3) null, --数据日期
	pipeline_id varchar(40) null, --管线id
	pipeline_name varchar(100) null, --管线名称
	tube_stock numeric(15, 5) null, --管存
	pipeline_storage_did int4 null, --管存数据点
	async_state int1 null, --同步状态（0 未同步 1 同步成功 2 同步失败）
	async_remark varchar(5000) null, --同步备注
	create_by_id varchar(40) NULL, -- 创建人
	create_by_name varchar(100) NULL, -- 创建人名称
	create_time timestamp(3) NULL, -- 创建时间
	modify_by_id varchar(40) NULL, -- 修改人
	modify_by_name varchar(50) NULL, -- 修改人名称
	modify_time timestamp(3) NULL, -- 修改时间
	CONSTRAINT ops_disp_ng_tube_storage_cal_release_pkey PRIMARY KEY (id)
)
WITH (
	orientation=row,
	compression=no
);
COMMENT ON TABLE pps_dispatch.disp_ng_tube_storage_cal_release IS '管存发布表';


COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_release.id IS '主键';
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_release.data_date IS '数据日期';
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_release.pipeline_id IS '管线id';
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_release.pipeline_name IS '管线名称';
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_release.tube_stock IS '管存';
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_release.pipeline_storage_did IS '管存数据点';
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_release.async_state IS '同步状态（0 未同步 1 同步成功 2 同步失败）';
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_release.async_remark IS '同步备注';
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_release.create_by_id IS '创建人';
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_release.create_by_name IS '创建人名称';
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_release.create_time IS '创建时间';
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_release.modify_by_id IS '修改人';
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_release.modify_by_name IS '修改人名称';
COMMENT ON COLUMN pps_dispatch.disp_ng_tube_storage_cal_release.modify_time IS '修改时间';

--pps_dispatch end